/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s30xx
*                                           Library Function
*
*                                        All Rights Reserved
*
*
* Project      : rx32s30xx
* File         : system_rx32s30xx.h
* By           : RX_SD_Team
* Description  : Only rx32s30xx
*********************************************************************************************************
*/

#ifndef __SYSTERM_rx32s30xx_H
#define __SYSTERM_rx32s30xx_H

#ifdef __cplusplus
 extern "C" {
#endif
#include <stdint.h>
	 
#define FREQ_HSE		((uint32_t)8000000)
#define FREQ_HRC		((uint32_t)10500000)//10.5MHz
#define FREQ_FSYS_Mhz   (84)

#define INFO_HRCADJ_OFFSET    0x140
#define INFO_LRCADJ_OFFSET    0x148
#define INFO_CMP4PADJ_OFFSET  0x218
#define INFO_CMP4NADJ_OFFSET  0x21C
#define INFO_CMP5PADJ_OFFSET  0x220
#define INFO_CMP5NADJ_OFFSET  0x224

#define INFO_HRCADJ_ADR     (INFO_BASE+INFO_HRCADJ_OFFSET)
#define INFO_LRCADJ_ADR     (INFO_BASE+INFO_LRCADJ_OFFSET)
#define INFO_CMP4PADJ_ADR   (INFO_BASE+INFO_CMP4PADJ_OFFSET)
#define INFO_CMP4NADJ_ADR   (INFO_BASE+INFO_CMP4NADJ_OFFSET)
#define INFO_CMP5PADJ_ADR   (INFO_BASE+INFO_CMP5PADJ_OFFSET)
#define INFO_CMP5NADJ_ADR   (INFO_BASE+INFO_CMP5NADJ_OFFSET)
/*
*********************************************************************************************************
*                                           全局宏/结构体
*********************************************************************************************************
*/



/*
*********************************************************************************************************
*                                             全局变量
*********************************************************************************************************
*/

extern uint32_t SystemCoreClock;
extern uint32_t APBClock;

/*
*********************************************************************************************************
*                                            全局函数申明
*********************************************************************************************************
*/

void SystemInit(void);                 /*!< 系统初始化        */




#ifdef __cplusplus
}
#endif

#endif
