/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_adc.h
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  : Only rx32s11xx
*********************************************************************************************************
*/
#ifndef __rx32s11xx_ADC_H__
#define __rx32s11xx_ADC_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"

/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of ADC Module
**********************************************************************************************************
*/
/**********************  Bit definition for SADCCON register of ADC_TypeDef ***********************/
#define  SADC_SADCCON                                       ((uint32_t)0x18075)           /*!< */
#define  SADC_SADCCON_SADCON                                ((uint32_t)0x0001)           /*!< */
#define  SADC_SADCCON_SADC_TRIG_EN                          ((uint32_t)0x0004)           /*!< */
#define  SADC_SADCCON_SADCSCAN                              ((uint32_t)0x0010)           /*!< */
#define  SADC_SADCCON_SADCCONT                              ((uint32_t)0x0020)           /*!< */
#define  SADC_SADCCON_SADCEN                                ((uint32_t)0x8000)           /*!< */
#define  SADC_SADCCON_DISCEN                                ((uint32_t)0x10000)          /*!< */

/**********************  Bit definition for SADCCLKCFG register of ADC_TypeDef ***********************/
#define  SADC_SADCCLKCFG                                    ((uint32_t)0x000f)          
#define  SADC_SADCCLKCFG_SADCCLKDIV                         ((uint32_t)0x000f)    

/**********************  Bit definition for SADCSTR register of ADC_TypeDef ***********************/
#define  SADC_SADCSTR                                       ((uint32_t)0x0001)           /*!< */

/**********************  Bit definition for SADCIE register of ADC_TypeDef ***********************/
#define  SADC_SADCIE                                        ((uint32_t)0x0003)           /*!< */
#define  SADC_SADCIE_SEQIE                                  ((uint32_t)0x0002)           /*!< */
#define  SADC_SADCIE_SIGIE                                  ((uint32_t)0x0001)           /*!< */

/**********************  Bit definition for SADCIF register of ADC_TypeDef ***********************/
#define  SADC_SADCIF                                        ((uint32_t)0x0003)           /*!< */
#define  SADC_SADCIF_SEQIF                                  ((uint32_t)0x0002)           /*!< */
#define  SADC_SADCIF_SIGIF                                  ((uint32_t)0x0001)           /*!< */

/**********************  Bit definition for SADCSAMP register of ADC_TypeDef ***********************/
#define  SADC_SADCSAMP_MASK                                 ((uint32_t)0xffffffff)       /*!< */
#define  SADC_SADCSAMP_CH0_SAMP_MASK                        ((uint32_t)0x0000000f)       /*!< */
#define  SADC_SADCSAMP_CH1_SAMP_MASK                        ((uint32_t)0x000000f0)       /*!< */
#define  SADC_SADCSAMP_CH2_SAMP_MASK                        ((uint32_t)0x00000f00)       /*!< */
#define  SADC_SADCSAMP_CH3_SAMP_MASK                        ((uint32_t)0x0000f000)       /*!< */
#define  SADC_SADCSAMP_CH4_SAMP_MASK                        ((uint32_t)0x000f0000)       /*!< */
#define  SADC_SADCSAMP_CH5_SAMP_MASK                        ((uint32_t)0x00f00000)       /*!< */
#define  SADC_SADCSAMP_CH6_SAMP_MASK                        ((uint32_t)0x0f000000)       /*!< */
#define  SADC_SADCSAMP_CH7_SAMP_MASK                        ((uint32_t)0xf0000000)       /*!< */

/**********************  Bit definition for SADCSAMP2 register of ADC_TypeDef ***********************/
#define  SADC_SADCSAMP2_MASK                                ((uint32_t)0xffffffff)       /*!< */
#define  SADC_SADCSAMP2_CH8_SAMP_MASK                       ((uint32_t)0x0000000f)       /*!< */
#define  SADC_SADCSAMP2_CH9_SAMP_MASK                       ((uint32_t)0x000000f0)       /*!< */
#define  SADC_SADCSAMP2_CH10_SAMP_MASK                      ((uint32_t)0x00000f00)       /*!< */
#define  SADC_SADCSAMP2_CH11_SAMP_MASK                      ((uint32_t)0x0000f000)       /*!< */
#define  SADC_SADCSAMP2_CH12_SAMP_MASK                      ((uint32_t)0x000f0000)       /*!< */
#define  SADC_SADCSAMP2_CH13_SAMP_MASK                      ((uint32_t)0x00f00000)       /*!< */
#define  SADC_SADCSAMP2_CH14_SAMP_MASK                      ((uint32_t)0x0f000000)       /*!< */

/**********************  Bit definition for SADCTRGLEN register of ADC_TypeDef ***********************/
#define  SADC_SADCTRGLEN                                    ((uint32_t)0x073f)           /*!< */
#define  SADC_SADCTRGLEN_ADTRIG                             ((uint32_t)0x000f)           /*!< */
#define  SADC_SADCTRGLEN_CH4_EN                             ((uint32_t)0x0020)           /*!< */
#define  SADC_SADCTRGLEN_CH5_EN                             ((uint32_t)0x0010)           /*!< */
#define  SADC_SADCTRGLEN_SEQLENG                            ((uint32_t)0x0700)           /*!< */

/**********************  Bit definition for SADCSEQCFG register of ADC_TypeDef ***********************/
#define  SADC_SADCSEQCFG_MASK                               ((uint32_t)0xffffffff)       /*!< */
#define  SADC_SADCSEQCFG_SEQ0_SEL_MASK                      ((uint32_t)0x0000000f)       /*!< */
#define  SADC_SADCSEQCFG_SEQ1_SEL_MASK                      ((uint32_t)0x000000f0)       /*!< */
#define  SADC_SADCSEQCFG_SEQ2_SEL_MASK                      ((uint32_t)0x00000f00)       /*!< */
#define  SADC_SADCSEQCFG_SEQ3_SEL_MASK                      ((uint32_t)0x0000f000)       /*!< */
#define  SADC_SADCSEQCFG_SEQ4_SEL_MASK                      ((uint32_t)0x000f0000)       /*!< */
#define  SADC_SADCSEQCFG_SEQ5_SEL_MASK                      ((uint32_t)0x00f00000)       /*!< */
#define  SADC_SADCSEQCFG_SEQ6_SEL_MASK                      ((uint32_t)0x0f000000)       /*!< */
#define  SADC_SADCSEQCFG_SEQ7_SEL_MASK                      ((uint32_t)0xf0000000)       /*!< */

/**********************  Bit definition for SADCDAT register of ADC_TypeDef ***********************/
#define  SADC_SADCDAT                                       ((uint32_t)0xfffff)          /*!< */

/**********************  Bit definition for SADCxDAT register of ADC_TypeDef ***********************/
#define  SADC_SADC0DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC1DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC2DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC3DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC4DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC5DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC6DAT                                      ((uint32_t)0xfffff)          /*!< */
#define  SADC_SADC7DAT                                      ((uint32_t)0xfffff)          /*!< */

/**********************  Bit definition for SADC_CALDATx register of ADC_TypeDef ***********************/
#define  SADC_CALDAT0                                       ((uint32_t)0xffff)           /*!< */
#define  SADC_CALDAT1                                       ((uint32_t)0xffff)           /*!< */
#define  SADC_CALDAT2                                       ((uint32_t)0xffff)           /*!< */
#define  SADC_CALDAT3                                       ((uint32_t)0xffff)           /*!< */

/*
  * @brief  Driver macro reserved for internal use: isolate bits with the
  *         selected mask and shift them to the register LSB
  *         (shift mask on register position bit 0).
  * @param  __BITS__ Bits in register 32 bits
  * @param  __MASK__ Mask in register 32 bits
  * @retval Bits in register 32 bits
 */
#define __ADC_MASK_SHIFT(__BITS__, __MASK__)                                   \
  (((__BITS__) & (__MASK__)) >> POSITION_VAL((__MASK__)))

#define ADC_CONVERTED_DATA_BUFFER_SIZE   ((uint32_t)   8)
   
#define SADC_SADCTPSFL1         (uint32_t)0x00000000 
#define SADC_SADCTPSFL2         (uint32_t)0x00000400 
#define SADC_SADCTPSFL4         (uint32_t)0x00000800 
#define SADC_SADCTPSFL8         (uint32_t)0x00000C00

#define SADC_CONV_SINGLE        (uint32_t)0x00000000 
#define SADC_CONV_CONTINUOUS    (uint32_t)0x00000020 

#define SADC_SADCSCAN_DISABLE   (uint32_t)0x00000000 
#define SADC_SADCSCAN_ENABLE    (uint32_t)0x00000010 

#define SADC_SADCCLK_DIV1       (uint32_t)0x00000000
#define SADC_SADCCLK_DIV2       (uint32_t)0x00000001
#define SADC_SADCCLK_DIV3       (uint32_t)0x00000002
#define SADC_SADCCLK_DIV4       (uint32_t)0x00000003
#define SADC_SADCCLK_DIV5       (uint32_t)0x00000004
#define SADC_SADCCLK_DIV6       (uint32_t)0x00000005
#define SADC_SADCCLK_DIV7       (uint32_t)0x00000006
#define SADC_SADCCLK_DIV8       (uint32_t)0x00000007

#define SADC_SAMPLINGTIME_2CYCLES      (uint32_t)0x00000000
#define SADC_SAMPLINGTIME_4CYCLES      (uint32_t)0x00000001
#define SADC_SAMPLINGTIME_8CYCLES      (uint32_t)0x00000002
#define SADC_SAMPLINGTIME_16CYCLES     (uint32_t)0x00000003
#define SADC_SAMPLINGTIME_32CYCLES     (uint32_t)0x00000004
#define SADC_SAMPLINGTIME_64CYCLES     (uint32_t)0x00000005
#define SADC_SAMPLINGTIME_128CYCLES    (uint32_t)0x00000006
#define SADC_SAMPLINGTIME_256CYCLES    (uint32_t)0x00000007

#define SADC_SEQLENG_1           (uint32_t)0x00000000
#define SADC_SEQLENG_2           (uint32_t)0x00000100
#define SADC_SEQLENG_3           (uint32_t)0x00000200
#define SADC_SEQLENG_4           (uint32_t)0x00000300
#define SADC_SEQLENG_5           (uint32_t)0x00000400
#define SADC_SEQLENG_6           (uint32_t)0x00000500
#define SADC_SEQLENG_7           (uint32_t)0x00000600
#define SADC_SEQLENG_8           (uint32_t)0x00000700

#define SADC_ADTRIG_SADCSTR      (uint32_t)0x00000000
#define SADC_ADTRIG_RTC2         (uint32_t)0x00000001
#define SADC_ADTRIG_INT3         (uint32_t)0x00000002
#define SADC_ADTRIG_INT7         (uint32_t)0x00000003
#define SADC_ADTRIG_TMR0         (uint32_t)0x00000004
#define SADC_ADTRIG_TMR1         (uint32_t)0x00000005
#define SADC_ADTRIG_TIM8_CH4     (uint32_t)0x00000006
#define SADC_ADTRIG_TIM8_CH5     (uint32_t)0x00000007
#define SADC_ADTRIG_TIM8_CH1     (uint32_t)0x00000008
#define SADC_ADTRIG_TIM8_CH2     (uint32_t)0x00000009
#define SADC_ADTRIG_TIM8_CH3     (uint32_t)0x0000000A
#define SADC_ADTRIG_TIM8_CH4_CH5 (uint32_t)0x0000000B

#define SADC_SEQCFG_SEQ0_SEL        (uint32_t)0*4
#define SADC_SEQCFG_SEQ1_SEL        (uint32_t)1*4
#define SADC_SEQCFG_SEQ2_SEL        (uint32_t)2*4
#define SADC_SEQCFG_SEQ3_SEL        (uint32_t)3*4
#define SADC_SEQCFG_SEQ4_SEL        (uint32_t)4*4
#define SADC_SEQCFG_SEQ5_SEL        (uint32_t)5*4
#define SADC_SEQCFG_SEQ6_SEL        (uint32_t)6*4
#define SADC_SEQCFG_SEQ7_SEL        (uint32_t)7*4
#define SADC_SEQ_NUMBER_MASK        (uint32_t)0x0000000F   

#define SADC_CHANNEL0            (uint32_t)0x00000000
#define SADC_CHANNEL1            (uint32_t)0x00000001
#define SADC_CHANNEL2            (uint32_t)0x00000002
#define SADC_CHANNEL3            (uint32_t)0x00000003
#define SADC_CHANNEL4            (uint32_t)0x00000004
#define SADC_CHANNEL5            (uint32_t)0x00000005
#define SADC_CHANNEL6            (uint32_t)0x00000006
#define SADC_CHANNEL7            (uint32_t)0x00000007
#define SADC_CHANNEL8            (uint32_t)0x00000008
#define SADC_CHANNEL9            (uint32_t)0x00000009
#define SADC_CHANNEL10           (uint32_t)0x0000000A
#define SADC_CHANNEL11           (uint32_t)0x0000000B
#define SADC_CHANNEL12           (uint32_t)0x0000000C
#define SADC_CHANNEL13           (uint32_t)0x0000000D
#define SADC_CHANNEL14           (uint32_t)0x0000000E
#define SADC_CHANNELVBG          SADC_CHANNEL11
#define SADC_CHANNELPGA0         SADC_CHANNEL12
#define SADC_CHANNELPGA1         SADC_CHANNEL13
#define SADC_CHANNELPGA2         SADC_CHANNEL14
#define SADC_SAMP_NUMBER_MASK    (uint32_t)0x0000000F  

#define DMA_CHANNEL_0            0x00000000U /*!< DMA Channel 0 */
#define DMA_CHANNEL_1            0x00000001U /*!< DMA Channel 1 */
#define DMA_CHANNEL_2            0x00000002U /*!< DMA Channel 2 */

typedef struct
{
	FunctionalState State;
	uint32_t TriggerSource;
	uint32_t ContMode;
	uint32_t ScanMode;
	uint32_t Prescaler;
	FunctionalState Discen;
} SADC_InitTypeDef;

typedef struct
{
	uint32_t Channel;
	uint32_t SamplingTime;
}RankType;

typedef struct
{
  uint32_t Length;
  RankType Rank[8];
} SADC_RankInitTypeDef;

void SADC_DeInit(SADC_TypeDef* SADCx);
void SADC_StructInit(SADC_InitTypeDef *SADCx);
void SADC_Init(SADC_TypeDef* ADCx,SADC_InitTypeDef* SADC_InitStruct);
void SADC_RankInit(SADC_TypeDef* ADCx,SADC_RankInitTypeDef* SADC_RankInitStruct);
void SADC_Enable(SADC_TypeDef *SADCx);
void SADC_Disable(SADC_TypeDef *SADCx);
void SADC_Enable_SADCON(SADC_TypeDef *SADCx);
void SADC_Disable_SADCON(SADC_TypeDef *SADCx);
uint32_t SADC_Get_SADCON(SADC_TypeDef *SADCx);
void SADC_Enable_TRIG(SADC_TypeDef *SADCx);
void SADC_Disable_TRIG(SADC_TypeDef *SADCx);
void SADC_Set_ScanMode(SADC_TypeDef *SADCx, uint32_t ScanMode);
void SADC_Set_ContMode(SADC_TypeDef *SADCx, uint32_t ContMode);
void SADC_Enable_SADCEN(SADC_TypeDef *SADCx);
void SADC_Disable_SADCEN(SADC_TypeDef *SADCx);
uint32_t SADC_Get_SADCEN(SADC_TypeDef *SADCx);
void SADC_Enable_DISCEN(SADC_TypeDef *SADCx);
void SADC_Disable_DISCEN(SADC_TypeDef *SADCx);
uint32_t SADC_Get_DISCEN(SADC_TypeDef *SADCx);
void SADC_Start(SADC_TypeDef *SADCx);
void SADC_Set_ClkPrescaler(SADC_TypeDef *SADCx, uint32_t Prescaler);
void SADC_Enable_IT(SADC_TypeDef *SADCx,uint32_t IE);
void SADC_Disable_IT(SADC_TypeDef *SADCx,uint32_t IE);
uint32_t SADC_Get_IT(SADC_TypeDef *SADCx,uint32_t IE);
uint32_t SADC_Get_Flag(SADC_TypeDef *SADCx,uint32_t IF);
void SADC_Clear_Flag(SADC_TypeDef *SADCx,uint32_t IF);
void SADC_Set_ChannelSamplingTime(SADC_TypeDef *SADCx, uint32_t Channel, uint32_t SamplingTime);
void SADC_Enable_TRIG_CH4(SADC_TypeDef *SADCx);
void SADC_Disable_TRIG_CH4(SADC_TypeDef *SADCx);
void SADC_Enable_TRIG_CH5(SADC_TypeDef *SADCx);
void SADC_Disable_TRIG_CH5(SADC_TypeDef *SADCx);
void SADC_Set_TriggerSource(SADC_TypeDef *SADCx, uint32_t TriggerSource);
void SADC_Set_SequencerLength(SADC_TypeDef *SADCx, uint32_t Length);
void SADC_Set_SequencerRanks(SADC_TypeDef *SADCx, uint32_t Rank, uint32_t Channel);
uint32_t SADC_Read_SADCDAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC0DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC1DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC2DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC3DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC4DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC5DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC6DAT(SADC_TypeDef *SADCx);
uint32_t SADC_Read_SADC7DAT(SADC_TypeDef *SADCx);
void SADC_Set_CALDAT0(SADC_TypeDef *SADCx, uint32_t offest);
uint32_t SADC_Read_CALDAT0(SADC_TypeDef *SADCx);
void SADC_Set_CALDAT1(SADC_TypeDef *SADCx, uint32_t offest);
uint32_t SADC_Read_CALDAT1(SADC_TypeDef *SADCx);
void SADC_Set_CALDAT2(SADC_TypeDef *SADCx, uint32_t offest);
uint32_t SADC_Read_CALDAT2(SADC_TypeDef *SADCx);
void SADC_Set_CALDAT3(SADC_TypeDef *SADCx, uint32_t offest);
uint32_t SADC_Read_CALDAT3(SADC_TypeDef *SADCx);

#ifdef __cplusplus
}
#endif

#endif /* __rx32s11xx_ADC_H__ */
