/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_flash.h
* By           : RX_SD_Team
* Version      : 20210420
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#ifndef __rx32s11xx_FLASH_H__
#define __rx32s11xx_FLASH_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"

///*
//*********************************************************************************************************
//*                                              Macro definition
//*********************************************************************************************************
//*/
	
#define FLASH_MAX_ADDRESS       (FLASH_BASE+FLASH_SIZE)

void Flash_chip_erase(void);
Bool Flash_page_erase(uint8_t page);
Bool Flash_Wordwrite(uint32_t address,uint32_t pwbuf);
Bool Flash_HalfWordwrite(uint32_t address, uint16_t pwbuf);
Bool Flash_Bytewrite(uint32_t address,uint8_t* pwbuf,uint32_t num);
uint32_t Flash_WordRead( uint32_t Address);
uint16_t Flash_HalfWordRead( uint32_t Address);
void Flash_ByteRead(uint8_t* pReadByte, uint32_t Address, uint32_t Num);

#ifdef __cplusplus
}
#endif

#endif 
