/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_me.h
* By           : RX_SD_Team
* Version      : 20210420
* Description  : Only rx32s11xx
*********************************************************************************************************
*/
#ifndef _rx32s11xx_ME_H
#define _rx32s11xx_ME_H

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"
#include "main.h"

/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of SQRT Module
**********************************************************************************************************
*/
/**********************  Bit definition for CR register of DIV_TypeDef ***********************/
#define  DIV_CR                                 ((uint32_t)0x001f)          
#define  DIV_CR_STR                             ((uint32_t)0x0001)          
#define  DIV_CR_RDY                             ((uint32_t)0x0002)          
#define  DIV_CR_SN                              ((uint32_t)0x0004)           
#define  DIV_CR_DIVF                            ((uint32_t)0x0008)         
#define  DIV_CR_BUSY                            ((uint32_t)0x0010)          

/**********************  Bit definition for DD register of DIV_TypeDef ***********************/
#define  DIV_DD                                 ((uint32_t)0xffffffff)        

/**********************  Bit definition for DI register of DIV_TypeDef ***********************/
#define  DIV_DI                                 ((uint32_t)0xffffffff)        

/**********************  Bit definition for DQ register of DIV_TypeDef ***********************/
#define  DIV_DQ                                 ((uint32_t)0xffffffff)        

/**********************  Bit definition for DR register of DIV_TypeDef ***********************/
#define  DIV_DR                                 ((uint32_t)0xffffffff)        

/**********************  Bit definition for CR register of SQRT_TypeDef ***********************/
#define  SQRT_CR                                 ((uint32_t)0x0006)          
#define  SQRT_CR_RDY                             ((uint32_t)0x0002)         
#define  SQRT_CR_BUSY                            ((uint32_t)0x0004)          

/**********************  Bit definition for DI register of SQRT_TypeDef ***********************/
#define  SQRT_DI                                 ((uint32_t)0xFFFFFFFF)       

/**********************  Bit definition for DO register of SQRT_TypeDef ***********************/
#define  SQRT_DO                                 ((uint32_t)0xFFFF)           

/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of PID Module
**********************************************************************************************************
*/
/**********************  Bit definition for CR register of PID_TypeDef ***********************/
#define  PID_CR                                 ((uint32_t)0x000F)          
#define  PID_CR_STR                             ((uint32_t)0x0001)          
#define  PID_CR_CLR                             ((uint32_t)0x0002)           
#define  PID_CR_RDY                             ((uint32_t)0x0004)           
#define  PID_CR_BUSY                            ((uint32_t)0x0008)         

/**********************  Bit definition for REF register of PID_TypeDef ***********************/
#define  PID_REF                                ((uint32_t)0xFFFF)            

/**********************  Bit definition for FB register of PID_TypeDef ***********************/
#define  PID_FB                                 ((uint32_t)0xFFFF)            

/**********************  Bit definition for OUT register of PID_TypeDef ***********************/
#define  PID_OUT                                ((uint32_t)0xFFFF)            

/**********************  Bit definition for ERR register of PID_TypeDef ***********************/
#define  PID_ERR                                ((uint32_t)0xFFFF)            
 
/**********************  Bit definition for INTG register of PID_TypeDef ***********************/
#define  PID_INTG                               ((uint32_t)0xFFFFFFFF)        

/**********************  Bit definition for KPG register of PID_TypeDef ***********************/
#define  PID_KPG                                ((uint32_t)0xFFFF)            

/**********************  Bit definition for KIG register of PID_TypeDef ***********************/
#define  PID_KIG                                ((uint32_t)0xFFFF)            

/**********************  Bit definition for KDG  register of PID_TypeDef ***********************/
#define  PID_KDG                                ((uint32_t)0xFFFF)            

/**********************  Bit definition for KIMULP register of PID_TypeDef ***********************/
#define  PID_KIMULP                             ((uint32_t)0xFFFF)            

/**********************  Bit definition for PIDDIV register of PID_TypeDef ***********************/
#define  PID_KDIV                               ((uint32_t)0x0FFF)            
#define  PID_KDIV_KPD                           ((uint32_t)0x000F)          
#define  PID_KDIV_KID                           ((uint32_t)0x00F0)          
#define  PID_KDIV_KDD                           ((uint32_t)0x0F00)          

/**********************  Bit definition for INTGLIM register of PID_TypeDef ***********************/
#define  PID_INTGLIM                            ((uint32_t)0xFFFFFFFF)       

/**********************  Bit definition for OUTLIM register of PID_TypeDef ***********************/
#define  PID_OUTLIM                             ((uint32_t)0xFFFF)          

/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of ME Module
**********************************************************************************************************
*/
/**********************  Bit definition for CR register of ME_TypeDef ***********************/
#define  ME_CR                                       ((uint32_t)0x3FFFF)           
#define  ME_CR_CDTR_CH                               ((uint32_t)0x0007)          
#define  ME_CR_CDTR_CH0                              ((uint32_t)0x0000)       
#define  ME_CR_CDTR_CH1                              ((uint32_t)0x0001)       
#define  ME_CR_CDTR_CH2                              ((uint32_t)0x0002)       
#define  ME_CR_CDTR_CH3                              ((uint32_t)0x0003)       
#define  ME_CR_CDTR_CH4                              ((uint32_t)0x0004)       
#define  ME_CR_CDTR_CH5                              ((uint32_t)0x0005)       
#define  ME_CR_CDTR_CH6                              ((uint32_t)0x0006)       
#define  ME_CR_CDTR_CH7                              ((uint32_t)0x0007) 

#define  ME_CR_SMO_CLR                               ((uint32_t)0x0008)           
#define  ME_CR_CDTR_STR                              ((uint32_t)0x0010)           
#define  ME_CR_CDTR_RDY                              ((uint32_t)0x0020)           
#define  ME_CR_IPD_STR                               ((uint32_t)0x0040)           
#define  ME_CR_IPD_RDY                               ((uint32_t)0x0080)           
#define  ME_CR_SMO_STR                               ((uint32_t)0x0100)           
#define  ME_CR_SMO_RDY                               ((uint32_t)0x0200)           
#define  ME_CR_SV_STR                                ((uint32_t)0x0400)           
#define  ME_CR_SV_RDY                                ((uint32_t)0x0800)          
#define  ME_CR_CDTR_BUSY                             ((uint32_t)0x1000)           
#define  ME_CR_IPD_BUSY                              ((uint32_t)0x2000)          
#define  ME_CR_SMO_BUSY                              ((uint32_t)0x4000)           
#define  ME_CR_SV_BUSY                               ((uint32_t)0x8000)         
#define  ME_CR_F4_STR                                ((uint32_t)0x10000)          

#define  ME_READ_CR_SV_FIVE                          ((uint32_t)0x20000) 
#define  ME_CR_SV_FIVE_NoRightShift                  ((uint32_t)0x20000)
#define  ME_CR_SV_FIVE_RightShiftOneBit              ((uint32_t)0x00000)

/**********************  Bit definition for Ia register of ME_TypeDef ***********************/
#define  ME_Ia                                       ((uint32_t)0xFFFF)          

/**********************  Bit definition for Ib register of ME_TypeDef ***********************/
#define  ME_Ib                                       ((uint32_t)0xFFFF)           

/**********************  Bit definition for Ic register of ME_TypeDef ***********************/
#define  ME_Ic                                       ((uint32_t)0xFFFF)          

/**********************  Bit definition for Ialpha register of ME_TypeDef *******************/
#define  ME_Ialpha                                   ((uint32_t)0xFFFF)           

/**********************  Bit definition for Ibeta register of ME_TypeDef ********************/
#define  ME_Ibeta                                    ((uint32_t)0xFFFF)          

/**********************  Bit definition for Iq register of ME_TypeDef ***********************/
#define  ME_Iq                                       ((uint32_t)0xFFFF)          

/**********************  Bit definition for Id register of ME_TypeDef ***********************/
#define  ME_Id                                       ((uint32_t)0xFFFF)           

/**********************  Bit definition for Vq register of ME_TypeDef ***********************/
#define  ME_Vq                                       ((uint32_t)0xFFFF)           

/**********************  Bit definition for Vd register of ME_TypeDef ***********************/
#define  ME_Vd                                       ((uint32_t)0xFFFF)          

/**********************  Bit definition for Valpha register of ME_TypeDef *******************/
#define  ME_Valpha                                   ((uint32_t)0xFFFF)          

/**********************  Bit definition for Vbeta register of ME_TypeDef ********************/
#define  ME_Vbeta                                    ((uint32_t)0xFFFF)           

/**********************  Bit definition for Angle register of ME_TypeDef ********************/
#define  ME_Angle                                    ((uint32_t)0xFFFF)           

/**********************  Bit definition for Cos register of ME_TypeDef ***********************/
#define  ME_Cos                                      ((uint32_t)0xFFFF)          

/**********************  Bit definition for Sin register of ME_TypeDef ***********************/
#define  ME_Sin                                      ((uint32_t)0xFFFF)         

/**********************  Bit definition for IPDSin register of ME_TypeDef ********************/
#define  ME_IPDSin                                   ((uint32_t)0xFFFF)           

/**********************  Bit definition for Kslid register of ME_TypeDef **********************/
#define  ME_Kslid                                    ((uint32_t)0xFFFF)       

/**********************  Bit definition for Kslf register of ME_TypeDef ***********************/
#define  ME_Kslf                                     ((uint32_t)0xFFFF)       

/**********************  Bit definition for KF register of ME_TypeDef *************************/
#define  ME_KF                                       ((uint32_t)0xFFFF)      
/**********************  Bit definition for KG register of ME_TypeDef *************************/
#define  ME_KG                                       ((uint32_t)0xFFFF)      
/**********************  Bit definition for E0 register of ME_TypeDef *************************/
#define  ME_E0                                       ((uint32_t)0xFFFF)       
/**********************  Bit definition for Ealpha register of ME_TypeDef *********************/
#define  ME_Ealpha                                   ((uint32_t)0xFFFFFFFF)      
/**********************  Bit definition for Ebeta register of ME_TypeDef **********************/
#define  ME_Ebeta                                    ((uint32_t)0xFFFFFFFF)       
/**********************  Bit definition for Zalpha register of ME_TypeDef *********************/
#define  ME_Zalpha                                   ((uint32_t)0xFFFFFFFF)       
/**********************  Bit definition for Zbeta register of ME_TypeDef **********************/
#define  ME_Zbeta                                    ((uint32_t)0xFFFFFFFF)       
/**********************  Bit definition for IalphaError register of ME_TypeDef ****************/
#define  ME_IalphaError                              ((uint32_t)0xFFFFFFFF)      
/**********************  Bit definition for IbetaError register of ME_TypeDef *****************/
#define  ME_IbetaError                               ((uint32_t)0xFFFFFFFF)       
/**********************  Bit definition for EstIalpha register of ME_TypeDef ******************/
#define  ME_EstIalpha                                ((uint32_t)0xFFFFFFFF)       
/**********************  Bit definition for EstIbeta register of ME_TypeDef *******************/
#define  ME_EstIbeta                                 ((uint32_t)0xFFFFFFFF)      
/**********************  Bit definition for SMOTheta register of ME_TypeDef *******************/
#define  ME_SMOTheta                                 ((uint32_t)0xFFFF)           
/**********************  Bit definition for SMOIalpha register of ME_TypeDef ******************/
#define  ME_SMOIalpha                                ((uint32_t)0xFFFF)          
/**********************  Bit definition for SMOIbeta register of ME_TypeDef *******************/
#define  ME_SMOIbeta                                 ((uint32_t)0xFFFF)           
/**********************  Bit definition for BEMFA register of ME_TypeDef **********************/
#define  ME_BEMFA                                    ((uint32_t)0xFFFF)       
/**********************  Bit definition for BEMFB register of ME_TypeDef **********************/
#define  ME_BEMFB                                    ((uint32_t)0xFFFF)       

/**********************  Bit definition for IPDTheta register of ME_TypeDef *******************/
#define  ME_IPDTheta                                 ((uint32_t)0xFFFF)           
/**********************  Bit definition for SVZone register of ME_TypeDef *********************/
#define  ME_SVZone                                   ((uint32_t)0x00FF)          
/**********************  Bit definition for FOVM register of ME_TypeDef ***********************/
#define  ME_FOVM                                     ((uint32_t)0xFFFF)           
/**********************  Bit definition for TPWM register of ME_TypeDef ***********************/
#define  ME_TPWM                                     ((uint32_t)0xFFFF)          
/**********************  Bit definition for LSMIN register of ME_TypeDef **********************/
#define  ME_LSMIN                                    ((uint32_t)0xFFFF)          

/**********************  Bit definition for PDCH1 register of ME_TypeDef **********************/
#define  ME_PDCH1                                    ((uint32_t)0xFFFFFFFF)     
/**********************  Bit definition for PDCH2 register of ME_TypeDef **********************/
#define  ME_PDCH2                                    ((uint32_t)0xFFFFFFFF)      
/**********************  Bit definition for PDCH3 register of ME_TypeDef **********************/
#define  ME_PDCH3                                    ((uint32_t)0xFFFFFFFF)      
/**********************  Bit definition for IER register of ME_TypeDef ************************/
#define  ME_IER                                      ((uint32_t)0x1f71)         
#define  ME_IER_DIVFE                                ((uint32_t)0x0001)         
#define  ME_IER_PID1E                                ((uint32_t)0x0010)          
#define  ME_IER_PID2E                                ((uint32_t)0x0020)          
#define  ME_IER_PID3E                                ((uint32_t)0x0040)           
#define  ME_IER_CDTRE                                ((uint32_t)0x0100)           
#define  ME_IER_IPDE                                 ((uint32_t)0x0200)         
#define  ME_IER_SMOE                                 ((uint32_t)0x0400)          
#define  ME_IER_SVE                                  ((uint32_t)0x0800)         
#define  ME_IER_F4E                                  ((uint32_t)0x1000)         

/**********************  Bit definition for IER register of ME_TypeDef ***********************/
#define  ME_IFR                                      ((uint32_t)0x1f71)         
#define  ME_IFR_DIVFF                                ((uint32_t)0x0001)          
#define  ME_IFR_PID1F                                ((uint32_t)0x0010)          
#define  ME_IFR_PID2F                                ((uint32_t)0x0020)          
#define  ME_IFR_PID3F                                ((uint32_t)0x0040)           
#define  ME_IFR_CDTRF                                ((uint32_t)0x0100)        
#define  ME_IFR_IPDF                                 ((uint32_t)0x0200)      
#define  ME_IFR_SMOF                                 ((uint32_t)0x0400)    
#define  ME_IFR_SVF                                  ((uint32_t)0x0800)        
#define  ME_IFR_F4F                                  ((uint32_t)0x1000)        

void ME_DeInit(ME_TypeDef* MEx);
uint16_t ME_SQRT(uint32_t m);

void ME_Config_IT(ME_TypeDef *MEx,uint16_t ME_IT, FunctionalState NewState);
uint32_t ME_Get_ITStatus(ME_TypeDef *MEx,uint16_t ITEn);
uint32_t ME_Get_IFStatus(ME_TypeDef *MEx,uint32_t IFlag);
void ME_Clear_IF(ME_TypeDef *MEx,uint32_t IFlag);

void ME_SET_FIVE( ME_TypeDef *MEx,uint16_t ME_FIVE );
void ME_SET_STR(ME_TypeDef *MEx,uint16_t ME_STR);
uint32_t ME_Get_RDYStatus(ME_TypeDef *MEx,uint32_t RDY);
void ME_CLEAR_RDY(ME_TypeDef *MEx,uint32_t RDY);
uint32_t ME_Get_BUSYStatus(ME_TypeDef *MEx,uint32_t BUSY);

void ME_SELECT_CDTRCH(ME_TypeDef *MEx,uint32_t Channel);
void ME_CLR_SMO(ME_TypeDef *MEx);

uint32_t ME_IsRDY_SQRT(SQRT_TypeDef *SQRTx);
void ME_CLEAR_RDY_SQRT(SQRT_TypeDef *SQRTx);

void ME_STR_PID(PID_TypeDef *PIDx);
void ME_CLR_PID(PID_TypeDef *PIDx);
uint32_t ME_IsRDY_PID(PID_TypeDef *PIDx);
void ME_CLEAR_RDY_PID(PID_TypeDef *PIDx);

void ME_Write_Ia(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ia(ME_TypeDef *MEx);
void ME_Write_Ib(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ib(ME_TypeDef *MEx);
void ME_Write_Ic(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ic(ME_TypeDef *MEx);
void ME_Write_Ialpha(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ialpha(ME_TypeDef *MEx);
void ME_Write_Ibeta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ibeta(ME_TypeDef *MEx);
void ME_Write_Iq(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Iq(ME_TypeDef *MEx);
void ME_Write_Id(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Id(ME_TypeDef *MEx);
void ME_Write_Vq(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Vq(ME_TypeDef *MEx);
void ME_Write_Vd(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Vd(ME_TypeDef *MEx);
void ME_Write_Valpha(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Valpha(ME_TypeDef *MEx);
void ME_Write_Vbeta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Vbeta(ME_TypeDef *MEx);
void ME_Write_Angle(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Angle(ME_TypeDef *MEx);
uint32_t ME_Read_Cos(ME_TypeDef *MEx);
uint32_t ME_Read_Sin(ME_TypeDef *MEx);
uint32_t ME_Read_IPDSin(ME_TypeDef *MEx);
void ME_Write_Kslid(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Kslid(ME_TypeDef *MEx);
void ME_Write_Kslf(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Kslf(ME_TypeDef *MEx);
void ME_Write_KF(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_KF(ME_TypeDef *MEx);
void ME_Write_KG(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_KG(ME_TypeDef *MEx);
void ME_Write_E0(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_E0(ME_TypeDef *MEx);
void ME_Write_Ealpha(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ealpha(ME_TypeDef *MEx);
void ME_Write_Ebeta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Ebeta(ME_TypeDef *MEx);
void ME_Write_Zalpha(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Zalpha(ME_TypeDef *MEx);
void ME_Write_Zbeta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_Zbeta(ME_TypeDef *MEx);
void ME_Write_IalphaError(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_IalphaError(ME_TypeDef *MEx);
void ME_Write_IbetaError(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_IbetaError(ME_TypeDef *MEx);
void ME_Write_EstIalpha(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_EstIalpha(ME_TypeDef *MEx);
void ME_Write_EstIbeta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_EstIbeta(ME_TypeDef *MEx);
void ME_Write_SMOTheta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_SMOTheta(ME_TypeDef *MEx);
void ME_Write_SMOIalpha(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_SMOIalpha(ME_TypeDef *MEx);
void ME_Write_SMOIbeta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_SMOIbeta(ME_TypeDef *MEx);
void ME_Write_BEMFA(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_BEMFA(ME_TypeDef *MEx);
void ME_Write_BEMFB(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_BEMFB(ME_TypeDef *MEx);
void ME_Write_IPDTheta(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_IPDTheta(ME_TypeDef *MEx);
void ME_Write_SVZone(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_SVZone(ME_TypeDef *MEx);
void ME_Write_FOVM(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_FOVM(ME_TypeDef *MEx);
void ME_Write_TPWM(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_TPWM(ME_TypeDef *MEx);
void ME_Write_LSMIN(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_LSMIN(ME_TypeDef *MEx);
void ME_Write_PDCH1(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_PDCH1(ME_TypeDef *MEx);
void ME_Write_PDCH2(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_PDCH2(ME_TypeDef *MEx);
void ME_Write_PDCH3(ME_TypeDef *MEx, uint32_t value);
uint32_t ME_Read_PDCH3(ME_TypeDef *MEx);

void ME_Write_PID_REF(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_REF(PID_TypeDef *PIDx);
void ME_Write_PID_FB(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_FB(PID_TypeDef *PIDx);
uint32_t ME_Read_PID_OUT(PID_TypeDef *PIDx);
uint32_t ME_Read_PID_ERR(PID_TypeDef *PIDx);
uint32_t ME_Read_PID_INTG(PID_TypeDef *PIDx);
void ME_Write_PID_KPG(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_KPG(PID_TypeDef *PIDx);
void ME_Write_PID_KIG(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_KIG(PID_TypeDef *PIDx);
void ME_Write_PID_KDG(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_KDG(PID_TypeDef *PIDx);
void ME_Write_PID_KIMULP(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_KIMULP(PID_TypeDef *PIDx);
void ME_Write_PID_KDIV(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_KDIV(PID_TypeDef *PIDx);
void ME_Write_PID_KDIV_KPD(PID_TypeDef *PIDx, uint32_t value);
void ME_Write_PID_KDIV_KID(PID_TypeDef *PIDx, uint32_t value);
void ME_Write_PID_KDIV_KDD(PID_TypeDef *PIDx, uint32_t value);
void ME_Write_PID_INTGLIM(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_INTGLIM(PID_TypeDef *PIDx);
void ME_Write_PID_OUTLIM(PID_TypeDef *PIDx, uint32_t value);
uint32_t ME_Read_PID_OUTLIM(PID_TypeDef *PIDx);

void ME_Write_SQDI(SQRT_TypeDef *SQRTx, uint32_t value);
uint32_t ME_Read_SQRT_DI(SQRT_TypeDef *SQRTx);
uint32_t ME_Read_SQRT_DO(SQRT_TypeDef *SQRTx);

uint32_t ME_SDIV_DQ(int32_t m,int32_t n);
uint32_t ME_SDIV_DR(int32_t m,int32_t n);
uint32_t ME_UDIV_DQ(uint32_t m,uint32_t n);
uint32_t ME_UDIV_DR(uint32_t m,uint32_t n);

void ME_Write_DIV_DD(DIV_TypeDef *DIVx, uint32_t value);
uint32_t ME_Read_DIV_DD(DIV_TypeDef *DIVx);
void ME_Write_DIV_DI(DIV_TypeDef *DIVx, uint32_t value);
uint32_t ME_Read_DIV_DI(DIV_TypeDef *DIVx);
uint32_t ME_Read_DIV_DQ(DIV_TypeDef *DIVx);
uint32_t ME_Read_DIV_DR(DIV_TypeDef *DIVx);

void ME_STR_DIV(DIV_TypeDef *DIVx);
void ME_SET_DIVSN(DIV_TypeDef *DIVx);
void ME_SET_DIVUSN(DIV_TypeDef *DIVx);
uint32_t ME_IsERR_DIV(DIV_TypeDef *DIVx);
void ME_CLEAR_ERR_DIV(DIV_TypeDef *DIVx);
uint32_t ME_IsRDY_DIV(DIV_TypeDef *DIVx);
void ME_CLEAR_RDY_DIV(DIV_TypeDef *DIVx);  


#ifdef __cplusplus
}
#endif

#endif /* __rx32s11xx_ME_H__ */

