/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_pga.h
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/
#ifndef __rx32s11xx_PGA_H__
#define __rx32s11xx_PGA_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"

/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of PGA Module
**********************************************************************************************************
*/
	
typedef struct
{	                                      
	FunctionalState PGA0_EN; 		
	uint32_t PGA0_GAIN;                 
	
	FunctionalState PGA1_EN;                 
	uint32_t PGA1_GAIN;                
	
	FunctionalState PGA2_EN;                 
	uint32_t PGA2_GAIN;                
                                      
} PGA_InitTypeDef;
/**********************  Bit definition for CR register of PGA_TypeDef ***********************/       
#define  PGA_CR_PGA0EN                   ((uint32_t)0x0001)
#define  PGA_CR_PGA1EN                   ((uint32_t)0x0010)
#define  PGA_CR_PGA2EN                   ((uint32_t)0x0100)

#define  PGA_CR_PGA0GAIN                 ((uint32_t)0x0006)           
#define  PGA_CR_PGA0GAIN_2X              ((uint32_t)0x0000)  /*!<2X  */
#define  PGA_CR_PGA0GAIN_4X              ((uint32_t)0x0002)  /*!<4X  */
#define  PGA_CR_PGA0GAIN_8X              ((uint32_t)0x0004)  /*!<8X  */

#define  PGA_CR_PGA1GAIN                 ((uint32_t)0x0060)           
#define  PGA_CR_PGA1GAIN_2X              ((uint32_t)0x0000)  /*!<2X  */
#define  PGA_CR_PGA1GAIN_4X              ((uint32_t)0x0020)  /*!<4X  */
#define  PGA_CR_PGA1GAIN_8X              ((uint32_t)0x0040)  /*!<8X  */

#define  PGA_CR_PGA2GAIN                 ((uint32_t)0x0600)           
#define  PGA_CR_PGA2GAIN_2X              ((uint32_t)0x0000)  /*!<2X  */
#define  PGA_CR_PGA2GAIN_4X              ((uint32_t)0x0200)  /*!<4X  */
#define  PGA_CR_PGA2GAIN_8X              ((uint32_t)0x0400)  /*!<8X  */

/**********************  Bit definition for CR2 register of PGA_TypeDef ***********************/
#define  PGA_CR2_TEST                    ((uint32_t)0x0003)  /*!< PGA TEST */
#define  PGA_CR2_TEST_Normal             ((uint32_t)0x0000)  /*!< Normal */
#define  PGA_CR2_TEST_PGA0               ((uint32_t)0x0001)  /*!< PGA0 TEST */
#define  PGA_CR2_TEST_PGA1               ((uint32_t)0x0002)  /*!< PGA1 TEST */
#define  PGA_CR2_TEST_PGA2               ((uint32_t)0x0003)  /*!< PGA2 TEST */


void PGA_DeInit(PGA_TypeDef* PGAx);
void PGA_StructInit(PGA_InitTypeDef *PGA_InitStruct);
void PGA_Init(PGA_TypeDef *PGAx, PGA_InitTypeDef *PGA_InitStruct);
void PGA_Enable(uint32_t val);
void PGA_Disable(uint32_t val);
void PGA_Set_GAIN(uint32_t PGAx,uint32_t val);
void PGA_Set_TEST(uint32_t val);


#ifdef __cplusplus
}
#endif

#endif
