/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_reset.h
* By           : RX_SD
* Version      : 20210420
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#ifndef __rx32s11xx_RESET_H__
#define __rx32s11xx_RESET_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"

/*
* @brief  PMU_RESET_FLAG
*/
#define PMU_RSTSTA_PORRST                ((uint32_t)(0x0001<<0))
#define PMU_RSTSTA_LBORRST               ((uint32_t)(0x0001<<1))
#define PMU_RSTSTA_WDTRST                ((uint32_t)(0x0001<<2))
#define PMU_RSTSTA_WakeupRST             ((uint32_t)(0x0001<<3))
#define PMU_RSTSTA_ExtRST                ((uint32_t)(0x0001<<5))
#define PMU_RSTSTA_SoftRST               ((uint32_t)(0x0001<<6))
#define PMU_RSTSTA_DebugRST              ((uint32_t)(0x0001<<7))
#define PMU_RSTSTA_StopFlag              ((uint32_t)(0x0001<<13))
#define PMU_RSTSTA_SleepFlag             ((uint32_t)(0x0001<<14))
#define PMU_RSTSTA_HoldFlag              ((uint32_t)(0x0001<<15))

uint32_t PMU_Get_ResetFlag(uint32_t resetflag);
void PMU_Clear_ResetFlag(uint32_t resetflag);
	
#ifdef __cplusplus
}
#endif

#endif /* __rx32s11xx_RESET_H__ */	
