/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_rtc.h
* By           : RX_SD_Team
* Version      : 20210420
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#ifndef __rx32s11xx_RTC_H__
#define __rx32s11xx_RTC_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"

/*
**********************************************************************************************************
*                          Peripheral Registers_Bits_Definition of RTC Module
**********************************************************************************************************
*/
/*************************  Bit definition for RTCCON register of RTC_TypeDef *************************/
#define RTC_RTCCON                     ((uint32_t)0x0040)           /* RTC control register */
#define RTC_RTCCON_RTC2EN              ((uint32_t)0x0040)           /* RTC tim2 enable bit */
 
/*************************  Bit definition for RTCIE register of RTC_TypeDef *************************/
#define RTC_RTCIE                      ((uint32_t)0x0040)           /* RTC interrupt Enable register */
#define RTC_RTCIE_RTC2IE               ((uint32_t)0x0040)           /* RTC tim2 interrupt Enable bit */

/*************************  Bit definition for RTCIF register of RTC_TypeDef *************************/
#define RTC_RTCIF                      ((uint32_t)0x0040)           /* RTC interrupt flag register */
#define RTC_RTCIF_RTC2IF               ((uint32_t)0x0040)           /* RTC tim2 interrupt flag bit */

/*************************  Bit definition for RTCIF register of RTC_TypeDef *************************/
#define RTC_RTCTMR2                    ((uint32_t)0xFFFF)           /* RTC tim2 register */
#define RTC_RTCTMR2_CNT                ((uint32_t)0xFFFF)           /* RTC tim2 count bit */

void RTC_DeInit(RTC_TypeDef* RTCx);
void RTC_Enable_TMR2EN(RTC_TypeDef *RTCx);
void RTC_Disable_TMR2EN(RTC_TypeDef *RTCx);

void RTC_Enable_IT(RTC_TypeDef *RTCx,uint32_t IE);
void RTC_Disable_IT(RTC_TypeDef *RTCx,uint32_t IE);
uint32_t RTC_Get_IT(RTC_TypeDef *RTCx,uint32_t IE);

void RTC_Clear_FLAG(RTC_TypeDef *RTCx,uint32_t IF);
uint32_t RTC_Get_FLAG(RTC_TypeDef *RTCx,uint32_t IF);

void RTC_Set_TMR2(RTC_TypeDef *RTCx,uint16_t Count);

#ifdef __cplusplus
}
#endif

#endif /* __rx32s11xx_RTC_H__ */
