/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_tim8.h
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/
#ifndef _rx32s11xx_TIM8_H
#define _rx32s11xx_TIM8_H

#ifdef __cplusplus
extern "C" {
#endif
	
#include "rx32s11xx.h"

	/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of TIM8 Module
**********************************************************************************************************
*/
/**********************  Bit definition for CR1 register of TIM_TypeDef ***********************/
#define  TIM_CR1_CEN                                           ((uint32_t)0x0001)          
#define  TIM_CR1_UDIS                                          ((uint32_t)0x0002)           
#define  TIM_CR1_URS                                           ((uint32_t)0x0004)           
#define  TIM_CR1_OPM                                           ((uint32_t)0x0008)         
#define  TIM_CR1_DIR                                           ((uint32_t)0x0010)         

#define  TIM_CR1_CMS                                           ((uint32_t)0x0060)        
#define  TIM_CR1_CMS_0                                         ((uint32_t)0x0000)        
#define  TIM_CR1_CMS_1                                         ((uint32_t)0x0020)         
#define  TIM_CR1_CMS_2                                         ((uint32_t)0x0040)          
#define  TIM_CR1_CMS_3                                         ((uint32_t)0x0060)           

#define  TIM_CR1_APRE                                          ((uint32_t)0x0080)          

#define  TIM_CR1_CKD                                           ((uint32_t)0x0300)          
#define  TIM_CR1_CKD_0                                         ((uint32_t)0x0000)        
#define  TIM_CR1_CKD_1                                         ((uint32_t)0x0100)         
#define  TIM_CR1_CKD_2                                         ((uint32_t)0x0200)          
#define  TIM_CR1_CKD_3                                         ((uint32_t)0x0300)          

/**********************  Bit definition for CR2 register of TIM_TypeDef ***********************/
#define  TIM_CR2_CCPC                                          ((uint32_t)0x0001)          
#define  TIM_CR2_CCUS                                          ((uint32_t)0x0004)                         

#define  TIM_CR2_TI1S                                          ((uint32_t)0x00080)         
#define  TIM_CR2_OIS1                                          ((uint32_t)0x00100)          
#define  TIM_CR2_OIS1N                                         ((uint32_t)0x00200)          
#define  TIM_CR2_OIS2                                          ((uint32_t)0x00400)         
#define  TIM_CR2_OIS2N                                         ((uint32_t)0x00800)         
#define  TIM_CR2_OIS3                                          ((uint32_t)0x01000)           
#define  TIM_CR2_OIS3N                                         ((uint32_t)0x02000)           
#define  TIM_CR2_OIS4                                          ((uint32_t)0x04000)          
#define  TIM_CR2_OIS5                                          ((uint32_t)0x08000)  
#define  TIM_CR2_OIS6                                          ((uint32_t)0x10000) 

/**********************  Bit definition for SMCR register of TIM_TypeDef ***********************/
#define  TIM_SMCR_SMS                                          ((uint32_t)0x0007)          
#define  TIM_SMCR_SMS_0                                        ((uint32_t)0x0000)          
#define  TIM_SMCR_SMS_1                                        ((uint32_t)0x0001)          
#define  TIM_SMCR_SMS_2                                        ((uint32_t)0x0002)          
#define  TIM_SMCR_SMS_3                                        ((uint32_t)0x0003)          
#define  TIM_SMCR_SMS_4                                        ((uint32_t)0x0004)         
#define  TIM_SMCR_SMS_5                                        ((uint32_t)0x0005)        
#define  TIM_SMCR_SMS_6                                        ((uint32_t)0x0006)         
#define  TIM_SMCR_SMS_7                                        ((uint32_t)0x0007)          

#define  TIM_SMCR_TS                                           ((uint32_t)0x0070)          
#define  TIM_SMCR_TS_0                                         ((uint32_t)0x0000)       
#define  TIM_SMCR_TS_1                                         ((uint32_t)0x0001)         
#define  TIM_SMCR_TS_2                                         ((uint32_t)0x0002)          
#define  TIM_SMCR_TS_3                                         ((uint32_t)0x0003)          
#define  TIM_SMCR_TS_4                                         ((uint32_t)0x0004)          
#define  TIM_SMCR_TS_5                                         ((uint32_t)0x0005)         
#define  TIM_SMCR_TS_6                                         ((uint32_t)0x0006)          
#define  TIM_SMCR_TS_7                                         ((uint32_t)0x0007)         

#define  TIM_SMCR_MSM                                          ((uint32_t)0x0080)         

#define  TIM_SMCR_ETF                                          ((uint32_t)0x0F00)          

#define  TIM_SMCR_ETPS                                         ((uint32_t)0x3000)         
#define  TIM_SMCR_ETPS_0                                       ((uint32_t)0x0000)        
#define  TIM_SMCR_ETPS_1                                       ((uint32_t)0x1000)       
#define  TIM_SMCR_ETPS_2                                       ((uint32_t)0x2000)          
#define  TIM_SMCR_ETPS_3                                       ((uint32_t)0x3000)          


#define  TIM_SMCR_ECE                                          ((uint32_t)0x4000)          
#define  TIM_SMCR_ETP                                          ((uint32_t)0x8000)           

/**********************  Bit definition for DIER register of TIM_TypeDef ***********************/
#define  TIM_DIER_UIE                                          ((uint32_t)0x00001)         
#define  TIM_DIER_CC1IE                                        ((uint32_t)0x00002)          
#define  TIM_DIER_CC2IE                                        ((uint32_t)0x00004)          
#define  TIM_DIER_CC3IE                                        ((uint32_t)0x00008)           
#define  TIM_DIER_CC4IE                                        ((uint32_t)0x00010)          
#define  TIM_DIER_COMIE                                        ((uint32_t)0x00020)          
#define  TIM_DIER_TIE                                          ((uint32_t)0x00040)         
#define  TIM_DIER_BIE                                          ((uint32_t)0x00080)                                 
#define  TIM_DIER_CC5IE                                        ((uint32_t)0x08000)          
#define  TIM_DIER_CC6IE                                        ((uint32_t)0x20000)        

/**********************  Bit definition for SR register of TIM_TypeDef ***********************/
#define  TIM_SR_UIF                                            ((uint32_t)0x0001)          
#define  TIM_SR_CC1IF                                          ((uint32_t)0x0002)          
#define  TIM_SR_CC2IF                                          ((uint32_t)0x0004)           
#define  TIM_SR_CC3IF                                          ((uint32_t)0x0008)         
#define  TIM_SR_CC4IF                                          ((uint32_t)0x0010)           
#define  TIM_SR_COMIF                                          ((uint32_t)0x0020)          
#define  TIM_SR_TIF                                            ((uint32_t)0x0040)          
#define  TIM_SR_BIF                                            ((uint32_t)0x0080)          

#define  TIM_SR_CC1OF                                          ((uint32_t)0x0200)
#define  TIM_SR_CC2OF                                          ((uint32_t)0x0400)
#define  TIM_SR_CC3OF                                          ((uint32_t)0x0800)
#define  TIM_SR_CC4OF                                          ((uint32_t)0x1000)
#define  TIM_SR_CC5OF                                          ((uint32_t)0x2000)
#define  TIM_SR_CC5IF                                          ((uint32_t)0x4000) 
#define  TIM_SR_CC6IF                                          ((uint32_t)0x8000)	

/**********************  Bit definition for EGR register of TIM_TypeDef ***********************/
#define  TIM_EGR_UG                                            ((uint32_t)0x0001)          
#define  TIM_EGR_CC1G                                          ((uint32_t)0x0002)          
#define  TIM_EGR_CC2G                                          ((uint32_t)0x0004)          
#define  TIM_EGR_CC3G                                          ((uint32_t)0x0008)           
#define  TIM_EGR_CC4G                                          ((uint32_t)0x0010)           
#define  TIM_EGR_COMG                                          ((uint32_t)0x0020)          
#define  TIM_EGR_TG                                            ((uint32_t)0x0040)          
#define  TIM_EGR_BG                                            ((uint32_t)0x0080)          
#define  TIM_EGR_CC5G                                          ((uint32_t)0x0100)
#define  TIM_EGR_CC6G                                          ((uint32_t)0x0200) 

/**********************  Bit definition for CCMR1 register of TIM_TypeDef ***********************/
#define  TIM_CCMR1_CC1S                                        ((uint32_t)0x0003)           
#define  TIM_CCMR1_CC1S_0                                      ((uint32_t)0x0000)           
#define  TIM_CCMR1_CC1S_1                                      ((uint32_t)0x0001)           
#define  TIM_CCMR1_CC1S_2                                      ((uint32_t)0x0002)           
#define  TIM_CCMR1_CC1S_3                                      ((uint32_t)0x0003)           

#define  TIM_CCMR1_OC1FE                                       ((uint32_t)0x0004)           
#define  TIM_CCMR1_OC1PE                                       ((uint32_t)0x0008)          

#define  TIM_CCMR1_OC1M                                        ((uint32_t)0x0070)           

#define  TIM_CCMR1_OC1CE                                       ((uint32_t)0x0080)          

#define  TIM_CCMR1_CC2S                                        ((uint32_t)0x0300)           

#define  TIM_CCMR1_OC2FE                                       ((uint32_t)0x0400)          

#define  TIM_CCMR1_OC2PE                                       ((uint32_t)0x0800)           

#define  TIM_CCMR1_OC2M                                        ((uint32_t)0x7000)          

#define  TIM_CCMR1_OC2CE                                       ((uint32_t)0x8000)          

/*----------------------------------------------------------------------------*/

#define  TIM_CCMR1_IC1PSC                                      ((uint16_t)0x000C)            /*!< IC1PSC[1:0] bits (Input Capture 1 Prescaler) */
#define  TIM_CCMR1_IC1PSC_0                                    ((uint16_t)0x0004)            /*!< Bit 0 */
#define  TIM_CCMR1_IC1PSC_1                                    ((uint16_t)0x0008)            /*!< Bit 1 */

#define  TIM_CCMR1_IC1F                                        ((uint16_t)0x00F0)            /*!< IC1F[3:0] bits (Input Capture 1 Filter) */
#define  TIM_CCMR1_IC1F_0                                      ((uint16_t)0x0010)            /*!< Bit 0 */
#define  TIM_CCMR1_IC1F_1                                      ((uint16_t)0x0020)            /*!< Bit 1 */
#define  TIM_CCMR1_IC1F_2                                      ((uint16_t)0x0040)            /*!< Bit 2 */
#define  TIM_CCMR1_IC1F_3                                      ((uint16_t)0x0080)            /*!< Bit 3 */

#define  TIM_CCMR1_IC2PSC                                      ((uint16_t)0x0C00)            /*!< IC2PSC[1:0] bits (Input Capture 2 Prescaler) */
#define  TIM_CCMR1_IC2PSC_0                                    ((uint16_t)0x0400)            /*!< Bit 0 */
#define  TIM_CCMR1_IC2PSC_1                                    ((uint16_t)0x0800)            /*!< Bit 1 */

#define  TIM_CCMR1_IC2F                                        ((uint16_t)0xF000)            /*!< IC2F[3:0] bits (Input Capture 2 Filter) */
#define  TIM_CCMR1_IC2F_0                                      ((uint16_t)0x1000)            /*!< Bit 0 */
#define  TIM_CCMR1_IC2F_1                                      ((uint16_t)0x2000)            /*!< Bit 1 */
#define  TIM_CCMR1_IC2F_2                                      ((uint16_t)0x4000)            /*!< Bit 2 */
#define  TIM_CCMR1_IC2F_3                                      ((uint16_t)0x8000)            /*!< Bit 3 */
/**********************  Bit definition for CCMR2 register of TIM_TypeDef ***********************/
#define  TIM_CCMR2_CC3S                                        ((uint32_t)0x0003)           
#define  TIM_CCMR2_CC3S_0                                      ((uint32_t)0x0000)           
#define  TIM_CCMR2_CC3S_1                                      ((uint32_t)0x0001)           
#define  TIM_CCMR2_CC3S_2                                      ((uint32_t)0x0002)         
#define  TIM_CCMR2_CC3S_3                                      ((uint32_t)0x0003)          

#define  TIM_CCMR2_OC3FE                                       ((uint32_t)0x0004)          
#define  TIM_CCMR2_OC3PE                                       ((uint32_t)0x0008)         

#define  TIM_CCMR2_OC3M                                        ((uint32_t)0x0070)           

#define  TIM_CCMR2_OC3CE                                       ((uint32_t)0x0800)          

#define  TIM_CCMR2_CC4S                                        ((uint32_t)0x0300)          

#define  TIM_CCMR2_OC4FE                                       ((uint32_t)0x0400)          

#define  TIM_CCMR2_OC4PE                                       ((uint32_t)0x0800)          

#define  TIM_CCMR2_OC4M                                        ((uint32_t)0x7000)          

#define  TIM_CCMR2_OC4CE                                       ((uint32_t)0x8000)         

/*----------------------------------------------------------------------------*/

#define  TIM_CCMR2_IC3PSC                                      ((uint16_t)0x000C)            /*!< IC3PSC[1:0] bits (Input Capture 3 Prescaler) */
#define  TIM_CCMR2_IC3PSC_0                                    ((uint16_t)0x0004)            /*!< Bit 0 */
#define  TIM_CCMR2_IC3PSC_1                                    ((uint16_t)0x0008)            /*!< Bit 1 */

#define  TIM_CCMR2_IC3F                                        ((uint16_t)0x00F0)            /*!< IC3F[3:0] bits (Input Capture 3 Filter) */
#define  TIM_CCMR2_IC3F_0                                      ((uint16_t)0x0010)            /*!< Bit 0 */
#define  TIM_CCMR2_IC3F_1                                      ((uint16_t)0x0020)            /*!< Bit 1 */
#define  TIM_CCMR2_IC3F_2                                      ((uint16_t)0x0040)            /*!< Bit 2 */
#define  TIM_CCMR2_IC3F_3                                      ((uint16_t)0x0080)            /*!< Bit 3 */

#define  TIM_CCMR2_IC4PSC                                      ((uint16_t)0x0C00)            /*!< IC4PSC[1:0] bits (Input Capture 4 Prescaler) */
#define  TIM_CCMR2_IC4PSC_0                                    ((uint16_t)0x0400)            /*!< Bit 0 */
#define  TIM_CCMR2_IC4PSC_1                                    ((uint16_t)0x0800)            /*!< Bit 1 */

#define  TIM_CCMR2_IC4F                                        ((uint16_t)0xF000)            /*!< IC4F[3:0] bits (Input Capture 4 Filter) */
#define  TIM_CCMR2_IC4F_0                                      ((uint16_t)0x1000)            /*!< Bit 0 */
#define  TIM_CCMR2_IC4F_1                                      ((uint16_t)0x2000)            /*!< Bit 1 */
#define  TIM_CCMR2_IC4F_2                                      ((uint16_t)0x4000)            /*!< Bit 2 */
#define  TIM_CCMR2_IC4F_3                                      ((uint16_t)0x8000)            /*!< Bit 3 */
/**********************  Bit definition for CCER register of TIM_TypeDef ***********************/
#define  TIM_CCER_CC1E                                         ((uint32_t)0x00001)          
#define  TIM_CCER_CC1P                                         ((uint32_t)0x00002)           
#define  TIM_CCER_CC1NE                                        ((uint32_t)0x00004)          
#define  TIM_CCER_CC1NP                                        ((uint32_t)0x00008)          
#define  TIM_CCER_CC2E                                         ((uint32_t)0x00010)          
#define  TIM_CCER_CC2P                                         ((uint32_t)0x00020)          
#define  TIM_CCER_CC2NE                                        ((uint32_t)0x00040)          
#define  TIM_CCER_CC2NP                                        ((uint32_t)0x00080)          
#define  TIM_CCER_CC3E                                         ((uint32_t)0x00100)          
#define  TIM_CCER_CC3P                                         ((uint32_t)0x00200)          
#define  TIM_CCER_CC3NE                                        ((uint32_t)0x00400)         
#define  TIM_CCER_CC3NP                                        ((uint32_t)0x00800)          
#define  TIM_CCER_CC4E                                         ((uint32_t)0x01000)         
#define  TIM_CCER_CC4P                                         ((uint32_t)0x02000)          
#define  TIM_CCER_CC5E                                         ((uint32_t)0x04000)          
#define  TIM_CCER_CC5P                                         ((uint32_t)0x08000)  
#define  TIM_CCER_CC6E                                         ((uint32_t)0x10000)          
#define  TIM_CCER_CC6P                                         ((uint32_t)0x20000)          

/**********************  Bit definition for CNT register of TIM_TypeDef ***********************/
#define  TIM_CNT                                               ((uint32_t)0xFFFF)          

/**********************  Bit definition for PSC register of TIM_TypeDef ***********************/
#define  TIM_PSC                                               ((uint32_t)0xFFFF)         

/**********************  Bit definition for ARR register of TIM_TypeDef ***********************/
#define  TIM_ARR                                               ((uint32_t)0xFFFF)           

/**********************  Bit definition for RCR register of TIM_TypeDef ***********************/
#define  TIM_RCR                                               ((uint32_t)0x00FF)          

/**********************  Bit definition for CCR1 register of TIM_TypeDef ***********************/
#define  TIM_CCR1                                              ((uint32_t)0xFFFF)           

/**********************  Bit definition for CCR2 register of TIM_TypeDef ***********************/
#define  TIM_CCR2                                              ((uint32_t)0xFFFF)          

/**********************  Bit definition for CCR3 register of TIM_TypeDef ***********************/
#define  TIM_CCR3                                              ((uint32_t)0xFFFF)          

/**********************  Bit definition for CCR4 register of TIM_TypeDef ***********************/
#define  TIM_CCR4                                              ((uint32_t)0xFFFF)             

/**********************  Bit definition for BDTR register of TIM_TypeDef ***********************/
#define  TIM_BDTR                                              ((uint32_t)0xFFFF)          
#define  TIM_BDTR_DTG                                          ((uint32_t)0x00FF)          
#define  TIM_BDTR_LOCK                                         ((uint32_t)0x0300)         
#define  TIM_BDTR_LOCK_0                                       ((uint32_t)0x0000)         
#define  TIM_BDTR_LOCK_1                                       ((uint32_t)0x0100)        
#define  TIM_BDTR_LOCK_2                                       ((uint32_t)0x0200)        
#define  TIM_BDTR_LOCK_3                                       ((uint32_t)0x0300)        

#define  TIM_BDTR_OSSI                                         ((uint32_t)0x0400)          
#define  TIM_BDTR_OSSR                                         ((uint32_t)0x0800)          
#define  TIM_BDTR_BKE                                          ((uint32_t)0x1000)          
#define  TIM_BDTR_BKP                                          ((uint32_t)0x2000)         
#define  TIM_BDTR_CMP4OE                                       ((uint32_t)0x10000)        
#define  TIM_BDTR_CMP4OEP                                      ((uint32_t)0x20000)        
#define  TIM_BDTR_CMP5OE                                       ((uint32_t)0x40000)       
#define  TIM_BDTR_CMP5OEP                                      ((uint32_t)0x80000)        
#define  TIM_BDTR_DOE                                          ((uint32_t)0x100000)
#define  TIM_BDTR_HardFault_OE                                 ((uint32_t)0x200000)
#define  TIM_BDTR_AOE                                          ((uint32_t)0x4000)       
#define  TIM_BDTR_MOE                                          ((uint32_t)0x8000)        

#define  TIM_BDTR_BKF                                          ((uint32_t)0x3C00000)
#define  TIM_BDTR_BKF_NoFilter_AsynBreak                       ((uint32_t)0<<22)
#define  TIM_BDTR_BKF_Fck_N2                                   ((uint32_t)1<<22)
#define  TIM_BDTR_BKF_Fck_N4                                   ((uint32_t)2<<22)
#define  TIM_BDTR_BKF_Fck_N8                                   ((uint32_t)3<<22)
#define  TIM_BDTR_BKF_FdtsDiv2_N6                              ((uint32_t)4<<22)
#define  TIM_BDTR_BKF_FdtsDiv2_N8                              ((uint32_t)5<<22)
#define  TIM_BDTR_BKF_FdtsDiv4_N6                              ((uint32_t)6<<22)
#define  TIM_BDTR_BKF_FdtsDiv4_N8                              ((uint32_t)7<<22)
#define  TIM_BDTR_BKF_FdtsDiv8_N6                              ((uint32_t)8<<22)
#define  TIM_BDTR_BKF_FdtsDiv8_N8                              ((uint32_t)9<<22)
#define  TIM_BDTR_BKF_FdtsDiv16_N5                             ((uint32_t)10<<22)
#define  TIM_BDTR_BKF_FdtsDiv16_N6                             ((uint32_t)11<<22)
#define  TIM_BDTR_BKF_FdtsDiv16_N8                             ((uint32_t)12<<22)
#define  TIM_BDTR_BKF_FdtsDiv32_N5                             ((uint32_t)13<<22)
#define  TIM_BDTR_BKF_FdtsDiv32_N6                             ((uint32_t)14<<22)
#define  TIM_BDTR_BKF_FdtsDiv32_N8                             ((uint32_t)15<<22)           

/**********************  Bit definition for CCR5 register of TIM_TypeDef ***********************/
#define  TIM_CCR5                                              ((uint32_t)0xFFFF)          

/**********************  Bit definition for CCR6 register of TIM_TypeDef ***********************/
#define  TIM_CCR6                                              ((uint32_t)0xFFFF)  

/**********************  Bit definition for CCMR3 register of TIM_TypeDef *****************/
#define  TIM_CCMR3                                             ((uint32_t)0xFFFF)           

#define  TIM_CCMR3_OC5FE                                       ((uint32_t)0x0004)          
#define  TIM_CCMR3_OC5PE                                       ((uint32_t)0x0008)        

#define  TIM_CCMR3_OC5M                                        ((uint32_t)0x0070)           

#define  TIM_CCMR3_OC5CE                                       ((uint32_t)0x0080)  

#define  TIM_CCMR3_OC6FE                                       ((uint32_t)0x0100)          
#define  TIM_CCMR3_OC6PE                                       ((uint32_t)0x0200) 
#define  TIM_CCMR3_OC6M                                        ((uint32_t)0x1C00)           

#define  TIM_CCMR3_OC6CE                                       ((uint32_t)0x2000)        

/**********************  Bit definition for CCR1N register of TIM_TypeDef ***********************/
#define  TIM_CCR1N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR1N_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for CCR2N register of TIM_TypeDef ***********************/
#define  TIM_CCR2N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR2N_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for CCR3N register of TIM_TypeDef ***********************/
#define  TIM_CCR3N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR3N_EN                                         ((uint32_t)0x80000000) 

/**
  * @brief  HELPER macro calculating the prescaler value to achieve the required counter clock frequency.
  * @note ex: @ref __TIM_CALC_PSC (80000000, 1000000);
  * @param  __TIMCLK__ timer input clock frequency (in Hz)
  * @param  __CNTCLK__ counter clock frequency (in Hz)
  * @retval Prescaler value  (between Min_Data=0 and Max_Data=65535)
  */
#define __TIM_CALC_PSC(__TIMCLK__, __CNTCLK__)   \
   ((__TIMCLK__) >= (__CNTCLK__)) ? (uint32_t)((__TIMCLK__)/(__CNTCLK__) - 1U) : 0U

/**
  * @brief  HELPER macro calculating the auto-reload value to achieve the required output signal frequency.
  * @note ex: @ref __TIM_CALC_ARR (1000000, @ref TIM_GetPrescaler (), 10000);
  * @param  __TIMCLK__ timer input clock frequency (in Hz)
  * @param  __PSC__ prescaler
  * @param  __FREQ__ output signal frequency (in Hz)
  * @retval  Auto-reload value  (between Min_Data=0 and Max_Data=65535)
  */
#define __TIM_CALC_ARR(__TIMCLK__, __PSC__, __FREQ__) \
     (((__TIMCLK__)/((__PSC__) + 1U)) >= (__FREQ__)) ? ((__TIMCLK__)/((__FREQ__) * ((__PSC__) + 1U)) - 1U) : 0U

/**
  * @brief  HELPER macro calculating DTG[0:7] in the TIM_BDTR register to achieve the requested dead time duration.
  * @note ex: @ref __TIM_CALC_DEADTIME (80000000, @ref TIM_GetClockDivision (), 120);
  * @param  __TIMCLK__ timer input clock frequency (in Hz)
  * @param  __CKD__ This parameter can be one of the following values:
  *         @arg @ref TIM_CLOCKDIVISION_DIV1
  *         @arg @ref TIM_CLOCKDIVISION_DIV2
  *         @arg @ref TIM_CLOCKDIVISION_DIV4
  * @param  __DT__ deadtime duration (in ns)
  * @retval DTG[0:7]
  */
#define __TIM_CALC_DEADTIME(__TIMCLK__, __CKD__, __DT__)  \
    ( (((uint64_t)((__DT__)*1000U)) < ((DT_DELAY_1+1U) * TIM_CALC_DTS((__TIMCLK__), (__CKD__))))           ? (uint8_t)(((uint64_t)((__DT__)*1000U) / TIM_CALC_DTS((__TIMCLK__), (__CKD__)))  & DT_DELAY_1) :                                               \
      (((uint64_t)((__DT__)*1000U)) < (64U + (DT_DELAY_2+1U)) * 2U * TIM_CALC_DTS((__TIMCLK__), (__CKD__)))  ? (uint8_t)(DT_RANGE_2 | ((uint8_t)((uint8_t)((((uint64_t)((__DT__)*1000U))/ TIM_CALC_DTS((__TIMCLK__), (__CKD__))) >> 1U) - (uint8_t) 64) & DT_DELAY_2)) :\
      (((uint64_t)((__DT__)*1000U)) < (32U + (DT_DELAY_3+1U)) * 8U * TIM_CALC_DTS((__TIMCLK__), (__CKD__)))  ? (uint8_t)(DT_RANGE_3 | ((uint8_t)((uint8_t)(((((uint64_t)(__DT__)*1000U))/ TIM_CALC_DTS((__TIMCLK__), (__CKD__))) >> 3U) - (uint8_t) 32) & DT_DELAY_3)) :\
      (((uint64_t)((__DT__)*1000U)) < (32U + (DT_DELAY_4+1U)) * 16U * TIM_CALC_DTS((__TIMCLK__), (__CKD__))) ? (uint8_t)(DT_RANGE_4 | ((uint8_t)((uint8_t)(((((uint64_t)(__DT__)*1000U))/ TIM_CALC_DTS((__TIMCLK__), (__CKD__))) >> 4U) - (uint8_t) 32) & DT_DELAY_4)) :\
       0U)
			 
/* Private macros ------------------------------------------------------------*/
/** @defgroup TIM_LL_Private_Macros TIM Private Macros
  * @{
  */
/** @brief  Convert channel id into channel index.
  * @param  __CHANNEL__ This parameter can be one of the following values:
  *         @arg @ref TIM_CHANNEL_CH1
  *         @arg @ref TIM_CHANNEL_CH1N
  *         @arg @ref TIM_CHANNEL_CH2
  *         @arg @ref TIM_CHANNEL_CH2N
  *         @arg @ref TIM_CHANNEL_CH3
  *         @arg @ref TIM_CHANNEL_CH3N
  *         @arg @ref TIM_CHANNEL_CH4
	*         @arg @ref TIM_CHANNEL_CH5
  * @retval none
  */
#define TIM_GET_CHANNEL_INDEX( __CHANNEL__) \
(((__CHANNEL__) == TIM_CHANNEL_CH1) ? 0U :\
((__CHANNEL__) == TIM_CHANNEL_CH1N) ? 1U :\
((__CHANNEL__) == TIM_CHANNEL_CH2) ? 2U :\
((__CHANNEL__) == TIM_CHANNEL_CH2N) ? 3U :\
((__CHANNEL__) == TIM_CHANNEL_CH3) ? 4U :\
((__CHANNEL__) == TIM_CHANNEL_CH3N) ? 5U :\
((__CHANNEL__) == TIM_CHANNEL_CH4) ? 6U : 7U)//7U will be selected by TIM_CHANNEL_CH5




/** @defgroup  TIM_Channel
  * @{
  */
#define TIM_CHANNEL_CH1                     (1<<0)     /*!< Timer input/output channel 1 */
#define TIM_CHANNEL_CH1N                    (1<<2)    /*!< Timer complementary output channel 1 */
#define TIM_CHANNEL_CH2                     (1<<4)     /*!< Timer input/output channel 2 */
#define TIM_CHANNEL_CH2N                    (1<<6)    /*!< Timer complementary output channel 2 */
#define TIM_CHANNEL_CH3                     (1<<8)     /*!< Timer input/output channel 3 */
#define TIM_CHANNEL_CH3N                    (1<<10)    /*!< Timer complementary output channel 3 */
#define TIM_CHANNEL_CH4                     (1<<12)     /*!< Timer input/output channel 4 */
#define TIM_CHANNEL_CH5                     (1<<14)     /*!< Timer input/output channel 5 */
#define TIM_CHANNEL_CH6                     (1<<16)     /*!< Timer input/output channel 6 */

/** @defgroup TIM_Output_Polarity 
  * @{
  */
#define TIM_OCPOLARITY_HIGH                 ((uint16_t)0x0000)
#define TIM_OCPOLARITY_LOW                  ((uint16_t)0x0002)


/** @defgroup TIM_Clock_Division
  * @{
  */
#define TIM_CKD_DIV1                        0x00000000U      /*!< tDTS=tCK_INT */
#define TIM_CKD_DIV2                        (0x01<<8)        /*!< tDTS=2*tCK_INT */
#define TIM_CKD_DIV4                        (0x02<<8)        /*!< tDTS=4*tCK_INT */


/** @defgroup TIM_LL_EC_TRGO Trigger Output
  * @{
  */
#define TIM_TRGO_RESET                      0x00000000U                                     /*!< UG bit from the TIMx_EGR register is used as trigger output */
#define TIM_TRGO_ENABLE                     (0x01<<4)                                   /*!< Counter Enable signal (CNT_EN) is used as trigger output */
#define TIM_TRGO_UPDATE                     (0x02<<4)                                   /*!< Update event is used as trigger output */
#define TIM_TRGO_CC1IF                      (0x03<<4)                 /*!< CC1 capture or a compare match is used as trigger output */
#define TIM_TRGO_OC1REF                     (0x04<<4)                                   /*!< OC1REF signal is used as trigger output */
#define TIM_TRGO_OC2REF                     (0x05<<4)                  /*!< OC2REF signal is used as trigger output */
#define TIM_TRGO_OC3REF                     (0x06<<4)                  /*!< OC3REF signal is used as trigger output */
#define TIM_TRGO_OC4REF                     (0x07<<4)            /*!< OC4REF signal is used as trigger output */

/** @defgroup TIM_Output_Configuration_Idle_State
  * @{
  */
#define TIM_OCIDLESTATE_LOW                 0x00000000U             /*!<OCx=0 (after a dead-time if OC is implemented) when MOE=0*/
#define TIM_OCIDLESTATE_HIGH                (1<<8)            /*!<OCx=1 (after a dead-time if OC is implemented) when MOE=0*/

/** @defgroup TIM_ClockDivision
  * @{
  */
#define TIM_CLOCKDIVISION_DIV1              0x00000000U          /*!< tDTS=tCK_INT */
#define TIM_CLOCKDIVISION_DIV2              (0x01<<8)        /*!< tDTS=2*tCK_INT */
#define TIM_CLOCKDIVISION_DIV4              (0x02<<8)        /*!< tDTS=4*tCK_INT */

/** @defgroup TIM_Update_Source
  * @{
  */
#define TIM_UPDATESOURCE_REGULAR            0x00000000U          /*!< Counter overflow/underflow, Setting the UG bit or Update generation through the slave mode controller generates an update request */
#define TIM_UPDATESOURCE_COUNTER            (1<<2)          /*!< Only counter overflow/underflow generates an update request */

/** @defgroup TIM_OnePulseMode
  * @{
  */
#define TIM_ONEPULSEMODE_SINGLE             (1<<3)          /*!< Counter is not stopped at update event */
#define TIM_ONEPULSEMODE_REPETITIVE         0x00000000U          /*!< Counter stops counting at the next update event */

/** @defgroup TIM_Counter_Direction
  * @{
  */
#define TIM_COUNTERDIRECTION_UP             0x00000000U          /*!< Timer counter counts up */
#define TIM_COUNTERDIRECTION_DOWN           (0x01<<4)          /*!< Timer counter counts down */

/** @defgroup TIM_Capture_Compare_Update_Source
  * @{
  */
#define TIM_CCUPDATESOURCE_COMG_ONLY        0x00000000U          /*!< Capture/compare control bits are updated by setting the COMG bit only */
#define TIM_CCUPDATESOURCE_COMG_AND_TRGI    (0x01<<2)         /*!< Capture/compare control bits are updated by setting the COMG bit or when a rising edge occurs on trigger input (TRGI) */

/** @defgroup TIM_Clock_Source
  * @{
  */
#define TIM_CLOCKSOURCE_INTERNAL            0x00000000U                                          /*!< The timer is clocked by the internal clock provided from the RCC */
#define TIM_CLOCKSOURCE_EXT_MODE1           ((0x04<<0) | (0x02<<0) | (0x01<<0))   /*!< Counter counts at each rising or falling edge on a selected inpu t*/
#define TIM_CLOCKSOURCE_EXT_MODE2           (0x01<<14)                                         /*!< Counter counts at each rising or falling edge on the external trigger input ETR */

/** @defgroup TIM_Encoder_Mode
  * @{
  */
#define TIM_ENCODERMODE_X2_TI1              (0x01<<0)                    /*!< Encoder mode 1 - Counter counts up/down on TI2FP2 edge depending on TI1FP1 level */
#define TIM_ENCODERMODE_X2_TI2              (0x02<<0)                    /*!< Encoder mode 2 - Counter counts up/down on TI1FP1 edge depending on TI2FP2 level */
#define TIM_ENCODERMODE_X4_TI12             ((0x01<<0)  | (0x02<<0)) /*!< Encoder mode 3 - Counter counts up/down on both TI1FP1 and TI2FP2 edges                                                                                                                                                                   depending on the level of the other input l */

/** @defgroup TIM_Slave_Mode
  * @{
  */
#define TIM_SLAVEMODE_DISABLED              0x00000000U                         /*!< Slave mode disabled */
#define TIM_SLAVEMODE_RESET                 (0x04<<0)                      /*!< Reset Mode - Rising edge of the selected trigger input (TRGI) reinitializes the counter */
#define TIM_SLAVEMODE_GATED                 ((0x04<<0) | (0x01<<0))   /*!< Gated Mode - The counter clock is enabled when the trigger input (TRGI) is high */
#define TIM_SLAVEMODE_TRIGGER               ((0x04<<0) | (0x02<<0))   /*!< Trigger Mode - The counter starts at a rising edge of the trigger TRGI */

/** @defgroup TIM_Trigger_Selection
  * @{
  */
#define TIM_TS_TI1F_ED                      (0x04<<4)                                    /*!< TI1 Edge Detector (TI1F_ED) is used as trigger input */
#define TIM_TS_TI1FP1                       ((0x04<<4) | (0x01<<4))                  /*!< Filtered Timer Input 1 (TI1FP1) is used as trigger input */
#define TIM_TS_TI2FP2                       ((0x04<<4) | (0x02<<4))                  /*!< Filtered Timer Input 2 (TI12P2) is used as trigger input */
#define TIM_TS_ETRF                         ((0x04<<4) | (0x02<<4) | (0x01<<4))  /*!< Filtered external Trigger (ETRF) is used as trigger input */

/** @defgroup TIM_ETR_Polarity
  * @{
  */
#define TIM_ETR_POLARITY_NONINVERTED        0x00000000U             /*!< ETR is non-inverted, active at high level or rising edge */
#define TIM_ETR_POLARITY_INVERTED           (0x01<<15)            /*!< ETR is inverted, active at low level or falling edge */

/** @defgroup TIM_ETR_Prescaler
  * @{
  */
#define TIM_ETR_PRESCALER_DIV1              0x00000000U             /*!< ETR prescaler OFF */
#define TIM_ETR_PRESCALER_DIV2              (0x01<<12)         /*!< ETR frequency is divided by 2 */
#define TIM_ETR_PRESCALER_DIV4              (0x02<<12)         /*!< ETR frequency is divided by 4 */
#define TIM_ETR_PRESCALER_DIV8              (0x03<<12)           /*!< ETR frequency is divided by 8 */

/** @defgroup TIM_ETR_Filter
  * @{
  */
#define TIM_ETR_FILTER_FDIV1                0x00000000U      /*!< No filter, sampling is done at fDTS */
#define TIM_ETR_FILTER_FDIV1_N2             (0x01)           /*!< fSAMPLING=fCK_INT, N=2 */
#define TIM_ETR_FILTER_FDIV1_N4             (0x02)           /*!< fSAMPLING=fCK_INT, N=4 */
#define TIM_ETR_FILTER_FDIV1_N8             (0x03)           /*!< fSAMPLING=fCK_INT, N=8 */
#define TIM_ETR_FILTER_FDIV2_N6             (0x04)           /*!< fSAMPLING=fDTS/2, N=6 */
#define TIM_ETR_FILTER_FDIV2_N8             (0x05)           /*!< fSAMPLING=fDTS/2, N=8 */
#define TIM_ETR_FILTER_FDIV4_N6             (0x06)           /*!< fSAMPLING=fDTS/4, N=6 */
#define TIM_ETR_FILTER_FDIV4_N8             (0x07)           /*!< fSAMPLING=fDTS/4, N=8 */
#define TIM_ETR_FILTER_FDIV8_N6             (0x08)           /*!< fSAMPLING=fDTS/8, N=8 */
#define TIM_ETR_FILTER_FDIV8_N8             (0x09)           /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_ETR_FILTER_FDIV16_N5            (0x0a)           /*!< fSAMPLING=fDTS/16, N=6 */
#define TIM_ETR_FILTER_FDIV16_N6            (0x0b)           /*!< fSAMPLING=fDTS/16, N=8 */
#define TIM_ETR_FILTER_FDIV16_N8            (0x0c)           /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_ETR_FILTER_FDIV32_N5            (0x0d)           /*!< fSAMPLING=fDTS/32, N=5 */
#define TIM_ETR_FILTER_FDIV32_N6            (0x0e)           /*!< fSAMPLING=fDTS/32, N=6 */
#define TIM_ETR_FILTER_FDIV32_N8            (0x0f)           /*!< fSAMPLING=fDTS/32, N=8 */




/** @defgroup TIM_Active_Input_Selection
  * @{
  */
#define TIM_ACTIVEINPUT_DIRECTTI            ((0x01<<0) << 16U) /*!< ICx is mapped on TIx */
#define TIM_ACTIVEINPUT_INDIRECTTI          ((0x02<<0) << 16U) /*!< ICx is mapped on TIy */
#define TIM_ACTIVEINPUT_TRC                 ((0x03<<0) << 16U)   /*!< ICx is mapped on TRC */

/************************************************************************************************************
                                            TIM_TimeBaseInitTypeDef
*************************************************************************************************************/
/** @defgroup TIM_Counter_Mode 
  * @{
  */
#define TIM_COUNTERMODE_UP                  0x00000000U   /*!<Counter used as upcounter */
#define TIM_COUNTERMODE_DOWN                (BIT4)        /*!< Counter used as downcounter */
#define TIM_COUNTERMODE_CENTER_UP           (BIT6)        /*!< The counter counts up and down alternatively. Output compare interrupt flags of output channels  are set only when the counter is counting down. */
#define TIM_COUNTERMODE_CENTER_DOWN         (BIT5)        /*!< The counter counts up and down alternatively. Output compare interrupt flags of output channels  are set only when the counter is counting up */
#define TIM_COUNTERMODE_CENTER_UP_DOWN      (BIT6|BIT5)   /*!< The counter counts up and down alternatively. Output compare interrupt flags of output channels  are set only when the counter is counting up or down. */

/************************************************************************************************************
                                            TIM_OCInitTypeDef
*************************************************************************************************************/
/** @defgroup TIM_Output_Compare_and_PWM_modes 
  * @{
  */

#define TIM_OCMODE_FROZEN                   0x00000000U                                              /*!<The comparison between the output compare register TIM_CCRy and the counter TIM_CNT has no effect on the output channel level */
#define TIM_OCMODE_ACTIVE                   (1<<4)                                         /*!<OCyREF is forced high on compare match*/
#define TIM_OCMODE_INACTIVE                 (0x02<<4)                                         /*!<OCyREF is forced low on compare match*/
#define TIM_OCMODE_TOGGLE                   ((0x02<<4) | (1<<4))                    /*!<OCyREF toggles on compare match*/
#define TIM_OCMODE_FORCED_INACTIVE          (0x04<<4)                                       /*!<OCyREF is forced low*/
#define TIM_OCMODE_FORCED_ACTIVE            ((0x04<<4)  | (1<<4))                    /*!<OCyREF is forced high*/
#define TIM_OCMODE_PWM1                     ((0x04<<4)  | (0x02<<4))                    /*!<In upcounting, channel y is active as long as TIM_CNT<TIM_CCRy else inactive.  In downcounting, channel y is inactive as long as TIM_CNT>TIM_CCRy else active.*/
#define TIM_OCMODE_PWM2                     ((0x04<<4)  | (0x02<<4) | (1<<4)) /*!<In upcounting, channel y is inactive as long as TIM_CNT<TIM_CCRy else active.  In downcounting, channel y is active as long as TIM_CNT>TIM_CCRy else inactive*/

/** @defgroup TIM_Output_Compare_state 
  * @{
  */
#define TIM_OutputState_Disable             ((uint16_t)0x0000)
#define TIM_OutputState_Enable              ((uint16_t)0x0001)

/** @defgroup TIM_Output_Compare_N_state 
  * @{
  */
#define TIM_OutputNState_Disable            ((uint16_t)0x0000)
#define TIM_OutputNState_Enable             ((uint16_t)0x0004)

/** @defgroup TIM_Output_Compare_Polarity 
  * @{
  */
#define TIM_OCPolarity_High                 ((uint16_t)0x0000)
#define TIM_OCPolarity_Low                  ((uint16_t)0x0002)

/** @defgroup TIM_Output_Compare_N_Polarity 
  * @{
  */ 
#define TIM_OCNPolarity_High                ((uint16_t)0x0000)
#define TIM_OCNPolarity_Low                 ((uint16_t)0x0008)

/** @defgroup TIM_Output_Compare_Idle_State 
  * @{
  */
#define TIM_OCIdleState_Set                 ((uint16_t)0x0100)
#define TIM_OCIdleState_Reset               ((uint16_t)0x0000)

/** @defgroup TIM_Output_Compare_N_Idle_State 
  * @{
  */
#define TIM_OCNIdleState_Set                ((uint16_t)0x0200)
#define TIM_OCNIdleState_Reset              ((uint16_t)0x0000)



/************************************************************************************************************
                                            TIM_ICInitTypeDef
*************************************************************************************************************/
/** @defgroup TIM_Input_Capture_Polarity 
  * @{
  */
#define  TIM_ICPolarity_Rising              ((uint16_t)0x0000)
#define  TIM_ICPolarity_Falling             ((uint16_t)0x0002)
#define  TIM_ICPolarity_BothEdge            ((uint16_t)0x000A)

/** @defgroup TIM_Input_Capture_Selection 
  * @{
  */
#define TIM_ICSelection_DirectTI            ((uint16_t)0x0001) /*!< TIM Input 1, 2, 3 or 4 is selected to be 
                                                                   connected to IC1, IC2, IC3 or IC4, respectively */
#define TIM_ICSelection_IndirectTI          ((uint16_t)0x0002) /*!< TIM Input 1, 2, 3 or 4 is selected to be
                                                                   connected to IC2, IC1, IC4 or IC3, respectively. */
#define TIM_ICSelection_TRC                 ((uint16_t)0x0003) /*!< TIM Input 1, 2, 3 or 4 is selected to be connected to TRC. */

/** @defgroup TIM_Input_Capture_Prescaler 
  * @{
  */
#define TIM_ICPSC_DIV1                      ((uint32_t)0x00<<16) /*!< Capture performed each time an edge is detected on the capture input. */
#define TIM_ICPSC_DIV2                      ((uint32_t)0x04<<16) /*!< Capture performed once every 2 events. */
#define TIM_ICPSC_DIV4                      ((uint32_t)0x08<<16) /*!< Capture performed once every 4 events. */
#define TIM_ICPSC_DIV8                      ((uint32_t)0x0C<<16) /*!< Capture performed once every 8 events. */

/** @defgroup TIM_Input_Configuration_Filter
  * @{
  */
#define TIM_IC_FILTER_FDIV1                 0x00000000U     /*!< No filter, sampling is done at fDTS */
#define TIM_IC_FILTER_FDIV1_N2              (0x01)          /*!< fSAMPLING=fCK_INT, N=2 */
#define TIM_IC_FILTER_FDIV1_N4              (0x02)          /*!< fSAMPLING=fCK_INT, N=4 */
#define TIM_IC_FILTER_FDIV1_N8              (0x03)          /*!< fSAMPLING=fCK_INT, N=8 */
#define TIM_IC_FILTER_FDIV2_N6              (0x04)          /*!< fSAMPLING=fDTS/2, N=6 */
#define TIM_IC_FILTER_FDIV2_N8              (0x05)          /*!< fSAMPLING=fDTS/2, N=8 */
#define TIM_IC_FILTER_FDIV4_N6              (0x06)          /*!< fSAMPLING=fDTS/4, N=6 */
#define TIM_IC_FILTER_FDIV4_N8              (0x07)          /*!< fSAMPLING=fDTS/4, N=8 */
#define TIM_IC_FILTER_FDIV8_N6              (0x08)          /*!< fSAMPLING=fDTS/8, N=6 */
#define TIM_IC_FILTER_FDIV8_N8              (0x09)          /*!< fSAMPLING=fDTS/8, N=8 */
#define TIM_IC_FILTER_FDIV16_N5             (0x0a)          /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_IC_FILTER_FDIV16_N6             (0x0b)          /*!< fSAMPLING=fDTS/16, N=6 */
#define TIM_IC_FILTER_FDIV16_N8             (0x0c)          /*!< fSAMPLING=fDTS/16, N=8 */
#define TIM_IC_FILTER_FDIV32_N5             (0x0d)          /*!< fSAMPLING=fDTS/32, N=5 */
#define TIM_IC_FILTER_FDIV32_N6             (0x0e)          /*!< fSAMPLING=fDTS/32, N=6 */
#define TIM_IC_FILTER_FDIV32_N8             (0x0f)          /*!< fSAMPLING=fDTS/32, N=8 */


/************************************************************************************************************
                                            TIM_BDTRInitTypeDef
*************************************************************************************************************/
/** @defgroup TIM_Off-state_Selection_for_Run_Mode
  * @{
  */
#define TIM_OSSR_DISABLE                    0x00000000U             /*!< When inactive, OCx/OCxN outputs are disabled */
#define TIM_OSSR_ENABLE                     (1<<11)           /*!< When inactive, OC/OCN outputs are enabled with their inactive level as soon as CCxE=1 or CCxNE=1 */

/** @defgroup TIM_Off-state_Selection_for_Idle_Mode
  * @{
  */
#define TIM_OSSI_DISABLE                    0x00000000U             /*!< When inactive, OCx/OCxN outputs are disabled */
#define TIM_OSSI_ENABLE                     (1<<10)           /*!< When inactive, OxC/OCxN outputs are first forced with their inactive level then forced to their idle level after the deadtime */

/** @defgroup TIM_Lock_level 
  * @{
  */
#define TIM_LOCKLevel_OFF                   ((uint16_t)0x0000)
#define TIM_LOCKLevel_1                     ((uint16_t)0x0100)
#define TIM_LOCKLevel_2                     ((uint16_t)0x0200)
#define TIM_LOCKLevel_3                     ((uint16_t)0x0300)

/** @defgroup TIM_Break_Input_enable_disable 
  * @{
  */
#define TIM_Break_Enable                    ((uint16_t)0x1000)
#define TIM_Break_Disable                   ((uint16_t)0x0000)

/** @defgroup TIM_Break_Polarity
  * @{
  */
#define TIM_BREAK_POLARITY_LOW              0x00000000U               /*!< Break input BRK is active low */
#define TIM_BREAK_POLARITY_HIGH             (1<<13)              /*!< Break input BRK is active high */

/** @defgroup TIM_CMP4_Break_enable_disable  
  * @{
  */
#define TIM_CMP4_Break_Enable               ((uint32_t)0x10000)
#define TIM_CMP4_Break_Disable              ((uint32_t)0x00000)

/** @defgroup TIM_CMP4_Break_Polarity
  * @{
  */
#define TIM_CMP4OEP_POLARITY_LOW            0x00000000U               /*!< Break input BRK is active low */
#define TIM_CMP4OEP_POLARITY_HIGH           (1<<17)              /*!< Break input BRK is active high */

/** @defgroup TIM_CMP5_Break_enable_disable  
  * @{
  */
#define TIM_CMP5_Break_Enable               ((uint32_t)0x40000)
#define TIM_CMP5_Break_Disable              ((uint32_t)0x00000)

/** @defgroup TIM_CMP5_Break_Polarity
  * @{
  */
#define TIM_CMP5OEP_POLARITY_LOW            0x00000000U               /*!< Break input BRK is active low */
#define TIM_CMP5OEP_POLARITY_HIGH           (1<<19)              /*!< Break input BRK is active high */

/** @defgroup TIM_HDFE_Bit_Set_Reset
  * @{
  */
#define  TIM_HDFE_Enable                    ((uint32_t)0x200000)
#define  TIM_HDFE_Disable                   ((uint32_t)0x000000)

/** @defgroup TIM_DOE_Bit_Set_Reset 
  * @{
  */
#define  TIM_DOE_Enable                     ((uint32_t)0x100000)
#define  TIM_DOE_Disable                    ((uint32_t)0x000000)

/** @defgroup TIM_AOE_Bit_Set_Reset 
  * @{
  */
#define TIM_AutomaticOutput_Enable          ((uint16_t)0x4000)
#define TIM_AutomaticOutput_Disable         ((uint16_t)0x0000)








/** 
  * @brief  TIM base Init structure definition  
  */

typedef struct
{
  uint16_t Prescaler;                /*!< Specifies the prescaler value used to divide the TIM clock
                                      This parameter can be a number between 0x0000 and 0xFFFF */

  uint16_t CounterMode;              /*!< Specifies the counter mode
                                      This parameter can be a value of @ref TIM_Counter_Mode */

  uint16_t Period;                   /*!< Specifies the period value to be loaded into the active
                                      Auto-Reload Register at the next update event
                                      This parameter must be a number between 0x0000 and 0xFFFF  */ 

  uint16_t ClockDivision;            /*!< Specifies the clock division
                                      This parameter can be a value of @ref TIM_Clock_Division */

  uint8_t  RepetitionCounter;        /*!< Specifies the repetition counter value. Each time the RCR downcounter
                                       reaches zero, an update event is generated and counting restarts
                                       from the RCR value (N)
                                      This means in PWM mode that (N+1) corresponds to:
                                          - the number of PWM periods in edge-aligned mode
                                          - the number of half PWM period in center-aligned mode
                                      This parameter must be a number between 0x00 and 0xFF*/
} TIM_TimeBaseInitTypeDef;     

/** 
  * @brief  TIM Output Compare Init structure definition  
  */

typedef struct
{
  uint16_t OCMode;                   /*!< Specifies the TIM mode
                                      This parameter can be a value of @ref TIM_Output_Compare_and_PWM_modes */

  uint16_t OutputState;              /*!< Specifies the TIM Output Compare state
                                      This parameter can be a value of @ref TIM_Output_Compare_state */

  uint16_t OutputNState;             /*!< Specifies the TIM complementary Output Compare state
                                      This parameter can be a value of @ref TIM_Output_Compare_N_state */

  uint16_t Pulse;                    /*!< Specifies the pulse value to be loaded into the Capture Compare Register
                                      This parameter can be a number between 0x0000 and 0xFFFF */

  uint16_t OCPolarity;               /*!< Specifies the output polarity
                                      This parameter can be a value of @ref TIM_Output_Compare_Polarity */

  uint16_t OCNPolarity;              /*!< Specifies the complementary output polarity
                                      This parameter can be a value of @ref TIM_Output_Compare_N_Polarity*/

  uint16_t OCIdleState;              /*!< Specifies the TIM Output Compare pin state during Idle state
                                      This parameter can be a value of @ref TIM_Output_Compare_Idle_State */

  uint16_t OCNIdleState;             /*!< Specifies the TIM Output Compare pin state during Idle state
                                      This parameter can be a value of @ref TIM_Output_Compare_N_Idle_State */
} TIM_OCInitTypeDef;

/** 
  * @brief  TIM Input Capture Init structure definition  
  */

typedef struct
{

  uint32_t Channel;                  /*!< Specifies the TIM channel
                                      This parameter can be a value of @ref TIM_Channel */

  uint32_t ICPolarity;               /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint32_t ICSelection;              /*!< Specifies the input
                                      This parameter can be a value of @ref TIM_Input_Capture_Selection */

  uint32_t ICPrescaler;              /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint32_t ICFilter;                 /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter*/
} TIM_ICInitTypeDef;


/** 
  * @brief  ENCODER structure definition   
  */

typedef struct
{

  uint16_t EncoderMode;              /*!< Specifies the encoder resolution
                                      This parameter can be a value of @ref TIM_Encoder_Mode */

  uint16_t IC1Polarity;              /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint16_t IC1Selection;             /*!< Specifies the input
                                      This parameter can be a value of @ref TIM_Input_Capture_Selection */

  uint16_t IC1Prescaler;             /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint16_t IC1Filter;                /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter*/

  uint16_t IC2Polarity;              /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint16_t IC2Selection;             /*!< Specifies the input
                                      This parameter can be a value of @ref TIM_Input_Capture_Selection */

  uint16_t IC2Prescaler;             /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint16_t IC2Filter;                /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter*/

} TIM_ENCODERInitTypeDef;



/** 
  * @brief  BDTR structure definition   
  */

typedef struct
{

  uint16_t OSSRState;                /*!< Specifies the Off-State selection used in Run mode
                                      This parameter can be a value of @ref TIM_Off-state_Selection_for_Run_Mode */

  uint16_t OSSIState;                /*!< Specifies the Off-State used in Idle state
                                      This parameter can be a value of @ref TIM_Off-state_Selection_for_Idle_Mode */

  uint16_t LOCKLevel;                /*!< Specifies the LOCK level parameters
                                      This parameter can be a value of @ref TIM_Lock_level */ 

  uint16_t DeadTime;                 /*!< Specifies the delay time between the switching-off and the
                                      switching-on of the outputs
                                      This parameter can be a number between 0x00 and 0xFF  */

  uint16_t BreakState;               /*!< Specifies whether the TIM Break input is enabled or not
                                      This parameter can be a value of @ref TIM_Break_Input_enable_disable */

  uint16_t BreakPolarity;            /*!< Specifies the TIM Break Input pin polarity
                                      This parameter can be a value of @ref TIM_Break_Polarity */

  uint16_t AutomaticOutput;          /*!< Specifies whether the TIM Automatic Output feature is enabled or not
                                      This parameter can be a value of @ref TIM_AOE_Bit_Set_Reset */
									  
  uint32_t CMP4_BreakState;          /*!< Specifies whether the TIM_CMP4 Break input is enabled or not
									                    This parameter can be a value of @ref TIM_CMP4_Break_enable_disable */
									  
  uint32_t CMP4_BreakPolarity;       /*!< Specifies the TIM_CMP4 Break input pin polarity
									                    This parameter can be a value of @ref TIM_CMP4_Break_Polarity */
									  
  uint32_t CMP5_BreakState;          /*!< Specifies whether the TIM_CMP5 Break input is enabled or not
									                    This parameter can be a value of @ref TIM_CMP5_Break_enable_disable */
									  
  uint32_t CMP5_BreakPolarity;	  
                                     /*!< Specifies the TIM_CMP5 Break input pin polarity
									                    This parameter can be a value of @ref TIM_CMP5_Break_Polarity */
									  
  uint32_t DOE;                      /*!< Specifies whether the TIM Direct Output is enabled or not
									                    This parameter can be a value of @ref TIM_DOE_Bit_Set_Reset */
  
	uint32_t HDFE; 						         /*!< Specifies whether the TIM Break Hardfault output is enabled or not
									                    This parameter can be a value of @ref TIM_HDFE_Bit_Set_Reset */
	
} TIM_BDTRInitTypeDef;

 void TIM_DeInit(TIM_TypeDef* TIMx);
 void TIM_TimeBaseStructInit(TIM_TimeBaseInitTypeDef* TIM_TimeBaseInitStruct);
 void TIM_OCStructInit(TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_ICStructInit(TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_BDTRStructInit(TIM_BDTRInitTypeDef* TIM_BDTRInitStruct);
 void TIM_TimeBaseInit(TIM_TypeDef* TIMx, TIM_TimeBaseInitTypeDef* TIM_TimeBaseInitStruct);
 void TIM_OC1Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC2Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC3Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC4Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC5Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC6Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_ICInit(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_BDTRInit(TIM_TypeDef* TIMx, TIM_BDTRInitTypeDef *TIM_BDTRInitStruct);
 void TIM_ENCODERInit(TIM_TypeDef *TIMx, TIM_ENCODERInitTypeDef *TIM_ENCODERInitStruct);
 void TIM_Enable_CEN(TIM_TypeDef *TIMx);
 void TIM_Disable_CEN(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_CENStatus(TIM_TypeDef *TIMx);
 void TIM_Enable_UpdateEvent(TIM_TypeDef *TIMx);
 void TIM_Disable_UpdateEvent(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_UpdateEventStatus(TIM_TypeDef *TIMx);
 void TIM_Set_UpdateSource(TIM_TypeDef *TIMx,uint32_t UpdateSource);
 uint32_t TIM_Get_UpdateSource(TIM_TypeDef *TIMx);
 void TIM_Set_OnePulseMode(TIM_TypeDef *TIMx,uint32_t OnePulseMode);
 uint32_t TIM_Get_OnePulseMode(TIM_TypeDef *TIMx);
 void TIM_Set_CounterMode(TIM_TypeDef *TIMx,uint32_t CounterMode);
 uint32_t TIM_Get_CounterMode(TIM_TypeDef *TIMx);
 void TIM_Enable_ARRPreload(TIM_TypeDef *TIMx);
 void TIM_Disable_ARRPreload(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_ARRPreloadStatus(TIM_TypeDef *TIMx);
 void TIM_Set_ClockDivision(TIM_TypeDef *TIMx,uint32_t ClockDivision);
 uint32_t TIM_Get_ClockDivision(TIM_TypeDef *TIMx);
 void TIM_Set_CounterValue(TIM_TypeDef *TIMx,uint32_t Counter);
 void TIM_Clear_CounterValue(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_CounterValue(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_Direction(TIM_TypeDef *TIMx);
 void TIM_Set_Prescaler(TIM_TypeDef *TIMx,uint32_t Prescaler);
 uint32_t TIM_Get_Prescaler(TIM_TypeDef *TIMx);
 void TIM_Set_AutoReload(TIM_TypeDef *TIMx,uint32_t AutoReload);
 uint32_t TIM_Get_AutoReload(TIM_TypeDef *TIMx);
 void TIM_Set_RepetitionCounter(TIM_TypeDef *TIMx,uint32_t RepetitionCounter);
 uint32_t TIM_Get_RepetitionCounter(TIM_TypeDef *TIMx);
 void TIM_Enable_CC_Preload(TIM_TypeDef *TIMx);
 void TIM_Disable_CC_Preload(TIM_TypeDef *TIMx);
 void TIM_Set_CC_Update(TIM_TypeDef *TIMx,uint32_t CCUpdateSource);
 void TIM_Set_LockLevel(TIM_TypeDef *TIMx,uint32_t LockLevel);
 void TIM_Set_DeadTime(TIM_TypeDef *TIMx,uint32_t DeadTime);
 void TIM_Enable_CC_Channel(TIM_TypeDef *TIMx,uint32_t Channels);
 void TIM_Disable_CC_Channel(TIM_TypeDef *TIMx,uint32_t Channels);
 uint32_t TIM_Get_CC_ChannelStatus(TIM_TypeDef *TIMx,uint32_t Channels);
 void TIM_Set_OC_Output(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t Configuration);
 void TIM_Set_OC_Mode(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t Mode);
 uint32_t TIM_Get_OC_Mode(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_OC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t Polarity);
 uint32_t TIM_Get_OC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_OC_IdleState(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t IdleState);
 uint32_t TIM_Get_OC_IdleState(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_OC_Fast(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Disable_OC_Fast(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_OC_FastStatus(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_OC_Preload(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Disable_OC_Preload(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_OC_PreloadStatus(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_OC_Clear(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Disable_OC_Clear(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_OC_ClearStatus(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_OC_CompareCH1(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH2(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH3(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH4(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH5(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH6(TIM_TypeDef *TIMx,uint32_t CompareValue);
 uint32_t TIM_Get_OC_CompareCH1(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH2(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH3(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH4(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH5(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH6(TIM_TypeDef *TIMx);
 void TIM_Set_IC_ActiveInput(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICActiveInput);
 uint32_t TIM_Get_IC_ActiveInput(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_IC_Prescaler(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICPrescaler);
 uint32_t TIM_Get_IC_Prescaler(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_IC_Filter(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICFilter);
 uint32_t TIM_Get_IC_Filter(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_IC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICPolarity);
 uint32_t TIM_Get_IC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_IC_XORCombination(TIM_TypeDef *TIMx);
 void TIM_Disable_IC_XORCombination(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_XORCombinationStatus(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH1(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH2(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH3(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH4(TIM_TypeDef *TIMx);
 void TIM_Enable_ExternalClock(TIM_TypeDef *TIMx);
 void TIM_Disable_ExternalClock(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_ExternalClockStatus(TIM_TypeDef *TIMx);
 void TIM_Set_ClockSource(TIM_TypeDef *TIMx,uint32_t ClockSource);
 void TIM_Set_EncoderMode(TIM_TypeDef *TIMx,uint32_t EncoderMode);
 void TIM_Set_SlaveMode(TIM_TypeDef *TIMx,uint32_t SlaveMode);
 void TIM_Set_TriggerInput(TIM_TypeDef *TIMx,uint32_t TriggerInput);
 void TIM_Set_ETR(TIM_TypeDef *TIMx,uint32_t ETRPolarity, uint32_t ETRPrescaler,uint32_t ETRFilter);
 void TIM_Enable_BRK(TIM_TypeDef *TIMx);
 void TIM_Disable_BRK(TIM_TypeDef *TIMx);
 void TIM_Set_BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_CMP4Break(TIM_TypeDef *TIMx);
 void TIM_Disable_CMP4Break(TIM_TypeDef *TIMx);
 void TIM_Set_CMP4BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_CMP5Break(TIM_TypeDef *TIMx);
 void TIM_Disable_CMP5Break(TIM_TypeDef *TIMx);
 void TIM_Set_CMP5BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_DOE(TIM_TypeDef *TIMx);
 void TIM_Disable_DOE(TIM_TypeDef *TIMx); 
 void TIM_Enable_HardFaultBreak( TIM_TypeDef *TIMx );
 void TIM_Disable_HardFaultBreak( TIM_TypeDef *TIMx );
 void TIM_Set_BRKFilter( TIM_TypeDef *TIMx, uint32_t BKFilter );
 void TIM_Set_OffStates(TIM_TypeDef *TIMx,uint32_t OffStateIdle, uint32_t OffStateRun);
 void TIM_Enable_AOE(TIM_TypeDef *TIMx);
 void TIM_Disable_AOE(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_AOEStatus(TIM_TypeDef *TIMx);
 void TIM_Enable_MOE(TIM_TypeDef *TIMx);
 void TIM_Disable_MOE(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_MOEStatus(TIM_TypeDef *TIMx);
 static void TIM_Set_TI1(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection, uint16_t TIM_ICFilter);
 static void TIM_Set_TI2(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection, uint16_t TIM_ICFilter); 
 static void TIM_Set_TI3(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection, uint16_t TIM_ICFilter); 
 static void TIM_Set_TI4(TIM_TypeDef* TIMx, uint16_t TIM_ICPolarity, uint16_t TIM_ICSelection, uint16_t TIM_ICFilter); 
 void TIM_Enable_IT(TIM_TypeDef* TIMx, uint32_t TIM_IT);
 void TIM_Disable_IT(TIM_TypeDef* TIMx, uint32_t TIM_IT); 
 uint32_t TIM_Get_Flag(TIM_TypeDef* TIMx, uint32_t Flag);
 void TIM_Clear_Flag(TIM_TypeDef *TIMx, uint32_t IT_Flag);
 void TIM_Set_GenerateEvent(TIM_TypeDef *TIMx, uint32_t Event); 
 void TIM_Set_OC_CompareCH1N(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH2N(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH3N(TIM_TypeDef *TIMx,uint32_t CompareValue);
 uint32_t TIM_Get_OC_CompareCH1N(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH2N(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH3N(TIM_TypeDef *TIMx);
 void TIM_Enable_CCR1N(TIM_TypeDef *TIMx);
 void TIM_Disable_CCR1N(TIM_TypeDef *TIMx);
 void TIM_Enable_CCR2N(TIM_TypeDef *TIMx);
 void TIM_Disable_CCR2N(TIM_TypeDef *TIMx);
 void TIM_Enable_CCR3N(TIM_TypeDef *TIMx);
 void TIM_Disable_CCR3N(TIM_TypeDef *TIMx);
#ifdef __cplusplus
}
#endif

#endif
