/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_uart.c
* By           : RX_SD_Team
* Version      : 20210420
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#include <stdio.h>
#include "rx32s11xx_reset.h"

/*
*********************************************************************************************************
*                                          Local variable
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                             Local function
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*@function    PMU_Get_ResetFlag
*@brief         Get wake up flag.
*@param       resetflag:
*                       @arg PMU_RSTSTA_PORRST
*                       @arg PMU_RSTSTA_LBORRST
*                       @arg PMU_RSTSTA_WDTRST
*                       @arg PMU_RSTSTA_WakeupRST
*                       @arg PMU_RSTSTA_ExtRST
*                       @arg PMU_RSTSTA_SoftRST
*                       @arg PMU_RSTSTA_DebugRST
*                       @arg PMU_RSTSTA_StopFlag
*                       @arg PMU_RSTSTA_SleepFlag
*                       @arg PMU_RSTSTA_HoldFlag
*@retval       State of bit (1 or 0).
*********************************************************************************************************
*/
uint32_t PMU_Get_ResetFlag(uint32_t resetflag)
{
    return (READ_BIT(PMU->RSTSTA, resetflag) == (resetflag));
}

/*
*********************************************************************************************************
*@function    PMU_Clear_ResetFlag
*@brief         Clear wake up flag.
*@param       resetflag:
*                       @arg PMU_RSTSTA_PORRST
*                       @arg PMU_RSTSTA_LBORRST
*                       @arg PMU_RSTSTA_WDTRST
*                       @arg PMU_RSTSTA_WakeupRST
*                       @arg PMU_RSTSTA_ExtRST
*                       @arg PMU_RSTSTA_SoftRST
*                       @arg PMU_RSTSTA_DebugRST
*                       @arg PMU_RSTSTA_StopFlag
*                       @arg PMU_RSTSTA_SleepFlag
*                       @arg PMU_RSTSTA_HoldFlag
*@retval       None
*********************************************************************************************************
*/
void PMU_Clear_ResetFlag(uint32_t resetflag)
{
    CLEAR_BIT(PMU->RSTSTA, resetflag);
}

