/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s30xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s30xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s30xx
*********************************************************************************************************
*/

#define  __MAIN_C
#include "main.h"

/*
*********************************************************************************************************
*                                           Global macro/Structure
*********************************************************************************************************
*/

  uint32_t ErrorFlag;
  uint32_t ErrorBit;
  uint32_t covert_time1;
  uint32_t covert_time2;
  uint32_t covert_number;
  uint32_t covert_number1;
  uint32_t RegAddress;
  char    *RegName;

/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                           Global Function declaration
*********************************************************************************************************
*/
uint8_t RNum = 0;
uint8_t TNum = 0;
#define DATA_NUMBER             (16)
uint8_t RBuffer[DATA_NUMBER] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
uint8_t TBuffer[DATA_NUMBER] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x01};

__IO uint32_t aADCxConvertedData[ADC_CONVERTED_DATA_BUFFER_SIZE]; 

/*
*********************************************************************************************************
*                                              MAIN
*
*********************************************************************************************************
*/

void Delay_ms(uint32_t nDelay)
{
  uint32_t i;
  while(nDelay--)
  {
    for(i=0;i<2138;i++);
  }
}

void ReceptionCallback(UART_TypeDef* UARTx)
{
	 RBuffer[RNum++] = UARTx->SBUF;
}

void UART1_PIN_initial(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    // IO PD8_FUNC2 TX1
    GPIO_InitStruct.Pin  = GPIO_PIN_8;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.AF   = AF_FUNCTION2;
	  GPIO_InitStruct.Pull = GPIO_PULL_UP;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
//    // IO PA1_FUNC3 TX1, PA0_FUNC2 RX1
//    GPIO_InitStruct.Pin  = GPIO_PIN_1;
//    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//    GPIO_InitStruct.AF   = AF_FUNCTION3;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
//	
//    GPIO_InitStruct.AF   = AF_FUNCTION2;
//    GPIO_InitStruct.Pin = GPIO_PIN_0;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
}


void ADC_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};	
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_SADCEN);
	//PC0-AD3 PC1-AD2 PC3-AD1 PC4-AD0 
  GPIO_InitStruct.Pin  = GPIO_PIN_4;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF   = AF_FUNCTION1;
	GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin  = GPIO_PIN_3;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin  = GPIO_PIN_0;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin  = GPIO_PIN_1;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
	
	//PB5-AD6 PB7-AD5 PB8-AD4
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
	
	//PA4-AD10 PA5-AD9 PA6-AD8 PA7-AD7
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_4;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
	
  CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_PGAEN);	
  PGA_Enable(PGA_CR_PGA0EN);
  PGA_Set_GAIN(PGA_CR_PGA0GAIN,PGA_CR_PGA0GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
	
}

void UART1_initial(uint32_t Baud)
{		
	UART1_PIN_initial(); 
	UART_InitTypeDef UART1_InitStruct = {0};
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
}

void UART_SendTxBuf(UART_TypeDef* UARTx,uint8_t* wbuf,uint8_t len)
{
	uint8_t i;
	
	for(i=0;i<len;i++)
	{
		Delay_ms(1);
		UART_Send_Data(UARTx, *(wbuf + i) ); 
		while(0 == (UARTx->UARTSTA & 0x01) );
		UARTx->UARTSTA &= ~( (uint32_t)0x01);
	}
}


void DMA_Initial(uint32_t Length)
{
	// DMA
  /* Configure NVIC to enable DMA interruptions */
	
  /* Configure the DMA transfer */
  /*  - DMA transfer in circular mode to match with ADC configuration:        */
  /*    DMA unlimited requests.                                               */
  /*  - DMA transfer from ADC without address increment.                      */
  /*  - DMA transfer to memory with address increment.                        */
  /*  - DMA transfer from ADC by half-word to match with ADC configuration:   */
  /*    ADC resolution 12 bits.                                               */
  /*  - DMA transfer to memory by half-word to match with ADC conversion data */
  /*    buffer variable type: half-word.                                      */
  
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_DMAEN);	  //enable dma_clk

  DMA_Set_Transfer( DMA,DMA_CHANNEL_0,
	     	              DMA_CHNCTL_MODE_WordTransfer       |
	                    DMA_CHNCTL_CYCLE_ENABLE            |
		                  DMA_CHNCTL_SOURCEINC_NOINC         |
		                  DMA_CHNCTL_DESTININC_INC           |
		                  DMA_CHNCTL_PSIZE_Word              |
//			DMA_CHNCTL_PSIZE_HalfWord          |
//			DMA_CHNCTL_PSIZE_Byte              |
                      DMA_CHNCTL_CHANNEL_SADC           	);
                  
  /* Set DMA transfer addresses of source and destination */
  DMA_Set_Addresses(DMA,DMA_CHANNEL_0,
		                     (uint32_t)&(SADC->SADCDAT),
	                       (uint32_t)&aADCxConvertedData);
  
  /* Set DMA transfer size */
  DMA_Set_DataLength(DMA,DMA_CHANNEL_0,
	  	              Length);
									 
  /* Enable DMA transfer interruption: transfer complete */
  DMA_Enable_IT(DMA,DMA_DMAIE_TCIE0);
	
//  /* Enable DMA transfer interruption: space transfer transfer */
//  DMA_ConfigIT(DMA,DMA_DMAIE_BCIE0,ENABLE);

//  /* Enable DMA transfer interruption: transfer error */
//  DMA_ConfigIT(DMA,DMA_DMAIE_TEIE0,ENABLE);

  /*## Activation of DMA #####################################################*/
  /* Enable the DMA transfer */
	DMA_Enable_Channel(DMA,DMA_CHANNEL_0);
}

void adc_init_single(uint32_t Length, uint32_t SamplingTime)
{
	if (SADC_Get_SADCON(SADC) == 0) {
    
    SADC_RankInitTypeDef SADC_RankInitStruct = {0};
		
    SADC_RankInitStruct.Length = Length;
    SADC_RankInitStruct.Rank[0].Channel = SADC_CHANNEL8;
    SADC_RankInitStruct.Rank[0].SamplingTime = SADC_SAMPLINGTIME_2CYCLES;
    SADC_RankInitStruct.Rank[1].Channel = SADC_CHANNEL2;
    SADC_RankInitStruct.Rank[1].SamplingTime = SADC_SAMPLINGTIME_128CYCLES;
    SADC_RankInitStruct.Rank[2].Channel = SADC_CHANNEL3;
    SADC_RankInitStruct.Rank[2].SamplingTime = SADC_SAMPLINGTIME_32CYCLES;
    SADC_RankInitStruct.Rank[3].Channel = SADC_CHANNEL9;
    SADC_RankInitStruct.Rank[3].SamplingTime = SADC_SAMPLINGTIME_4CYCLES;
    SADC_RankInitStruct.Rank[4].Channel = SADC_CHANNEL5;
    SADC_RankInitStruct.Rank[4].SamplingTime = SADC_SAMPLINGTIME_64CYCLES;
    SADC_RankInitStruct.Rank[5].Channel = SADC_CHANNEL10;
    SADC_RankInitStruct.Rank[5].SamplingTime = SADC_SAMPLINGTIME_256CYCLES;
    SADC_RankInitStruct.Rank[6].Channel = SADC_CHANNEL7;
    SADC_RankInitStruct.Rank[6].SamplingTime = SADC_SAMPLINGTIME_16CYCLES;
    SADC_RankInitStruct.Rank[7].Channel = SADC_CHANNEL6;
    SADC_RankInitStruct.Rank[7].SamplingTime = SADC_SAMPLINGTIME_8CYCLES;
		
    SADC_RankInit(SADC, &SADC_RankInitStruct);
    
    SADC_InitTypeDef SADC_InitStruct = {DISABLE,0};    
		
    SADC_InitStruct.State   = ENABLE;
    SADC_InitStruct.TriggerSource = SADC_ADTRIG_SADCSTR;
    SADC_InitStruct.ContMode = SADC_CONV_SINGLE;
    SADC_InitStruct.ScanMode = SADC_SADCSCAN_ENABLE;
    SADC_InitStruct.Prescaler = SADC_SADCCLK_DIV3;
    SADC_InitStruct.Discen   = ENABLE;
    SADC_Init(SADC, &SADC_InitStruct);
  }
}

void Dis_single_test(uint32_t number, uint32_t Length)
{
		WDT_FeedDog();
		for(covert_number=0;covert_number<number;covert_number++){
	
       DMA_Enable_IT(DMA,DMA_DMAIE_TCIE0);
      
		  for(covert_number1=0;covert_number1<(Length>>8);covert_number1++){
        
        SADC_Start(SADC);
        Delay_ms(1);
        
        if (SADC_Get_Flag(SADC,SADC_SADCIF_SEQIF) == 1){
	        printf("\n%x trig %d Error \r\n",(Length>>8),covert_number1);
		    }
      }
		
      SADC_Start(SADC);
      
      /* wait end flag of scan conversions */
      while (DMA_Get_Flag(DMA,DMA_DMAIF_TCIF0) == 0){;} 
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SEQIF) == 0){;} 

    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SEQIF);
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
  	  DMA_Clear_Flag(DMA,DMA_DMAIF_TCIF0); 
	  }
    /* Disable ADC */
    SADC_Disable(SADC);
    DMA_Disable_IT(DMA,DMA_DMAIE_TCIE0);
}

void adc_init_change(uint32_t Length, uint32_t SamplingTime)
{
	if (SADC_Get_SADCON(SADC) == 0) {
    
    SADC_RankInitTypeDef SADC_RankInitStruct = {0};
		
    SADC_RankInitStruct.Length = Length;
    SADC_RankInitStruct.Rank[0].Channel = SADC_CHANNEL8;
    SADC_RankInitStruct.Rank[0].SamplingTime = SADC_SAMPLINGTIME_2CYCLES;
    SADC_RankInitStruct.Rank[1].Channel = SADC_CHANNEL2;
    SADC_RankInitStruct.Rank[1].SamplingTime = SADC_SAMPLINGTIME_128CYCLES;
    SADC_RankInitStruct.Rank[2].Channel = SADC_CHANNEL3;
    SADC_RankInitStruct.Rank[2].SamplingTime = SADC_SAMPLINGTIME_32CYCLES;
    SADC_RankInitStruct.Rank[3].Channel = SADC_CHANNEL9;
    SADC_RankInitStruct.Rank[3].SamplingTime = SADC_SAMPLINGTIME_4CYCLES;
    SADC_RankInitStruct.Rank[4].Channel = SADC_CHANNEL5;
    SADC_RankInitStruct.Rank[4].SamplingTime = SADC_SAMPLINGTIME_64CYCLES;
    SADC_RankInitStruct.Rank[5].Channel = SADC_CHANNEL10;
    SADC_RankInitStruct.Rank[5].SamplingTime = SADC_SAMPLINGTIME_256CYCLES;
    SADC_RankInitStruct.Rank[6].Channel = SADC_CHANNEL7;
    SADC_RankInitStruct.Rank[6].SamplingTime = SADC_SAMPLINGTIME_16CYCLES;
    SADC_RankInitStruct.Rank[7].Channel = SADC_CHANNEL6;
    SADC_RankInitStruct.Rank[7].SamplingTime = SADC_SAMPLINGTIME_8CYCLES;
		
    SADC_RankInit(SADC, &SADC_RankInitStruct);
    
    SADC_InitTypeDef SADC_InitStruct = {DISABLE,0};    
		
    SADC_InitStruct.State   = ENABLE;
    SADC_InitStruct.TriggerSource = SADC_ADTRIG_SADCSTR;
    SADC_InitStruct.ContMode = SADC_CONV_SINGLE;
    SADC_InitStruct.ScanMode = SADC_SADCSCAN_ENABLE;
    SADC_InitStruct.Prescaler = SADC_SADCCLK_DIV3;
    SADC_InitStruct.Discen   = ENABLE;
    SADC_Init(SADC, &SADC_InitStruct);
	
  }
}

void Dis_change_test(uint32_t number, uint32_t Length)
{
		WDT_FeedDog();	
		for(covert_number=0;covert_number<number;covert_number++){
	
       DMA_Enable_IT(DMA,DMA_DMAIE_TCIE0);
      
		  for(covert_number1=0;covert_number1<(Length>>8);covert_number1++){
        
        SADC_Start(SADC);
        Delay_ms(1);
        
        if (SADC_Get_Flag(SADC,SADC_SADCIF_SEQIF) == 1){
	        printf("\n%x trig %d Error \r\n",(Length>>8),covert_number1);
		    }
      }
      
//		  SADC_Disable_DISCEN(SADC); 
//      
//		  SADC_Disable_DISCEN(SADC); 
//		  SADC_Enable_DISCEN(SADC); 
      
//      SADC_Set_SequencerLength(SADC, Length - 1);     
      
      SADC_Set_SequencerLength(SADC, Length + 1);   
      
      SADC_Start(SADC);
      
      /* wait end flag of scan conversions */
      while (DMA_Get_Flag(DMA,DMA_DMAIF_TCIF0) == 0){;} 
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SEQIF) == 0){;} 

    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SEQIF);
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
  	  DMA_Clear_Flag(DMA,DMA_DMAIF_TCIF0); 
	  }
    /* Disable ADC */
    SADC_Disable(SADC);
    DMA_Disable_IT(DMA,DMA_DMAIE_TCIE0);
}

int main(void)
{
		
	ADC_Initial();
  NVIC_SetPriority((IRQn_Type) DMA_IRQn, 1); /* DMA IRQ lower priority than ADC IRQ */
  NVIC_EnableIRQ((IRQn_Type) DMA_IRQn);

	UART1_initial(115200);
	
  printf("\r\n SADC_SEQLENG_8\r\n");
  DMA_Initial(8);
	adc_init_single(SADC_SEQLENG_8,SADC_SAMPLINGTIME_2CYCLES);
  Dis_single_test(5,SADC_SEQLENG_8); //OK
 
  printf("\r\n finish \r\n");
 while (1){						
	WDT_FeedDog();
 }

}
