/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define __MAIN_C
#include "main.h"
/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

uint32_t ErrorFlag;
uint32_t ErrorBit;
uint32_t covert_number;
uint32_t covert_number1;
uint32_t RegAddress;
char    *RegName;
  
uint8_t RNum = 0;
uint8_t TNum = 0;
#define DATA_NUMBER             (16)
uint8_t RBuffer[DATA_NUMBER] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
uint8_t TBuffer[DATA_NUMBER] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x01};

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/

void Delay_ms(uint32_t nDelay)
{
  uint32_t i;
  while(nDelay--)
  {
    for(i=0;i<2138;i++);
  }
}


void UART1_PIN_initial(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    // IO PD8_FUNC2 TX1
    GPIO_InitStruct.Pin  = GPIO_PIN_8;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.AF   = AF_FUNCTION2;
	  GPIO_InitStruct.Pull = GPIO_PULL_UP;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
//    // IO PA1_FUNC3 TX1, PA0_FUNC2 RX1
//    GPIO_InitStruct.Pin  = GPIO_PIN_1;
//    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//    GPIO_InitStruct.AF   = AF_FUNCTION3;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
//	
//    GPIO_InitStruct.AF   = AF_FUNCTION2;
//    GPIO_InitStruct.Pin = GPIO_PIN_0;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
}

void ADC_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_SADCEN);
	//PC0-AD3 PC1-AD2 PC3-AD1 PC4-AD0 
  GPIO_InitStruct.Pin  = GPIO_PIN_4;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF   = AF_FUNCTION1;
	GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
	
	//PB5-AD6 PB7-AD5 PB8-AD4
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
	
	//PA4-AD10 PA5-AD9 PA6-AD8 PA7-AD7
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_4;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
	
  CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_PGAEN);	
  PGA_Enable(PGA_CR_PGA0EN);
  PGA_Set_GAIN(PGA_CR_PGA0GAIN,PGA_CR_PGA0GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);

}

void UART1_initial(uint32_t Baud)
{		
	UART1_PIN_initial(); 
	UART_InitTypeDef UART1_InitStruct = {0};
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
}

void UART_SendTxBuf(UART_TypeDef* UARTx,uint8_t* wbuf,uint8_t len)
{
	uint8_t i;
	
	for(i=0;i<len;i++)
	{
		Delay_ms(1);
		UART_Send_Data(UARTx, *(wbuf + i) ); 
		while(0 == (UARTx->UARTSTA & 0x01) );
		UARTx->UARTSTA &= ~( (uint32_t)0x01);
	}
}

void adc_init_channel(uint32_t Channel, uint32_t SamplingTime)
{
	if (SADC_Get_SADCON(SADC) == 0) {
    
    SADC_RankInitTypeDef SADC_RankInitStruct = {0};
		
    SADC_RankInitStruct.Length = SADC_SEQLENG_1;
    SADC_RankInitStruct.Rank[0].Channel = Channel;
    SADC_RankInitStruct.Rank[0].SamplingTime = SamplingTime;
		
    SADC_RankInit(SADC, &SADC_RankInitStruct);
    
    SADC_InitTypeDef SADC_InitStruct = {0};
		
    SADC_InitStruct.State   = ENABLE;
    SADC_InitStruct.TriggerSource = SADC_ADTRIG_SADCSTR;
    SADC_InitStruct.ContMode = SADC_CONV_SINGLE;
    SADC_InitStruct.ScanMode = SADC_SADCSCAN_DISABLE;
    SADC_InitStruct.Prescaler = SADC_SADCCLK_DIV3;
    SADC_InitStruct.Discen   = DISABLE;
    SADC_Init(SADC, &SADC_InitStruct);
  }
}

void channel_single_test(uint32_t number)
{
		for(covert_number=0;covert_number<number;covert_number++){
	
      SADC_Enable_IT(SADC,SADC_SADCIE_SIGIE);	
      
    /* Start ADC group regular conversion */
      if (SADC_Get_SADCON(SADC) == 1) {
        SADC_Start(SADC);
      }
		
    /* wait end flag of scan conversions */
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SIGIF) == 0){
		  };
		
    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
	  } 

    printf("\r\n");
}

void adc_init_scan(uint32_t Length,  uint32_t SamplingTime)
{
	if (SADC_Get_SADCON(SADC) == 0) {
 
    SADC_RankInitTypeDef SADC_RankInitStruct = {0};
		
    SADC_RankInitStruct.Length = Length;
    SADC_RankInitStruct.Rank[0].Channel = SADC_CHANNEL8;
    SADC_RankInitStruct.Rank[0].SamplingTime = SADC_SAMPLINGTIME_2CYCLES;
    SADC_RankInitStruct.Rank[1].Channel = SADC_CHANNEL2;
    SADC_RankInitStruct.Rank[1].SamplingTime = SADC_SAMPLINGTIME_128CYCLES;
    SADC_RankInitStruct.Rank[2].Channel = SADC_CHANNEL3;
    SADC_RankInitStruct.Rank[2].SamplingTime = SADC_SAMPLINGTIME_32CYCLES;
    SADC_RankInitStruct.Rank[3].Channel = SADC_CHANNEL9;
    SADC_RankInitStruct.Rank[3].SamplingTime = SADC_SAMPLINGTIME_4CYCLES;
    SADC_RankInitStruct.Rank[4].Channel = SADC_CHANNEL5;
    SADC_RankInitStruct.Rank[4].SamplingTime = SADC_SAMPLINGTIME_64CYCLES;
    SADC_RankInitStruct.Rank[5].Channel = SADC_CHANNEL10;
    SADC_RankInitStruct.Rank[5].SamplingTime = SADC_SAMPLINGTIME_256CYCLES;
    SADC_RankInitStruct.Rank[6].Channel = SADC_CHANNEL7;
    SADC_RankInitStruct.Rank[6].SamplingTime = SADC_SAMPLINGTIME_16CYCLES;
    SADC_RankInitStruct.Rank[7].Channel = SADC_CHANNEL6;
    SADC_RankInitStruct.Rank[7].SamplingTime = SADC_SAMPLINGTIME_8CYCLES;
		
    SADC_RankInit(SADC, &SADC_RankInitStruct);
    
    SADC_InitTypeDef SADC_InitStruct = {0};
		
    SADC_InitStruct.State   = ENABLE;
    SADC_InitStruct.TriggerSource = SADC_ADTRIG_SADCSTR;
    SADC_InitStruct.ContMode = SADC_CONV_SINGLE;
    SADC_InitStruct.ScanMode = SADC_SADCSCAN_ENABLE;
    SADC_InitStruct.Prescaler = SADC_SADCCLK_DIV3;
    SADC_InitStruct.Discen   = DISABLE;
    SADC_Init(SADC, &SADC_InitStruct);
	
  }
}

void scan_single_test(uint32_t number)
{
		for(covert_number=0;covert_number<number;covert_number++){
	
      SADC_Enable_IT(SADC,SADC_SADCIE_SEQIE);	
      
    /* Start ADC group regular conversion */
      if (SADC_Get_SADCON(SADC) == 1) {
        SADC_Start(SADC);
      }
		
    /* wait end flag of scan conversions */
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SEQIF) == 0){
		  };
		
    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
      SADC_Clear_Flag(SADC,SADC_SADCIF_SEQIF);
	  }

    printf("\r\n");
}

void adc_init_dis(uint32_t Length,  uint32_t SamplingTime)
{
	if (SADC_Get_SADCON(SADC) == 0) {
    
    SADC_RankInitTypeDef SADC_RankInitStruct = {0};
		
    SADC_RankInitStruct.Length = Length;
    SADC_RankInitStruct.Rank[0].Channel = SADC_CHANNEL8;
    SADC_RankInitStruct.Rank[0].SamplingTime = SADC_SAMPLINGTIME_2CYCLES;
    SADC_RankInitStruct.Rank[1].Channel = SADC_CHANNEL2;
    SADC_RankInitStruct.Rank[1].SamplingTime = SADC_SAMPLINGTIME_128CYCLES;
    SADC_RankInitStruct.Rank[2].Channel = SADC_CHANNEL3;
    SADC_RankInitStruct.Rank[2].SamplingTime = SADC_SAMPLINGTIME_32CYCLES;
    SADC_RankInitStruct.Rank[3].Channel = SADC_CHANNEL9;
    SADC_RankInitStruct.Rank[3].SamplingTime = SADC_SAMPLINGTIME_4CYCLES;
    SADC_RankInitStruct.Rank[4].Channel = SADC_CHANNEL5;
    SADC_RankInitStruct.Rank[4].SamplingTime = SADC_SAMPLINGTIME_64CYCLES;
    SADC_RankInitStruct.Rank[5].Channel = SADC_CHANNEL10;
    SADC_RankInitStruct.Rank[5].SamplingTime = SADC_SAMPLINGTIME_256CYCLES;
    SADC_RankInitStruct.Rank[6].Channel = SADC_CHANNEL7;
    SADC_RankInitStruct.Rank[6].SamplingTime = SADC_SAMPLINGTIME_16CYCLES;
    SADC_RankInitStruct.Rank[7].Channel = SADC_CHANNEL6;
    SADC_RankInitStruct.Rank[7].SamplingTime = SADC_SAMPLINGTIME_8CYCLES;
		
    SADC_RankInit(SADC, &SADC_RankInitStruct);
    
    SADC_InitTypeDef SADC_InitStruct = {0};
		
    SADC_InitStruct.State   = ENABLE;
    SADC_InitStruct.TriggerSource = SADC_ADTRIG_SADCSTR;
    SADC_InitStruct.ContMode = SADC_CONV_SINGLE;
    SADC_InitStruct.ScanMode = SADC_SADCSCAN_ENABLE;
    SADC_InitStruct.Prescaler = SADC_SADCCLK_DIV3;
    SADC_InitStruct.Discen   = ENABLE;
    SADC_Init(SADC, &SADC_InitStruct);
	
  }
}

void dis_single_test(uint32_t number, uint32_t Length)
{
		for(covert_number=0;covert_number<number;covert_number++){
	
      SADC_Enable_IT(SADC,SADC_SADCIE_SEQIE);	
      
		  for(covert_number1=0;covert_number1<=(Length>>8);covert_number1++){
        SADC_Start(SADC);
        Delay_ms(1);
      }
		
    /* wait end flag of scan conversions */
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SEQIF) == 0){
		  };
		
    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
      SADC_Clear_Flag(SADC,SADC_SADCIF_SEQIF);
	  }
    printf("\r\n");
}

int main(void)
{		
	ADC_Initial();
  NVIC_SetPriority((IRQn_Type) SADC_IRQn, 1); 
  NVIC_EnableIRQ((IRQn_Type) SADC_IRQn);

	UART1_initial(115200);
	
  printf("\r\nstart \r\n");
  
  printf("\r\nSCAN SEQ \r\n");
	adc_init_scan(SADC_SEQLENG_4,SADC_SAMPLINGTIME_2CYCLES);
	scan_single_test(5);
	
	
  printf("\r\nDIS SEQ \r\n");
	adc_init_dis(SADC_SEQLENG_3,SADC_SAMPLINGTIME_2CYCLES);
	dis_single_test(5,SADC_SEQLENG_3);
  
  
  printf("\r\nSIG\r\n");
	adc_init_channel(SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  channel_single_test(5);
  
  
  printf("\r\nfinish\r\n");
 while (1){						
	WDT_FeedDog();
 }		

}
