/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                          rx32s30xx
*                                       rx32s30xx Function
*                                    All Rights Reserved
*
*
* Project      : rx32s30xx
* File         : rx32s30xx_it.c
* By           : RX_SD_Team
* Description  :
*********************************************************************************************************/
#include "main.h"
#include "rx32s11xx_it.h"

/*
*********************************************************************************************************
*                                             Global macro/Structure
*********************************************************************************************************
*/
extern __IO uint32_t aADCxConvertedData[ADC_CONVERTED_DATA_BUFFER_SIZE]; 
extern uint32_t covert_number;
/*
*********************************************************************************************************
*                                            Global variable
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                        NMI INTERRUPT HANDLER #16-14
*
*********************************************************************************************************
*/
void NMI_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        HARDFAULT INTERRUPT HANDLER #16-13
*
*********************************************************************************************************
*/
void HardFault_Handler(void)
{
    /* Go to infinite loop when Hard Fault exception occurs */
    while (1)
    {

    }
}

/*
*********************************************************************************************************
*                                        SVC INTERRUPT HANDLER #16-5
*
*********************************************************************************************************
*/
void SVC_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        PENDSV INTERRUPT HANDLER #16-2
*
*********************************************************************************************************
*/
void PendSV_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        SYSTICK INTERRUPT HANDLER #16-1
*
*********************************************************************************************************
*/
void SysTick_Handler(void)
{
	
}

/*
*********************************************************************************************************
*                                        PMU INTERRUPT HANDLER #16+0
*
*********************************************************************************************************
*/

void PMU_IRQHandler()
{

}
/*
*********************************************************************************************************
*                                   EXTI0 INTERRUPT HANDLER  #16+2
*
*********************************************************************************************************
*/

void EXTI0_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   EXTI1 INTERRUPT HANDLER  #16+3
*
*********************************************************************************************************
*/

void EXTI1_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   EXTI2 INTERRUPT HANDLER  #16+4
*
*********************************************************************************************************
*/

void EXTI2_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   EXTI3 INTERRUPT HANDLER  #16+5
*
*********************************************************************************************************
*/

void EXTI3_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   EXTI4 INTERRUPT HANDLER  #16+6
*
*********************************************************************************************************
*/

void EXTI4_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   EXTI5 INTERRUPT HANDLER  #16+7
*
*********************************************************************************************************
*/

void EXTI5_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   EXTI6 INTERRUPT HANDLER  #16+8
*
*********************************************************************************************************
*/

void EXTI6_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   UART0 INTERRUPT HANDLER  #16+9
*
*********************************************************************************************************
*/

void UART0_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   UART1 INTERRUPT HANDLER  #16+10
*
*********************************************************************************************************
*/

void UART1_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   TMR0 INTERRUPT HANDLER  #16+15
*
*********************************************************************************************************
*/

void TMR0_IRQHandler()
{


}

/*
*********************************************************************************************************
*                                   TMR1 INTERRUPT HANDLER  #16+16
*
*********************************************************************************************************
*/

void TMR1_IRQHandler()
{


}

/*
*********************************************************************************************************
*                                   TMR2 INTERRUPT HANDLER  #16+17
*
*********************************************************************************************************
*/

void TMR2_IRQHandler()
{


}

/*
*********************************************************************************************************
*                                   TMR3 INTERRUPT HANDLER  #16+18
*
*********************************************************************************************************
*/

void TMR3_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                    RTC INTERRUPT HANDLER  #16+20
*
*********************************************************************************************************
*/

void RTC_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                    I2C INTERRUPT HANDLER  #16+21
*
*********************************************************************************************************
*/

void I2C_IRQHandler()
{

}


/*
*********************************************************************************************************
*                                 EXTI7 INTERRUPT HANDLER  #16+28
*
*********************************************************************************************************/

void EXTI7_IRQHandler(void)
{

}

/*
*********************************************************************************************************
*                                 EXTI8 INTERRUPT HANDLER  #16+29
*
*********************************************************************************************************
*/

void EXTI8_IRQHandler(void)
{

}


/*
*********************************************************************************************************
*                                 DMA INTERRUPT HANDLER  #16+31
*
*********************************************************************************************************
*/
void DMA_IRQHandler(void)
{
    if(DMA_Get_Flag(DMA,DMA_DMAIF_TCIF0) == 1)                                    /*!< TC0 complete Interrupt */
    {
      if((READ_REG(SADC->SADC0DAT) != aADCxConvertedData[0]) |
         (READ_REG(SADC->SADC1DAT) != aADCxConvertedData[1]) |
         (READ_REG(SADC->SADC2DAT) != aADCxConvertedData[2]) |
         (READ_REG(SADC->SADC3DAT) != aADCxConvertedData[3]) |
         (READ_REG(SADC->SADC4DAT) != aADCxConvertedData[4]) |
         (READ_REG(SADC->SADC5DAT) != aADCxConvertedData[5]) |
         (READ_REG(SADC->SADC6DAT) != aADCxConvertedData[6]) |
         (READ_REG(SADC->SADC7DAT) != aADCxConvertedData[7]) ){
        printf("SADC0DAT is %x \r\n",READ_REG(SADC->SADC0DAT));
        printf("SADC1DAT is %x \r\n",READ_REG(SADC->SADC1DAT));
        printf("SADC2DAT is %x \r\n",READ_REG(SADC->SADC2DAT));
        printf("SADC3DAT is %x \r\n",READ_REG(SADC->SADC3DAT));
        printf("SADC4DAT is %x \r\n",READ_REG(SADC->SADC4DAT));
        printf("SADC5DAT is %x \r\n",READ_REG(SADC->SADC5DAT));
        printf("SADC6DAT is %x \r\n",READ_REG(SADC->SADC6DAT));
        printf("SADC7DAT is %x \r\n",READ_REG(SADC->SADC7DAT));		

        printf("DMA0 is %x\r\n",aADCxConvertedData[0]);
        printf("DMA1 is %x\r\n",aADCxConvertedData[1]);
        printf("DMA2 is %x\r\n",aADCxConvertedData[2]);
        printf("DMA3 is %x\r\n",aADCxConvertedData[3]);
        printf("DMA4 is %x\r\n",aADCxConvertedData[4]);
        printf("DMA5 is %x\r\n",aADCxConvertedData[5]);
        printf("DMA6 is %x\r\n",aADCxConvertedData[6]);
        printf("DMA7 is %x\r\n",aADCxConvertedData[7]);	
      }	
       DMA_Disable_IT(DMA,DMA_DMAIE_TCIE0);
//  	DMA_ClearITFlag(DMA,DMA_DMAIF_TCIF0);
    }
    if(DMA_Get_Flag(DMA,DMA_DMAIF_TCIF1) == 1)                                    /*!< TC1 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_TCIF1);
    }

    if(DMA_Get_Flag(DMA,DMA_DMAIF_TCIF2) == 1)                                    /*!< TC2 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_TCIF2);
    }

    if(DMA_Get_Flag(DMA,DMA_DMAIF_BCIF0) == 1)                                    /*!< BC1 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_BCIF0);
    }

    if(DMA_Get_Flag(DMA,DMA_DMAIF_BCIF1) == 1)                                    /*!< BC1 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_BCIF1);
    }

    if(DMA_Get_Flag(DMA,DMA_DMAIF_BCIF2) == 1)                                    /*!< BC2 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_BCIF2);
    }
		
    if(DMA_Get_Flag(DMA,DMA_DMAIF_TEIF0) == 1)                                    /*!< TE0 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_TEIF0);
    }

    if(DMA_Get_Flag(DMA,DMA_DMAIF_TEIF1) == 1)                                    /*!< TE1 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_TEIF1);
    }

    if(DMA_Get_Flag(DMA,DMA_DMAIF_TEIF2) == 1)                                    /*!< TE2 complete Interrupt*/
    {
	   DMA_Clear_Flag(DMA,DMA_DMAIF_TEIF2);
    }
      printf("DMA %d finish\r\n",covert_number);	
}





