/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define __MAIN_C
#include "main.h"
/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

uint32_t ErrorFlag;
uint32_t ErrorBit;
uint32_t covert_number;
uint32_t RegAddress;
char    *RegName;
  
uint8_t RNum = 0;
uint8_t TNum = 0;
#define DATA_NUMBER             (16)
uint8_t RBuffer[DATA_NUMBER] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
uint8_t TBuffer[DATA_NUMBER] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x01};

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/

void Delay_ms(uint32_t nDelay)
{
  uint32_t i;
  while(nDelay--)
  {
    for(i=0;i<2138;i++);
  }
}


void UART1_PIN_initial(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    // IO PD8_FUNC2 TX1
    GPIO_InitStruct.Pin  = GPIO_PIN_8;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.AF   = AF_FUNCTION2;
	  GPIO_InitStruct.Pull = GPIO_PULL_UP;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
//    // IO PA1_FUNC3 TX0, PA0_FUNC2 RX1
//    GPIO_InitStruct.Pin  = GPIO_PIN_1;
//    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//    GPIO_InitStruct.AF   = AF_FUNCTION3;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
//	
//    GPIO_InitStruct.AF   = AF_FUNCTION2;
//    GPIO_InitStruct.Pin = GPIO_PIN_0;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
}

void ADC_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_SADCEN);
	//PC0-AD3 PC1-AD2 PC3-AD1 PC4-AD0 
  GPIO_InitStruct.Pin  = GPIO_PIN_4;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF   = AF_FUNCTION1;
	GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
	
	//PB5-AD6 PB7-AD5 PB8-AD4
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
	
	//PA4-AD10 PA5-AD9 PA6-AD8 PA7-AD7
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_4;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
	
  CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_PGAEN);	
  PGA_Enable(PGA_CR_PGA0EN);
  PGA_Set_GAIN(PGA_CR_PGA0GAIN,PGA_CR_PGA0GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
	
}

void UART1_initial(uint32_t Baud)
{		
	UART1_PIN_initial(); 
	UART_InitTypeDef UART1_InitStruct = {0};
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
}

void UART_SendTxBuf(UART_TypeDef* UARTx,uint8_t* wbuf,uint8_t len)
{
	uint8_t i;
	
	for(i=0;i<len;i++)
	{
		Delay_ms(1);
		UART_Send_Data(UARTx, *(wbuf + i) ); 
		while(0 == (UARTx->UARTSTA & 0x01) );
		UARTx->UARTSTA &= ~( (uint32_t)0x01);
	}
}

void adc_init(uint32_t TriggerSource, uint32_t Channel, uint32_t SamplingTime)
{
	if (SADC_Get_SADCON(SADC) == 0) {
    
    SADC_RankInitTypeDef SADC_RankInitStruct = {0};
		
    SADC_RankInitStruct.Length = SADC_SEQLENG_1;
    SADC_RankInitStruct.Rank[0].Channel = Channel;
    SADC_RankInitStruct.Rank[0].SamplingTime = SamplingTime;
		
    SADC_RankInit(SADC, &SADC_RankInitStruct);
    
    SADC_InitTypeDef SADC_InitStruct = {0};
		
    SADC_InitStruct.State   = ENABLE;
    SADC_InitStruct.TriggerSource = TriggerSource;
    SADC_InitStruct.ContMode = SADC_CONV_SINGLE;
    SADC_InitStruct.ScanMode = SADC_SADCSCAN_DISABLE;
    SADC_InitStruct.Prescaler = SADC_SADCCLK_DIV3;
    SADC_InitStruct.Discen   = DISABLE;
    SADC_Init(SADC, &SADC_InitStruct);
	
  }
}

void soft_trig_test(uint32_t number, uint32_t TriggerSource)
{
		for(covert_number=0;covert_number<number;covert_number++){
	
	    switch(TriggerSource){
	      case (SADC_ADTRIG_SADCSTR): 
           SADC_Start(SADC); 
        break;
		    case (SADC_ADTRIG_RTC2): 
           SADC_Start(SADC); 
   	    break;
		    case (SADC_ADTRIG_INT3): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_INT7): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TMR0):  
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TMR1): 
           SADC_Start(SADC);  
	      break;
		    case (SADC_ADTRIG_TIM8_CH4): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH5): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH1): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH2): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH3): 
           SADC_Start(SADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH4_CH5): 
           SADC_Start(SADC); 
	      break;
      }
    /* wait end flag of scan conversions */
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SIGIF) == 0){
		  };
	    printf("%d SADC0DAT is %x \r\n",covert_number,SADC->SADCDAT);
		
    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
	  }
    printf("\r\n");
}

void trig_test(uint32_t number, uint32_t TriggerSource)
{
		for(covert_number=0;covert_number<number;covert_number++){
	
	    switch(TriggerSource){
	      case (SADC_ADTRIG_SADCSTR): 
           SADC_Start(SADC); 
        break;
		    case (SADC_ADTRIG_RTC2): 
//           SADC_Start(ADC); 
   	    break;
		    case (SADC_ADTRIG_INT3): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_INT7): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TMR0):  
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TMR1): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH4): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH5): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH1): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH2): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH3): 
//           SADC_Start(ADC); 
	      break;
		    case (SADC_ADTRIG_TIM8_CH4_CH5): 
//           SADC_Start(ADC); 
	      break;
      }
    /* wait end flag of scan conversions */
      while (SADC_Get_Flag(SADC,SADC_SADCIF_SIGIF) == 0){
	       WDT_FeedDog();
       }
	    printf("%d SADC0DAT is %x \r\n",covert_number,SADC->SADCDAT);
		
    /* Clear flag ADC group regular end of scan conversions */
      SADC_Clear_Flag(SADC,SADC_SADCIF_SIGIF);
	  }
    printf("\r\n");
}
/**
  * @brief  TIM1_PWM_Init
  * @param  arr psc
  AF1:
  PD0:TIM_CH2N  PD1:TIM_CH2
  PD2:TIM_CH1N  PD3:TIM_CH1
  PC9:TIM_CH3N  PC10:TIM_CH3
  PC8:TIM_BKIN
  AF2:
  PC6:TIM_CH4  PC7:TIIM8_CH5
  AF3:
  PD4:TIM_ETR
  */
void TIM_PWM_Init(uint16_t arr, uint16_t ccr, uint16_t psc)
{
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_TIM8EN);
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	/*---------------------TIM8---------------------*/
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct = {0};
	TIM_OCInitTypeDef TIM_OCInitStruct = {0};
	/***************************/
	/* Time base configuration */
	/***************************/
	TIM_TimeBaseInitStruct.CounterMode       = TIM_COUNTERMODE_CENTER_UP;
	TIM_TimeBaseInitStruct.Period            = arr;
	TIM_TimeBaseInitStruct.Prescaler         = psc;
	TIM_TimeBaseInitStruct.ClockDivision     = TIM_CKD_DIV1;
	TIM_TimeBaseInitStruct.RepetitionCounter = 1;
	TIM_TimeBaseInit(TIM8, &TIM_TimeBaseInitStruct);
	/*---------------------CC1 CC2 CC3---------------------*/
	TIM_OCInitStruct.OCMode       = TIM_OCMODE_PWM2;
  TIM_OCInitStruct.OutputState  = TIM_OutputState_Enable;
  TIM_OCInitStruct.OutputNState = TIM_OutputNState_Enable;
	/*-------upper arm-------*/
	#ifdef WH_PIN_IO_MODE_LOW_ACTIVE
	TIM_OCInitStruct.OCPolarity  = TIM_OCPolarity_Low;
	TIM_OCInitStruct.OCIdleState = TIM_OCIdleState_Set;
	#else
  TIM_OCInitStruct.OCPolarity  = TIM_OCPolarity_High;
  TIM_OCInitStruct.OCIdleState = TIM_OCIdleState_Reset;
	#endif
	/*-------lower arm-------*/
	#ifdef WL_PIN_IO_MODE_LOW_ACTIVE
	TIM_OCInitStruct.OCNPolarity  = TIM_OCNPolarity_Low;
	TIM_OCInitStruct.OCNIdleState = TIM_OCNIdleState_Set;
	#else
	TIM_OCInitStruct.OCNPolarity  = TIM_OCNPolarity_High;
	TIM_OCInitStruct.OCNIdleState = TIM_OCNIdleState_Reset;
	#endif
	TIM_OCInitStruct.Pulse = ccr;
	TIM_OC1Init(TIM8, &TIM_OCInitStruct);
	TIM_OC2Init(TIM8, &TIM_OCInitStruct);
	TIM_OC3Init(TIM8, &TIM_OCInitStruct);

	/*---------------------CC4 CC5---------------------*/
	TIM_OCInitStruct.OCMode = TIM_OCMODE_PWM2;
	TIM_OCInitStruct.OCIdleState = TIM_OCIdleState_Set;
	TIM_OCInitStruct.OCPolarity = TIM_OCPolarity_High;
	TIM_OCInitStruct.OCNPolarity = TIM_OCNPolarity_High;
	TIM_OCInitStruct.Pulse = ccr;
	TIM_OC4Init(TIM8, &TIM_OCInitStruct);
//	TIM_OC5Init(TIM8, &TIM_OCInitStruct);

	/*  Enable register preload for every output channels */
	TIM_Enable_OC_Preload(TIM8, TIM_CHANNEL_CH1);
	TIM_Enable_OC_Preload(TIM8, TIM_CHANNEL_CH2);
	TIM_Enable_OC_Preload(TIM8, TIM_CHANNEL_CH3);
	TIM_Enable_OC_Preload(TIM8, TIM_CHANNEL_CH4);
	TIM_Enable_OC_Preload(TIM8, TIM_CHANNEL_CH5);

	TIM_Enable_ARRPreload(TIM8);


	/**********************************/
	/* Start output signal generation */
	/**********************************/
	/* Enable outputs OC1, OC1N, OC2, OC2N, OC3, OC3N and OC4, OC5 */
	TIM_Enable_CC_Channel(TIM8, TIM_CHANNEL_CH1  |
														  TIM_CHANNEL_CH1N |
															TIM_CHANNEL_CH2  |
															TIM_CHANNEL_CH2N |
															TIM_CHANNEL_CH3  |
															TIM_CHANNEL_CH3N |
															TIM_CHANNEL_CH4  |
															TIM_CHANNEL_CH5);  
	/* Main output enable */
	TIM_Enable_MOE(TIM8);
	/* Enable counter */
	TIM_Enable_CEN(TIM8);
	
	TIM8->EGR = TIM_EGR_BG; // generate 1st break event to correct output idle state
  
  TIM_Disable_BRK(TIM8);
	/*-----------------GPIO------------------*/
	GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
	GPIO_InitStruct.AF   = AF_FUNCTION1;
  GPIO_InitStruct.Pull = GPIO_FLOATING;
	//TIM_CH3N
	GPIO_InitStruct.Pin = GPIO_PIN_9;
	GPIO_Init(GPIOC, &GPIO_InitStruct);
	//TIM_CH3
	GPIO_InitStruct.Pin = GPIO_PIN_10;
	GPIO_Init(GPIOC, &GPIO_InitStruct);
  //TIM_CH2N
	GPIO_InitStruct.Pin = GPIO_PIN_0;
	GPIO_Init(GPIOD, &GPIO_InitStruct);
	//TIM_CH2
	GPIO_InitStruct.Pin = GPIO_PIN_1;
	GPIO_Init(GPIOD, &GPIO_InitStruct);
  //TIM_CH1N
	GPIO_InitStruct.Pin = GPIO_PIN_2;
	GPIO_Init(GPIOD, &GPIO_InitStruct);
  //TIM_CH1
	GPIO_InitStruct.Pin = GPIO_PIN_3;
	GPIO_Init(GPIOD, &GPIO_InitStruct);
	GPIO_InitStruct.AF   = AF_FUNCTION2;
  //TIM_CH4
	GPIO_InitStruct.Pin = GPIO_PIN_6;
	GPIO_Init(GPIOC, &GPIO_InitStruct);
  //TIM_CH5
	GPIO_InitStruct.Pin = GPIO_PIN_7;
	GPIO_Init(GPIOC, &GPIO_InitStruct);
	/*--------------ENABLE TIM8 OUTPUT------------------*/
  Delay_ms(2);
	TIM_Enable_MOE(TIM8);
}

int main(void)
{		
	ADC_Initial();

	UART1_initial(115200);
  printf("\r\n start\r\n");
	
  printf("\r\n SOFT SADC_ADTRIG_SADCSTR\r\n");
	adc_init(SADC_ADTRIG_SADCSTR,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_SADCSTR);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_RTC2\r\n");
	adc_init(SADC_ADTRIG_RTC2,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_RTC2);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_INT3\r\n");
	adc_init(SADC_ADTRIG_INT3,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_INT3);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_INT7\r\n");
	adc_init(SADC_ADTRIG_INT7,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_INT7);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TMR0\r\n");
	adc_init(SADC_ADTRIG_TMR0,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TMR0);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TMR1\r\n");
	adc_init(SADC_ADTRIG_TMR1,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TMR1);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TIM8_CH4\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH4,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TIM8_CH4);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TIM8_CH5\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH5,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TIM8_CH5);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TIM8_CH1\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH1,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TIM8_CH1);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TIM8_CH2\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH2,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TIM8_CH2);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TIM8_CH3\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH3,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TIM8_CH3);
	SADC_Disable(SADC);  
	
  printf("\r\n SOFT SADC_ADTRIG_TIM8_CH4_CH5\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH4_CH5,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  soft_trig_test(5,SADC_ADTRIG_TIM8_CH4_CH5);
	SADC_Disable(SADC);  
	
	
  printf("\r\n TRIG SADC_ADTRIG_SADCSTR\r\n");
	adc_init(SADC_ADTRIG_SADCSTR,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_SADCSTR);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_RTC2\r\n");
  RTC->RTCCON  |= 0x8060;
	adc_init(SADC_ADTRIG_RTC2,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_RTC2);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_INT3\r\n");
  GPIO_InitTypeDef GPIO_InitStruct;
	//PD7-INT3
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF = AF_FUNCTION3;
  GPIO_InitStruct.Pull = GPIO_PULL_UP;
  GPIO_Init(GPIOD, &GPIO_InitStruct);
  EXTI->EXTIE     = 0x08;                    //INT3 FALLING ENABLE
	adc_init(SADC_ADTRIG_INT3,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_INT3);
	SADC_Disable(SADC);  
  EXTI->EXTIE     = 0x00;                    
	
  printf("\r\n TRIG SADC_ADTRIG_INT7\r\n");
	//PC1-INT7
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF = AF_FUNCTION3;
  GPIO_InitStruct.Pull = GPIO_PULL_UP;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  EXTI->EXTIE2     = 0x01;                    //INT7 FALLING ENABLE
	adc_init(SADC_ADTRIG_INT7,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_INT7);
	SADC_Disable(SADC);  
  EXTI->EXTIE2     = 0x00;   
	
  printf("\r\n TRIG SADC_ADTRIG_TMR0\r\n");
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_TMR0EN);        // enable TMR0_clk
  TMR0->TMRPRD = 0x8d;         
  MODIFY_REG(TMR0->TMRCON, TMR_TMRCON_MODE, TMR_TMRCON_MODE_PERIOD);
  SET_BIT(TMR0->TMRCON,TMR_TMRCON_CNTEN);           // Enable counter 
	adc_init(SADC_ADTRIG_TMR0,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TMR0);
	SADC_Disable(SADC);  
  CLEAR_BIT(TMR0->TMRCON,TMR_TMRCON_CNTEN);         // Disable counter 
	
  printf("\r\n TRIG SADC_ADTRIG_TMR1\r\n");
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_TMR1EN);        // enable TMR0_clk
  TMR1->TMRPRD = 0x8d;         
  MODIFY_REG(TMR1->TMRCON, TMR_TMRCON_MODE, TMR_TMRCON_MODE_PERIOD);
  SET_BIT(TMR1->TMRCON,TMR_TMRCON_CNTEN);           // Enable counter 
	adc_init(SADC_ADTRIG_TMR1,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TMR1);
	SADC_Disable(SADC);  
  CLEAR_BIT(TMR1->TMRCON,TMR_TMRCON_CNTEN);         // Disable counter 
	
  printf("\r\n TRIG SADC_ADTRIG_TIM8_CH4\r\n");
	TIM_PWM_Init(4000,3000,0);
	adc_init(SADC_ADTRIG_TIM8_CH4,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TIM8_CH4);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_TIM8_CH5\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH5,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TIM8_CH5);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_TIM8_CH4_CH5\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH4_CH5,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TIM8_CH4_CH5);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_TIM8_CH1\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH1,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TIM8_CH1);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_TIM8_CH2\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH2,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TIM8_CH2);
	SADC_Disable(SADC);  
	
  printf("\r\n TRIG SADC_ADTRIG_TIM8_CH3\r\n");
	adc_init(SADC_ADTRIG_TIM8_CH3,SADC_CHANNEL0,SADC_SAMPLINGTIME_2CYCLES);
  trig_test(5,SADC_ADTRIG_TIM8_CH3);
	SADC_Disable(SADC);  
	
  printf("\r\n finish\r\n");
 while (1){						
	WDT_FeedDog();
 }		

}
