/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define __MAIN_C

#include "main.h"

/*
*********************************************************************************************************
*                                           Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/



uint8_t rxbuf[256];
uint8_t rxlen;
/*
*********************************************************************************************************
*                                           Global Function declaration
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                              MAIN
*
*********************************************************************************************************
*/
void delay_ms(uint16_t x) //delay 1ms
{
    uint16_t i, j;
    for (i = 0; i < x; i++)
    {
        for (j = 0; j < (3700); j++);
    }
}

void UART1_PIN_Initial(void)
{
	/* TX1 -> PD8*/
	GPIO_InitTypeDef GPIO_InitStruct = {0};
  GPIO_InitStruct.Pin   = GPIO_PIN_8;
  GPIO_InitStruct.Mode  = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF    = AF_FUNCTION2;
	GPIO_InitStruct.Pull  = GPIO_FLOATING;
  GPIO_Init(GPIOD, &GPIO_InitStruct);
}

void UART1_Initial(void)
{
	UART_InitTypeDef UART1_InitStruct = {0};
	UART1_InitStruct.Baudrate  = 115200;
	UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
	UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
	UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
	UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
	UART_Init(UART1, &UART1_InitStruct);

	UART_Enable(UART1,UART_UARTCON_TXEN);
}

void CMP4_GPIO_Init(void)
{
  GPIO_InitTypeDef CMP4_GPIO_InitStruct = {0};
	
	/*****CMP4 IO1P*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_3;
  CMP4_GPIO_InitStruct.Mode  = GPIO_MODE_AF_PP;
	CMP4_GPIO_InitStruct.AF = AF_FUNCTION1;
	CMP4_GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOC, &CMP4_GPIO_InitStruct);
	
	/*****CMP4 IO1N*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_3;
  GPIO_Init(GPIOC, &CMP4_GPIO_InitStruct);
	
	/*****CMP4 IO2P*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_0;
  GPIO_Init(GPIOC, &CMP4_GPIO_InitStruct);
	
	/*****CMP4 IO2N*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_1;
  GPIO_Init(GPIOC, &CMP4_GPIO_InitStruct);
	
	/*****CMP4 IO3P*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_7;
  GPIO_Init(GPIOB, &CMP4_GPIO_InitStruct);
	
	/*****CMP4 IO3N*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_8;
  GPIO_Init(GPIOB, &CMP4_GPIO_InitStruct);
	
	/*****CMP4 OUT*****/
  CMP4_GPIO_InitStruct.Pin   = GPIO_PIN_4;
	CMP4_GPIO_InitStruct.AF = AF_FUNCTION3;
  CMP4_GPIO_InitStruct.Pull = GPIO_PULL_DOWN;
  GPIO_Init(GPIOA, &CMP4_GPIO_InitStruct);
}

int main(void)
{
	CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_CMP4EN);
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);
  
  UART1_PIN_Initial();//Config UART1 pin
  UART1_Initial();//Config UART1
  CMP4_GPIO_Init();//Config CMP4 pin

	/*--------CMP4 Initial Structure-------*/
	CMP_InitTypeDef CMP_InitStruct = {0};
	CMP_InitStruct.Mode 	  = CMP_CR1_MODE_High;
	CMP_InitStruct.Pol  	  = CMP_CR1_POL_Positive;
	CMP_InitStruct.OFLT 	  = CMP_CR1_OFLT_1;
	CMP_InitStruct.Rhyst	  = CMP_CR1_RHYST_0mV;
	CMP_InitStruct.Fhyst	  = CMP_CR1_FHYST_0mV;
	CMP_InitStruct.CRV      = CMP_CR2_CRV_SEL_16_20;
	CMP_InitStruct.CRV_En   = DISABLE;
	CMP_InitStruct.CRV_Src  = CMP_CR2_CRV_SRC_AVCC;
	CMP_InitStruct.INM      = CMP_CR2_INM_SEL_PC4;
	CMP_InitStruct.INP      = CMP_CR2_INP_SEL_PC3;
	CMP_Init(CMP4, &CMP_InitStruct);//Config CMP4
  
	CMP_Enable(CMP4);//Enable CMP4
  
  printf("\r\n***********  rx32s11xx Test ***********\r\n\r\n");
  printf("\r\n***********  CMP4 Test ***********\r\n\r\n");
	
  /* Function Test
	2.5V         -> PC4
	2.4V to 2.6V -> PC3
	PA4 -> LOW to HIGH
	*/
  while (1)
  {
    WDT_FeedDog();
		printf("CMP4_OUT:%d\r\n",CMP_Read_OUT(CMP4));
		delay_ms(500);
  }
}




