/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                               rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_it.c
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  :Only rx32s11xx
*********************************************************************************************************
*/
#include "main.h"
#include "rx32s11xx_it.h"

/*
*********************************************************************************************************
*                                           Global macro/Structure
*********************************************************************************************************
*/
#define EXTI_Rising_Edge_Interrupt
//#define EXTI_Falling_Edge_Interrupt

/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                           Global Function declaration
*********************************************************************************************************
*/



/*
*********************************************************************************************************
*                                        NMI INTERRUPT HANDLER #16-14
*
*********************************************************************************************************
*/
void NMI_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        HARDFAULT INTERRUPT HANDLER #16-13
*
*********************************************************************************************************
*/
void HardFault_Handler(void)
{
		printf("!!! Hard Fault !!!\r\n");
    /* Go to infinite loop when Hard Fault exception occurs */
    while (1)
    {

    }
}

/*
*********************************************************************************************************
*                                        SVC INTERRUPT HANDLER #16-5
*
*********************************************************************************************************
*/
void SVC_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        PENDSV INTERRUPT HANDLER #16-2
*
*********************************************************************************************************
*/
void PendSV_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        SYSTICK INTERRUPT HANDLER #16-1
*
*********************************************************************************************************
*/
void SysTick_Handler(void)
{
  if((SysTick->CTRL & 0x10000)!=0)
		{

		}			

}

/*
*********************************************************************************************************
*                                        PMU INTERRUPT HANDLER #16+0
*
*********************************************************************************************************
*/

void PMU_IRQHandler()
{

}


/*
*********************************************************************************************************
*                                   EXTI0 INTERRUPT HANDLER  #16+2
*
*********************************************************************************************************
*/
uint32_t exti_cnt = 0;
void EXTI0_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_0)!= 0)           
	{
		printf("EXTI0_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_0) != 0) 					
	{
		printf("EXTI0_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_0);
	EXTI_Clear_RisingFlag(EXTI_0);
}

/*
*********************************************************************************************************
*                                   EXTI1 INTERRUPT HANDLER  #16+3
*
*********************************************************************************************************
*/

void EXTI1_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_1)!= 0)           
	{
		printf("EXTI1_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_1) != 0) 					
	{
		printf("EXTI1_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_1);
	EXTI_Clear_RisingFlag(EXTI_1);
}

/*
*********************************************************************************************************
*                                   EXTI2 INTERRUPT HANDLER  #16+4
*
*********************************************************************************************************
*/

void EXTI2_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_2)!= 0)           
	{
		printf("EXTI2_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_2) != 0) 					
	{
		printf("EXTI2_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_2);
	EXTI_Clear_RisingFlag(EXTI_2);
}

/*
*********************************************************************************************************
*                                   EXTI3 INTERRUPT HANDLER  #16+5
*
*********************************************************************************************************
*/

void EXTI3_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
  if(EXTI_Get_FallingFlag(EXTI_3)!= 0)           
	{
		printf("EXTI3_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_3) != 0) 					
	{
		printf("EXTI3_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_3);
	EXTI_Clear_RisingFlag(EXTI_3);
}

/*
*********************************************************************************************************
*                                   EXTI4 INTERRUPT HANDLER  #16+6
*
*********************************************************************************************************
*/

void EXTI4_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_4)!= 0)           
	{
		printf("EXTI4_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_4) != 0) 					
	{
		printf("EXTI4_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_4);
	EXTI_Clear_RisingFlag(EXTI_4);
}

/*
*********************************************************************************************************
*                                   EXTI5 INTERRUPT HANDLER  #16+7
*
*********************************************************************************************************
*/

void EXTI5_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_5)!= 0)           
	{
		printf("EXTI5_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_5) != 0) 					
	{
		printf("EXTI5_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_5);
	EXTI_Clear_RisingFlag(EXTI_5);
}

/*
*********************************************************************************************************
*                                   EXTI6 INTERRUPT HANDLER  #16+8
*
*********************************************************************************************************
*/

void EXTI6_IRQHandler()
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_6)!= 0)           
	{
		printf("EXTI6_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_6) != 0) 					
	{
		printf("EXTI6_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_6);
	EXTI_Clear_RisingFlag(EXTI_6);
}

/*
*********************************************************************************************************
*                                 EXTI7 INTERRUPT HANDLER  #16+28
*
*********************************************************************************************************
*/
void EXTI7_IRQHandler(void)
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_7)!= 0)           
	{
		printf("EXTI7_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_7) != 0) 					
	{
		printf("EXTI7_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_7);
	EXTI_Clear_RisingFlag(EXTI_7);
}

/*
*********************************************************************************************************
*                                 EXTI8 INTERRUPT HANDLER  #16+29
*
*********************************************************************************************************
*/
void EXTI8_IRQHandler(void)
{
#ifdef EXTI_Falling_Edge_Interrupt
	if(EXTI_Get_FallingFlag(EXTI_8)!= 0)           
	{
		printf("EXTI8_FALLING:%d\r\n",exti_cnt++);
	}
#elif defined EXTI_Rising_Edge_Interrupt
	if(EXTI_Get_RisingFlag(EXTI_8) != 0) 					
	{
		printf("EXTI8_RISING:%d\r\n",exti_cnt++);
	}
#endif
	EXTI_Clear_FallingFlag(EXTI_8);
	EXTI_Clear_RisingFlag(EXTI_8);
}

/*
*********************************************************************************************************
*                                   UART1 INTERRUPT HANDLER  #16+10
*
*********************************************************************************************************
*/

void UART1_IRQHandler()
{
	
}



/*
*********************************************************************************************************
*                                   TIMER_0 INTERRUPT HANDLER  #16+15
*
*********************************************************************************************************
*/

void TMR0_IRQHandler()
{



}

/*
*********************************************************************************************************
*                                   TIMER_1 INTERRUPT HANDLER  #16+16
*
*********************************************************************************************************
*/

void TMR1_IRQHandler()
{


}

/*
*********************************************************************************************************
*                                   TIMER_2 INTERRUPT HANDLER  #16+17
*
*********************************************************************************************************
*/

void TMR2_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   TIMER_3 INTERRUPT HANDLER  #16+18
*
*********************************************************************************************************
*/

void TMR3_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                    RTC INTERRUPT HANDLER  #16+20
*
*********************************************************************************************************
*/

void RTC_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                    I2C INTERRUPT HANDLER  #16+21
*
*********************************************************************************************************
*/

void I2C_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                 DMA INTERRUPT HANDLER  #16+31
*
*********************************************************************************************************
*/
void DMA_IRQHandler(void)
{

}





