/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#include "main.h"

/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

uint32_t Temp_Word = 0;
uint16_t Temp_HalfWord = 0;
uint16_t Temp_Array_HalfWord[256] = {0};
uint16_t Temp_Array_HalfWord_1[256] = {0};
uint8_t Temp_Byte = 0, Temp_Byte_1 = 0, Temp_Byte_2 = 0;
uint8_t Temp_Array_Byte[256] = {0};
void (*func_p)(void);

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/
void USART1_Init(uint32_t srel);
void USART_Send_Byte(uint8_t val);
uint8_t USART_Receive_Byte(void);

void Program_Main_Flash(uint32_t addr, uint32_t* data, uint32_t size);

void ProbeUsart_Cmd_Get(void);
void ProbeUsart_Cmd_GID(void);
void ProbeUsart_Cmd_WM(void);
void ProbeUsart_Cmd_Go(void);

int main(void)
{
  SysTick->LOAD  = (uint32_t)(0x80000);     /* set reload register */
  SysTick->VAL   = 0UL;                     /* Load the SysTick Counter Value */
  
  GPIO_Set_PinMode(GPIOA, GPIO_PIN_0, GPIO_MODE);
  GPIO_Set_DIR(GPIOA, GPIO_PIN_0, GPIO_INPUT);
  GPIO_Set_INPUTUP(GPIOA, GPIO_PIN_0, GPIO_FLOATING);
  
  while(GPIO_Get_PTDAT(GPIOA, GPIO_PIN_0)){WDT_FeedDog();}
  while(!GPIO_Get_PTDAT(GPIOA, GPIO_PIN_0)){WDT_FeedDog();}
  SysTick->CTRL  = 0x05;
  while(GPIO_Get_PTDAT(GPIOA, GPIO_PIN_0)){WDT_FeedDog();}
  Temp_Word = SysTick->VAL;
	Temp_Word = 0x80000 - Temp_Word;
	Temp_Word = Temp_Word/0x07;
  Temp_Word = Temp_Word/2 - 1;
  USART1_Init(Temp_Word);
  USART_Send_Byte(Back_ACK);
  
  while (1)
  {
    Temp_Byte = USART_Receive_Byte(); //wait for command
    switch(Temp_Byte)
		{
			case Cmd_Get:
				ProbeUsart_Cmd_Get();
			break;
			case Cmd_GID:
				ProbeUsart_Cmd_GID();
			break;
			case Cmd_WM:
				ProbeUsart_Cmd_WM();
			break;
      case Cmd_Go:
				ProbeUsart_Cmd_Go();
			break;
			default:
				USART_Send_Byte(Back_NACK);
			break;
		}
    WDT_FeedDog();
  }
}

void ProbeUsart_Cmd_Get(void)
{
	Temp_Byte = ~USART_Receive_Byte();
	if(Temp_Byte == Cmd_Get)
	{
		USART_Send_Byte(Back_ACK);
		USART_Send_Byte(0x04);
		USART_Send_Byte(Bootloader_Version);
		USART_Send_Byte(Cmd_Get);
		USART_Send_Byte(Cmd_GID);
		USART_Send_Byte(Cmd_WM);
    USART_Send_Byte(Cmd_Go);
		USART_Send_Byte(Back_ACK);
	}
	else
	{
		USART_Send_Byte(Back_NACK);
	}
}

void ProbeUsart_Cmd_GID(void)
{
	Temp_Byte = ~USART_Receive_Byte();
	if(Temp_Byte == Cmd_GID)
	{
		Temp_HalfWord = *(__IO uint32_t*)(0x4000FF00);
		USART_Send_Byte(Back_ACK);
		USART_Send_Byte(0x01);
		USART_Send_Byte((uint8_t)(Temp_HalfWord >> 8));
		USART_Send_Byte((uint8_t)Temp_HalfWord);
		USART_Send_Byte(Back_ACK);
	}
	else
	{
		USART_Send_Byte(Back_NACK);
	}
}

void ProbeUsart_Cmd_Go(void)
{
  Temp_Byte = ~USART_Receive_Byte();
  if(Temp_Byte == Cmd_Go)
  {
    Temp_Word = *(__IO uint32_t*)(0x00000FC0);
		if((Temp_Word & 0x00F0FF00) == 0x00F0FF00)	//Read Protect
    {
      USART_Send_Byte(Back_ACK);
      Temp_Byte_1 = 0x00;
			for(Temp_Byte = 0; Temp_Byte < 5; Temp_Byte++)	//Receive Address
			{
				Temp_Array_Byte[Temp_Byte] = USART_Receive_Byte();
				Temp_Byte_1 = Temp_Byte_1^Temp_Array_Byte[Temp_Byte];	//XOR CheckSum
			}
      USART_Send_Byte(Back_ACK);
      Temp_Word = (((uint32_t)Temp_Array_Byte[0] << 24) | ((uint32_t)Temp_Array_Byte[1] << 16) | ((uint32_t)Temp_Array_Byte[2] << 8) | (uint32_t)Temp_Array_Byte[3]);
      if((Temp_Byte_1 == 0x00)&&(Temp_Word <= (0x00000000 + 32*1024)))
      {
        USART_Send_Byte(Back_ACK);
        GPIO_DeInit(GPIOA);
        UART_DeInit(UART1);
        CMU_Disable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);
        Temp_Word = Temp_Word + 1;
        func_p = (void (*)(void))Temp_Word;
        func_p();
      }
      else
      {
        USART_Send_Byte(Back_NACK);
      }
    }
    else
    {
      USART_Send_Byte(Back_NACK);
    }
  }
  else
  {
    USART_Send_Byte(Back_NACK);
  }
}

void ProbeUsart_Cmd_WM(void)
{
	Temp_Byte = ~USART_Receive_Byte();
	if(Temp_Byte == Cmd_WM)
	{
		Temp_Word = *(__IO uint32_t*)(0x00000FC0);
		if((Temp_Word & 0x00F0FF00) == 0x00F0FF00)	//Read Protect
		{
			Temp_Byte_1 = 0x00;
			USART_Send_Byte(Back_ACK);
			for(Temp_Byte = 0; Temp_Byte < 5; Temp_Byte++)	//Receive Address
			{
				Temp_Array_Byte[Temp_Byte] = USART_Receive_Byte();
				Temp_Byte_1 = Temp_Byte_1^Temp_Array_Byte[Temp_Byte];		//XOR CheckSum
			}
			if(Temp_Byte_1 == 0x00)
			{
				Temp_Word = ((Temp_Array_Byte[0] << 24) | (Temp_Array_Byte[1] << 16) | (Temp_Array_Byte[2] << 8) | Temp_Array_Byte[3]);
				USART_Send_Byte(Back_ACK);
				Temp_Byte_1 = USART_Receive_Byte();
				Temp_Byte_2 = Temp_Byte_1;
				for(Temp_HalfWord = 0; Temp_HalfWord < (Temp_Byte_1 + 2); Temp_HalfWord++)	//Receive Data
				{
					Temp_Array_Byte[Temp_HalfWord] = USART_Receive_Byte();
					Temp_Byte_2 = Temp_Byte_2 ^ Temp_Array_Byte[Temp_HalfWord];		//XOR CheckSum
				}
				if(Temp_Byte_2 == 0x00)
				{
					if(Temp_Word <= (0x00000000 + 32*1024))
					{
						Program_Main_Flash(Temp_Word,(uint32_t *)Temp_Array_Byte,(Temp_Byte_1 + 1)/4);
						USART_Send_Byte(Back_ACK);
					}
					else
					{
						USART_Send_Byte(Back_NACK);
					}
				}
				else
				{
					USART_Send_Byte(Back_NACK);
				}
			}
			else
			{
				USART_Send_Byte(Back_NACK);
			}
		}
		else
		{
			USART_Send_Byte(Back_NACK);
		}
	}
	else
	{
		USART_Send_Byte(Back_NACK);
	}
}

void Program_Main_Flash(uint32_t addr, uint32_t* data, uint32_t size)
{
  uint32_t i = 0;
  
  CMU->WPREG = CMU_WPREG_UnProtected;
  CMU->FLASHLOCK = CMU_FLASHLOCK_UnLocked;
  
  for(i = 0; i < size; i++)
  {
    if((addr + i*4)%1024 == 0)
    {
      CMU->FLASHCON = CMU_FLASHCON_FOP_PAGEERASE;
      M32(addr + i*4) = 0xFF;
      while(CMU->FLASHCON & CMU_FLASHCON_BUSY);
    }
    CMU->FLASHCON = CMU_FLASHCON_FOP_WRITE;
    M32(addr + i*4) = *(data+i);
    while(CMU->FLASHCON & CMU_FLASHCON_BUSY);
  }
  
  CMU->FLASHLOCK = CMU_FLASHLOCK_Locked;
  CMU->WPREG = CMU_WPREG_Protected;
}

void USART1_Init(uint32_t srel)
{
  GPIO_InitTypeDef GPIO_InitStruct;
  
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF = AF_FUNCTION2;
  GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_InitStruct.AF = AF_FUNCTION3;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);
  
  UART_InitTypeDef UART_InitStruct;
  
  UART_InitStruct.Baudrate = 115200;
  UART_InitStruct.LenSel = UART_UARTCON_LENSEL_8Bit;
  UART_InitStruct.ParityEN = UART_UARTCON_PARITY_Enable;
  UART_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_EVEN;
  UART_InitStruct.StopSel = UART_UARTCON_STOPSEL_1Bit;
  UART_Init(UART1, &UART_InitStruct);
  UART1->SREL = srel;
  
  UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
}

void USART_Send_Byte(uint8_t val)
{
	UART_Send_Data(UART1, val);
  while( UART_Get_Flag(UART1, UART_UARTSTA_TXIF)==0 ){WDT_FeedDog();}
  UART_Clear_Flag( UART1, UART_UARTSTA_TXIF );
}

uint8_t USART_Receive_Byte(void)
{
	while( UART_Get_Flag(UART1, UART_UARTSTA_RXIF)==0 ){WDT_FeedDog();}
  UART_Clear_Flag( UART1, UART_UARTSTA_RXIF );
	return UART1->SBUF;
}
