/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                          rx32s10xx
*                      Library Function
*                   All Rights Reserved
*
*
* Project      : rx32s10xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s10xx
*********************************************************************************************************
*/

#define __MAIN_C

#include "main.h"
#include "stdlib.h"

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Variables for ADC conversion data */
__IO uint32_t aADCxConvertedData[ADC_CONVERTED_DATA_BUFFER_SIZE];

void UART1_PIN_initial(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    // IO PD8_FUNC2 TX1
    GPIO_InitStruct.Pin  = GPIO_PIN_8;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.AF   = AF_FUNCTION2;
	  GPIO_InitStruct.Pull = GPIO_PULL_UP;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
//    // IO PA1_FUNC3 TX1, PA0_FUNC2 RX1
//    GPIO_InitStruct.Pin  = GPIO_PIN_1;
//    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//    GPIO_InitStruct.AF   = AF_FUNCTION3;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
//	
//    GPIO_InitStruct.AF   = AF_FUNCTION2;
//    GPIO_InitStruct.Pin = GPIO_PIN_0;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
}

void UART1_Initial(void)
{
	UART1_PIN_initial(); 
	UART_InitTypeDef UART1_InitStruct = {0};
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
}

/*
*********************************************************************************************************
*    MAIN
*
*********************************************************************************************************
*/
/* Exported constants --------------------------------------------------------*/
uint32_t ErrorFlag;
uint32_t ErrorBit;
uint32_t covert_time1;
uint32_t covert_time2;
uint32_t covert_number = 0;
uint32_t covert_number1 = 0;
uint32_t RegAddress;
int i;
char *RegName;
/* Exported functions ------------------------------------------------------- */

void clr_sram(uint32_t Start, uint32_t End)
{
    for (i = Start; i < End;)
    {
        M32(i) = 0x00000000;
        i = i + 4;
    }
}

void set_sram(uint32_t Start, uint32_t End)
{
    for (i = Start; i < End;)
    {
        M32(i) = i;
        //		printf("\r\n address %x is %x\r\n",i,M32(i));
        i = i + 4;
    }
}

void set_sram_value(uint32_t Start, uint32_t End, uint32_t value)
{
    for (i = Start; i < End;)
    {
        M32(i) = i + value;
        //		printf("\r\n address %x is %x\r\n",i,M32(i));
        i = i + 4;
    }
}


void ADC_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_SADCEN);
	//PC0-AD3 PC1-AD2 PC3-AD1 PC4-AD0 
  GPIO_InitStruct.Pin  = GPIO_PIN_4;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF   = AF_FUNCTION1;
	GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
	
	//PB5-AD6 PB7-AD5 PB8-AD4
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
	
	//PA4-AD10 PA5-AD9 PA6-AD8 PA7-AD7
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_4;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
	
  CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_PGAEN);	
  PGA_Enable(PGA_CR_PGA0EN);
  PGA_Set_GAIN(PGA_CR_PGA0GAIN,PGA_CR_PGA0GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
  PGA_Enable(PGA_CR_PGA1EN);
  PGA_Set_GAIN(PGA_CR_PGA1GAIN,PGA_CR_PGA1GAIN_4X);
}

void Test_DIV(int32_t testcnt)
{
    unsigned long int unsign_dd, unsign_di, unsign_dq, unsign_dr;
    signed long int sign_dd, sign_di, sign_dq, sign_dr;

    for (i = 0; i < testcnt; i++)
    {
        if (i < testcnt / 2)
        {

            unsign_dd = rand() + rand();
            unsign_di = rand() + rand();

            //	  	ME_Write_DIV_DD(DIV,unsign_dd);
            //		  ME_Write_DIV_DI(DIV,unsign_di);
            //		  ME_CLEAR_RDY_DIV(DIV);
            //	    //start unsign DIV
            //			ME_SET_DIVUSN(DIV);
            //      ME_STR_DIV(DIV);
            //      while (ME_IsRDY_DIV(DIV) == 0) {
            //      }
            //		  ME_CLEAR_RDY_DIV(DIV);
            //		  unsign_dq = ME_Read_DIV_DQ(DIV);
            //		  unsign_dr = ME_Read_DIV_DR(DIV);

            unsign_dq = ME_UDIV_DQ(unsign_dd, unsign_di);
            unsign_dr = ME_UDIV_DR(unsign_dd, unsign_di);

            printf("Test%d:", i);
            printf("UNSIGN_DD= %x  ", unsign_dd);
            printf("UNSIGN_DI= %x  ", unsign_di);
            printf("UNSIGN_DQ= %x  ", unsign_dq);
            printf("UNSIGN_DR= %x  ", unsign_dr);
            printf("\r\n");
        }
        else
        {
            sign_dd = rand() + rand();
            sign_di = rand() + rand();

            //	  	ME_Write_DIV_DD(DIV,sign_dd);
            //		  ME_Write_DIV_DI(DIV,sign_di);
            //		  ME_CLEAR_RDY_DIV(DIV);
            //	    //start sign DIV
            //			ME_SET_DIVSN(DIV);
            //      ME_STR_DIV(DIV);
            //      while (ME_IsRDY_DIV(DIV) == 0) {
            //      }
            //		  ME_CLEAR_RDY_DIV(DIV);
            //		  sign_dq = ME_Read_DIV_DQ(DIV);
            //		  sign_dr = ME_Read_DIV_DR(DIV);

            sign_dq = ME_SDIV_DQ(sign_dd, sign_di);
            sign_dr = ME_SDIV_DR(sign_dd, sign_di);

            printf("Test%d:", i);
            printf("SIGN_DD= %x  ", sign_dd);
            printf("SIGN_DI= %x  ", sign_di);
            printf("SIGN_DQ= %x  ", sign_dq);
            printf("SIGN_DR= %x  ", sign_dr);
            printf("\r\n");
        }
    }
}

int main(void)
{

    CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_MEEN);
    UART1_Initial();

    Test_DIV(10);
    while (1)
    {
        WDT_FeedDog();
    }
}
