/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define __MAIN_C
#include "main.h"
/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

uint32_t ErrorFlag;
uint32_t ErrorBit;
uint32_t covert_number;
uint32_t covert_time1;
uint32_t covert_time2;
uint32_t RegAddress;
char    *RegName;
  
uint8_t RNum = 0;
uint8_t TNum = 0;
#define DATA_NUMBER             (16)
uint8_t RBuffer[DATA_NUMBER] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
uint8_t TBuffer[DATA_NUMBER] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x01};

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/

void Delay(uint32_t nDelay)
{
  uint32_t i;
  while(nDelay--)
  {
    for(i=0;i<1000;i++);
  }
}


void UART1_PIN_initial(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    // IO PD8_FUNC2 TX1
    GPIO_InitStruct.Pin  = GPIO_PIN_8;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.AF   = AF_FUNCTION2;
	  GPIO_InitStruct.Pull = GPIO_PULL_UP;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
//    // IO PA1_FUNC3 TX1, PA0_FUNC2 RX1
//    GPIO_InitStruct.Pin  = GPIO_PIN_1;
//    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//    GPIO_InitStruct.AF   = AF_FUNCTION3;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
//	
//    GPIO_InitStruct.AF   = AF_FUNCTION2;
//    GPIO_InitStruct.Pin = GPIO_PIN_0;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
}

void CLKOUT_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
	//PB5_AF4 CLKOUT 
  GPIO_InitStruct.Pin  = GPIO_PIN_5;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF   = AF_FUNCTION4;
  GPIO_Init(GPIOB, &GPIO_InitStruct);
  CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_CLKOUTEN);	
}

void Key_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
	//PD0_GPIO KEY 
  GPIO_InitStruct.Pin  = KEY_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULL_UP;
  GPIO_Init(KEY_POR, &GPIO_InitStruct);	
}

void Key_INPUT(void)
{
	//PD0_GPIO KEY 
  while(GPIO_Get_IDR(KEY_POR,KEY_PIN)==1){	WDT_FeedDog();}
  Delay(1);
  while(GPIO_Get_IDR(KEY_POR,KEY_PIN)==1){WDT_FeedDog();}
  Delay(1);
  while(GPIO_Get_IDR(KEY_POR,KEY_PIN)==0){WDT_FeedDog();}
  Delay(1);
  while(GPIO_Get_IDR(KEY_POR,KEY_PIN)==0){WDT_FeedDog();}
  Delay(1);
}


void UART1_initial(uint32_t Baud)
{		
	UART1_PIN_initial(); 
	UART_InitTypeDef UART1_InitStruct = {0};
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
//  UART_Enable_IT(UART1,UART_UARTCON_RXIE);
//  NVIC_EnableIRQ(UART1_IRQn);
}

void UART_SendTxBuf(UART_TypeDef* UARTx,uint8_t* wbuf,uint8_t len)
{
	uint8_t i;
	
	for(i=0;i<len;i++)
	{
		Delay(100);
		UART_Send_Data(UARTx, *(wbuf + i) ); 
		while(0 == (UARTx->UARTSTA & 0x01) );
		UARTx->UARTSTA &= ~( (uint32_t)0x01);
	}
}

void clkout_test(uint32_t syssel,uint32_t sysdiv,uint32_t outsel,uint32_t outdiv)
{
  CMU_Set_SYSCLK(syssel);
  CMU_Set_SYSCLKDIV(sysdiv);
  CMU_Set_CLKOUTSEL(outsel);
  CMU_Set_CLKOUTDIV(outdiv);
}

int main(void)
{		
  int i=0;
	UART1_initial(115200);
  
  CMU_Enable_CLKCTRL0(CMU_CLKCTRL0_HRCEN);
  
  printf("\r\n start\r\n"); 
 
  PMU_Set_VCCLVL(PMU_VCCLVL_4_2_v);
  PMU_Enable_VCCIT();
	NVIC_EnableIRQ(PMU_IRQn);
  
  while(1){
     i =i+1;
     printf("\r\n %d VFF_FLAG %x",i,PMU->PMUSTA);
     printf("\r\n %d VFF_IF  %x",i,PMU->PMUIF);
     Delay(2000);
	
	   WDT_FeedDog();
  }

}
