/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_it.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/#include "main.h"
#include "rx32s11xx_it.h"

/*
*********************************************************************************************************
*                                           Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                           Global Function declaration
*********************************************************************************************************
*/
extern uint8_t rxbuf[256];
extern uint8_t rxlen;


/*
*********************************************************************************************************
*                                        NMI INTERRUPT HANDLER #16-14
*
*********************************************************************************************************
*/
void NMI_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        HARDFAULT INTERRUPT HANDLER #16-13
*
*********************************************************************************************************
*/
void HardFault_Handler(void)
{
    /* Go to infinite loop when Hard Fault exception occurs */
    while (1)
    {

    }
}

/*
*********************************************************************************************************
*                                        SVC INTERRUPT HANDLER #16-5
*
*********************************************************************************************************
*/
void SVC_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        PENDSV INTERRUPT HANDLER #16-2
*
*********************************************************************************************************
*/
void PendSV_Handler(void)
{

}

/*
*********************************************************************************************************
*                                        SYSTICK INTERRUPT HANDLER #16-1
*
*********************************************************************************************************
*/
void SysTick_Handler(void)
{
	
}

/*
*********************************************************************************************************
*                                        PMU INTERRUPT HANDLER #16+0
*
*********************************************************************************************************
*/

void PMU_IRQHandler()
{
    if(PMU_Get_FlagVCC() == 1)                   /*!rising*/
    {	
      printf("PMUIF \r\n");
      printf("\r\n VFF_FLAG %x",PMU->PMUSTA);
//      PMU_Disable_VCCIT();
      PMU_Clear_FlagVCC();		
	    WDT_FeedDog();
    }
}
/*
*********************************************************************************************************
*                                   EXTI0 INTERRUPT HANDLER  #16+2
*
*********************************************************************************************************
*/

void EXTI0_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_0) == 1)                   /*!rising*/
    {	
      printf("EXTI_0 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_0);		
    }
    if(EXTI_Get_FallingFlag(EXTI_0) == 1)                  /*!<falling*/
    {	
      printf("EXTI_0 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_0);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI1 INTERRUPT HANDLER  #16+3
*
*********************************************************************************************************
*/

void EXTI1_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_1) == 1)                   /*!rising*/
    {	
      printf("EXTI_1 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_1);		
    }
    if(EXTI_Get_FallingFlag(EXTI_1) == 1)                  /*!<falling*/
    {	
      printf("EXTI_1 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_1);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI2 INTERRUPT HANDLER  #16+4
*
*********************************************************************************************************
*/

void EXTI2_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_2) == 1)                   /*!rising*/
    {	
      printf("EXTI_2 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_2);		
    }
    if(EXTI_Get_FallingFlag(EXTI_2) == 1)                  /*!<falling*/
    {	
      printf("EXTI_2 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_2);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI3 INTERRUPT HANDLER  #16+5
*
*********************************************************************************************************
*/

void EXTI3_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_3) == 1)                   /*!rising*/
    {	
      printf("EXTI_3 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_3);		
    }
    if(EXTI_Get_FallingFlag(EXTI_3) == 1)                  /*!<falling*/
    {	
      printf("EXTI_3 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_3);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI4 INTERRUPT HANDLER  #16+6
*
*********************************************************************************************************
*/

void EXTI4_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_4) == 1)                   /*!rising*/
    {	
      printf("EXTI_4 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_4);		
    }
    if(EXTI_Get_FallingFlag(EXTI_4) == 1)                  /*!<falling*/
    {	
      printf("EXTI_4 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_4);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI5 INTERRUPT HANDLER  #16+7
*
*********************************************************************************************************
*/

void EXTI5_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_5) == 1)                   /*!rising*/
    {	
      printf("EXTI_5 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_5);		
    }
    if(EXTI_Get_FallingFlag(EXTI_5) == 1)                  /*!<falling*/
    {	
      printf("EXTI_5 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_5);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI6 INTERRUPT HANDLER  #16+8
*
*********************************************************************************************************
*/

void EXTI6_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_6) == 1)                   /*!rising*/
    {	
      printf("EXTI_6 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_6);		
    }
    if(EXTI_Get_FallingFlag(EXTI_6) == 1)                  /*!<falling*/
    {	
      printf("EXTI_6 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_6);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI7 INTERRUPT HANDLER  #16+8
*
*********************************************************************************************************
*/

void EXTI7_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_7) == 1)                   /*!rising*/
    {	
      printf("EXTI_7 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_7);		
    }
    if(EXTI_Get_FallingFlag(EXTI_7) == 1)                  /*!<falling*/
    {	
      printf("EXTI_7 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_7);		
    }
}

/*
*********************************************************************************************************
*                                   EXTI6 INTERRUPT HANDLER  #16+8
*
*********************************************************************************************************
*/

void EXTI8_IRQHandler()
{
    if(EXTI_Get_RisingFlag(EXTI_8) == 1)                   /*!rising*/
    {	
      printf("EXTI_8 rising \r\n");
      EXTI_Clear_RisingFlag(EXTI_8);		
    }
    if(EXTI_Get_FallingFlag(EXTI_8) == 1)                  /*!<falling*/
    {	
      printf("EXTI_8 falling \r\n");
      EXTI_Clear_FallingFlag(EXTI_8);		
    }
}

/*
*********************************************************************************************************
*                                   UART0 INTERRUPT HANDLER  #16+9
*
*********************************************************************************************************
*/

void UART0_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   UART1 INTERRUPT HANDLER  #16+10
*
*********************************************************************************************************
*/

void UART1_IRQHandler()
{
	if(UART_Get_Flag(UART1,UART_UARTSTA_RXIF)==1)
	{
      printf("RXIF \r\n");
			UART_Clear_Flag(UART1,UART_UARTSTA_RXIF); 
	}
}

/*
*********************************************************************************************************
*                                   TMR0 INTERRUPT HANDLER  #16+15
*
*********************************************************************************************************
*/

void TMR0_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   TMR1 INTERRUPT HANDLER  #16+16
*
*********************************************************************************************************
*/

void TMR1_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                   TMR2 INTERRUPT HANDLER  #16+17
*
*********************************************************************************************************
*/

void TMR2_IRQHandler()
{
}

/*
*********************************************************************************************************
*                                   TMR3 INTERRUPT HANDLER  #16+18
*
*********************************************************************************************************
*/

void TMR3_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                    RTC INTERRUPT HANDLER  #16+20
*
*********************************************************************************************************
*/

void RTC_IRQHandler()
{

}

/*
*********************************************************************************************************
*                                    I2C INTERRUPT HANDLER  #16+21
*
*********************************************************************************************************
*/

void I2C_IRQHandler()
{

}


/*
*********************************************************************************************************
*                                 DMA INTERRUPT HANDLER  #16+31
*
*********************************************************************************************************
*/
void DMA_IRQHandler(void)
{
}





