/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                          Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define __MAIN_C

#include "main.h"

/*
*********************************************************************************************************
*                                    Local macro/Structure
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                         Local variable
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                       Local Function declaration
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                              MAIN
*
*********************************************************************************************************
*/
void UART1_Initial(void)
{
  UART_InitTypeDef UART1_InitStruct = {0};
  
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
  
  UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
}

void UART1_PIN_Initial(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  
  GPIO_InitStruct.Pin   = GPIO_PIN_8;//TX1
  GPIO_InitStruct.Mode  = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF    = AF_FUNCTION2;
  GPIO_Init(GPIOD, &GPIO_InitStruct);
}

void delay_ms(uint16_t x) //delay 1ms
{
  uint16_t i, j;
  for (i = 0; i < x; i++)
  {
    for (j = 0; j < (3700); j++);
  }
}

int main(void)
{
	UART1_PIN_Initial();
  UART1_Initial();
  
  RTC_Set_TMR2(RTC,8);
  RTC_Enable_TMR2EN(RTC);
  RTC_Enable_IT(RTC,RTC_RTCIE_RTC2IE);
	NVIC_EnableIRQ(RTC_IRQn);

	while (1)
	{
		WDT_FeedDog();
	}
}

