/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#include "main.h"

/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/
void CLKCTRL_Initial(void)
{
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_TIM8EN);
}

int main(void)
{	
  CLKCTRL_Initial();

  GPIO_InitTypeDef GPIO_Initstruct = {0};
  TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct = {0};

  GPIO_Initstruct.Pin  = GPIO_PIN_4;
  GPIO_Initstruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_Init(GPIOC, &GPIO_Initstruct);

  TIM_TimeBaseInitStruct.CounterMode = TIM_COUNTERMODE_DOWN;
  TIM_TimeBaseInitStruct.Period      = 1000;
  TIM_TimeBaseInitStruct.Prescaler   = 10;
  TIM_TimeBaseInit(TIM8, &TIM_TimeBaseInitStruct);

  /* Configure the NVIC to handle TIM update interrupt */
  TIM_Enable_IT(TIM8,TIM_DIER_UIE); //Update interrupt enable
  NVIC_SetPriority(TIM8_IRQn, 0);
  NVIC_EnableIRQ(TIM8_IRQn);

  TIM_Enable_CEN(TIM8); //Counter enable

  WDT_FeedDog();
  
  while (1)
  {
  }
}






