/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#include "main.h"

/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/
TIM_ICUserValueTypeDef TIM_ICUserValueStructure = {0, 0, 0, 0};

uint32_t ErrorFlag;
uint32_t ErrorBit;
uint32_t covert_number;
uint32_t RegAddress;
char    *RegName;
  
uint8_t RNum = 0;
uint8_t TNum = 0;
#define DATA_NUMBER             (16)
uint8_t RBuffer[DATA_NUMBER] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
uint8_t TBuffer[DATA_NUMBER] = {0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x01};

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/
void Delay_ms(uint32_t nDelay)
{
  uint32_t i;
  while(nDelay--)
  {
    for(i=0;i<2138;i++);
  }
}


void UART1_PIN_initial(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    // IO PD8_FUNC2 TX1
    GPIO_InitStruct.Pin  = GPIO_PIN_8;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.AF   = AF_FUNCTION2;
	  GPIO_InitStruct.Pull = GPIO_PULL_UP;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
//    // IO PA1_FUNC3 TX1, PA0_FUNC2 RX1
//    GPIO_InitStruct.Pin  = GPIO_PIN_1;
//    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//    GPIO_InitStruct.AF   = AF_FUNCTION3;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
//	
//    GPIO_InitStruct.AF   = AF_FUNCTION2;
//    GPIO_InitStruct.Pin = GPIO_PIN_0;
//    GPIO_Init(GPIOA, &GPIO_InitStruct);
}

void UART1_initial(uint32_t Baud)
{		
	UART1_PIN_initial(); 
	UART_InitTypeDef UART1_InitStruct = {0};
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);

  UART1_InitStruct.Baudrate  = 115200;
  UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
  UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
  UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
  UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
  UART_Init(UART1, &UART1_InitStruct);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN);
  
  UART_Disable_IT(UART1, UART_UARTCON_TXIE | UART_UARTCON_RXIE | UART_UARTCON_PRDIE);
  NVIC_DisableIRQ(UART1_IRQn);
}

void UART_SendTxBuf(UART_TypeDef* UARTx,uint8_t* wbuf,uint8_t len)
{
	uint8_t i;
	
	for(i=0;i<len;i++)
	{
		Delay_ms(1);
		UART_Send_Data(UARTx, *(wbuf + i) ); 
		while(0 == (UARTx->UARTSTA & 0x01) );
		UARTx->UARTSTA &= ~( (uint32_t)0x01);
	}
}

void CLKCTRL_Initial(void)
{
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_TIM8EN);
}

/**
  * @brief  TIM8_IC_Init
  * @param  arr:(0-65535)
  * @param  psc:(0-65535)
  AF1:
  PD3:TIM8_CH1
  PD2:TIM8_CH1N
  PD1:TIM8_CH2
  PD0:TIM8_CH2N
  PC10:TIM8_CH3
  PC9:TIM8_CH3N
  AF2:
  PC6:TIM8_CH4
  * @retval None
  */
void TIM8_IC_Init(uint16_t arr, uint16_t psc)
{
  /*-----------------GPIO------------------*/
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  GPIO_InitStruct.Pin  = GPIO_PIN_6;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.AF   = AF_FUNCTION2;
  GPIO_InitStruct.Pull = GPIO_FLOATING;
  GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*---------------------TIM8---------------------*/
  TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct = {0};
  TIM_ICInitTypeDef TIM_ICInitStruct = {0};

  TIM_TimeBaseInitStruct.CounterMode       = TIM_COUNTERMODE_UP;
  TIM_TimeBaseInitStruct.RepetitionCounter = 0;
  TIM_TimeBaseInitStruct.Period        = arr;
  TIM_TimeBaseInitStruct.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  TIM_TimeBaseInitStruct.Prescaler     = psc;
  TIM_TimeBaseInit(TIM8, &TIM_TimeBaseInitStruct);

  TIM_Enable_ARRPreload(TIM8); //Auto-reload preload enable

  /*---------------------------SET CH4-----------------------------*/
  TIM_ICInitStruct.Channel     = TIM_CHANNEL_CH4;
  TIM_ICInitStruct.ICSelection = TIM_ICSelection_DirectTI;
  TIM_ICInitStruct.ICFilter    = TIM_IC_FILTER_FDIV1;
  TIM_ICInitStruct.ICPrescaler = TIM_ICPSC_DIV1;
  TIM_ICInitStruct.ICPolarity  = TIM_ICPolarity_Rising;
  TIM_ICInit(TIM8, &TIM_ICInitStruct);

  TIM_Enable_CC_Channel(TIM8, TIM_CHANNEL_CH4); //CC4 INPUT ENABLE

  /*-----------------------CC Interrupt enable---------------------*/
  TIM_Enable_IT(TIM8,TIM_DIER_CC4IE); //CC4 IT ENABLE

  TIM_Clear_Flag(TIM8,TIM_SR_CC4IF);

  TIM_Enable_IT(TIM8,TIM_DIER_UIE); //Update interrupt enable
  NVIC_SetPriority(TIM8_IRQn,0);
  NVIC_EnableIRQ(TIM8_IRQn);

  TIM_Enable_CEN(TIM8); //counter enable
}


int main(void)
{	
	CLKCTRL_Initial();
	UART1_initial(115200);
	printf("-------IC Test-------\r\n");
  
	TIM8_IC_Init(99,10);
  while (1)
  {
  WDT_FeedDog();
  }
}






