/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define  __MAIN_C

#include "main.h"

/*
*********************************************************************************************************
*                                          Local macro/Structure
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                            Local variable
*********************************************************************************************************
*/
uint8_t rxbuf[256];
uint8_t rxlen;

/*
*********************************************************************************************************
*                                           Local Function declaration
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                              MAIN
*
*********************************************************************************************************
*/
/*
*********************************************************************************************************
* TMR PIN Initial
*
* AE1
* TMR0: GPIOC_6
* TMR1: GPIOA_1
* TMR2: GPIOD_8
* TMR3: GPIOD_7
*
*********************************************************************************************************
*/

void TMR_PIN_Initial(void)
{
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
	GPIO_InitStruct.AF   = AF_FUNCTION1;
	GPIO_InitStruct.Pin  = GPIO_PIN_6;
	GPIO_Init(GPIOC, &GPIO_InitStruct);

	GPIO_InitStruct.AF   = AF_FUNCTION2;
	GPIO_InitStruct.Pin = GPIO_PIN_1;
	GPIO_Init(GPIOA, &GPIO_InitStruct);

	GPIO_InitStruct.AF  = AF_FUNCTION4;
	GPIO_InitStruct.Pin = GPIO_PIN_8;
	GPIO_Init(GPIOD, &GPIO_InitStruct);

	GPIO_InitStruct.AF  = AF_FUNCTION2;
	GPIO_InitStruct.Pin = GPIO_PIN_7;
	GPIO_Init(GPIOD, &GPIO_InitStruct);
}

void TMR0_initial(void)
{
	TMR_PIN_Initial();
	CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_TMR0EN);

	TMR_InitTypeDef TMR0_InitStruct = {0};
	TMR0_InitStruct.Mode = TMR_TMRCON_MODE_PERIOD;
	TMR0_InitStruct.TMRDIV = 0xFF;
	TMR0_InitStruct.TMRPRD = 0xFF;
	TMR_Init(TMR0, &TMR0_InitStruct);

	TMR_Enable_CNT(TMR0);
	
  NVIC_EnableIRQ(TMR0_IRQn);
	TMR_Enable_IT(TMR0, TMR_TMRIE_PRDIE);
}

int main(void)
{
	//PC4 toggle for DEBUG
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	GPIO_InitStruct.Pin  = GPIO_PIN_4;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	
	TMR0_initial();
	
	/*  Infinite loop  */
	while (1)
	{
		WDT_FeedDog();
	}
}

