/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : rx32s11xx_it.h
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#ifndef __rx32s11xx_IT_H__
#define __rx32s11xx_IT_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s11xx.h"

/*
*********************************************************************************************************
*                                           Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                           Global Function declaration
*********************************************************************************************************
*/
void NMI_Handler(void);                          /*!< #16-14              */
void HardFault_Handler(void);                    /*!< #16-13              */
void SVC_Handler(void);                          /*!< #16-5               */
void PendSV_Handler(void);                       /*!< #16-2               */
void SysTick_Handler(void);                      /*!< #16-1               */
void PMU_IRQHandler(void);                       /*!< #16+0               */
void EXTI0_IRQHandler(void);                     /*!< #16+2               */
void EXTI1_IRQHandler(void);                     /*!< #16+3               */
void EXTI2_IRQHandler(void);                     /*!< #16+4               */
void EXTI3_IRQHandler(void);                     /*!< #16+5               */
void EXTI4_IRQHandler(void);                     /*!< #16+6               */
void EXTI5_IRQHandler(void);                     /*!< #16+7               */
void EXTI6_IRQHandler(void);                     /*!< #16+8               */
void UART0_IRQHandler(void);                     /*!< #16+9               */
void UART1_IRQHandler(void);                     /*!< #16+10              */
void TMR0_IRQHandler(void);                      /*!< #16+15              */
void TMR1_IRQHandler(void);                      /*!< #16+16              */
void TMR2_IRQHandler(void);                      /*!< #16+17              */
void TMR3_IRQHandler(void);                      /*!< #16+18              */
void RTC_IRQHandler(void);                       /*!< #16+20              */
void I2C_IRQHandler(void);                       /*!< #16+21              */
void EXTI7_IRQHandler(void);                     /*!< #16+28              */
void EXTI8_IRQHandler(void);                     /*!< #16+29              */
void DMA_IRQHandler(void);                       /*!< #16+31              */



#ifdef __cplusplus
}
#endif

#endif
