/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/
/*
*********************************************************************************************************
*                                              rx32s11xx
*                                           Library Function
*                                        All Rights Reserved
*
*
* Project      : rx32s11xx
* File         : main.c
* By           : RX_SD_Team
* Description  : Only rx32s11xx
*********************************************************************************************************
*/

#define __MAIN_C

#include "main.h"
#include "systick.h"
/*
*********************************************************************************************************
*                                         Global macro/Structure
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/
uint8_t RNum = 0;
uint8_t TNum = 0;
#define DATA_NUMBER (16)
uint8_t RBuffer[DATA_NUMBER] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
uint8_t TBuffer[DATA_NUMBER] = {0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88, 0x99, 0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xFF, 0x01};

/*
*********************************************************************************************************
*                                       Global Function declaration
*********************************************************************************************************
*/
void CLK_Init(void)
{
  CMU_Enable_CLKCTRL1(CMU_CLKCTRL1_UART1EN);
}
void UART1_PIN_initial(void)
{
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	// IO PD8-TX1-AF2, PA1-TX1-AF3, PA0-RX1-AF2
	GPIO_InitStruct.Pin  = GPIO_PIN_8;
	GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
	GPIO_InitStruct.AF   = AF_FUNCTION2;
	GPIO_Init(GPIOD, &GPIO_InitStruct);

	GPIO_InitStruct.Pin = GPIO_PIN_0;
	GPIO_Init(GPIOA, &GPIO_InitStruct);
	
//	GPIO_InitStruct.Pin  = GPIO_PIN_1;
//	GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
//	GPIO_InitStruct.AF   = AF_FUNCTION3;
//	GPIO_Init(GPIOA, &GPIO_InitStruct);
}
void UART1_Init(uint32_t Baud)
{
	UART1_PIN_initial();

	UART_InitTypeDef UART1_InitStruct = {0};
	UART1_InitStruct.Baudrate  = Baud;
	UART1_InitStruct.LenSel    = UART_UARTCON_LENSEL_8Bit;
	UART1_InitStruct.StopSel   = UART_UARTCON_STOPSEL_1Bit;
	UART1_InitStruct.Paritysel = UART_UARTCON_PARITYSEL_0;
	UART1_InitStruct.ParityEN  = UART_UARTCON_PARITY_Disable;
	UART_Init(UART1, &UART1_InitStruct);

	UART_Enable_IT(UART1,UART_UARTCON_RXIE);
	NVIC_EnableIRQ(UART1_IRQn);
	
	UART_Enable(UART1,UART_UARTCON_TXEN|UART_UARTCON_RXEN); //|UART_UARTCON_RXEN
}

void ReceptionCallback(UART_TypeDef *UARTx)
{
    RBuffer[RNum++] = UART_Receive_Data(UARTx);
}

uint8_t BufferCmp8(uint8_t *Buffer1, uint8_t *Buffer2, uint8_t BufferLength)
{
	while (BufferLength--)
	{
		if (*Buffer1 != *Buffer2)
		{
				return 1;
		}
		Buffer1++;
		Buffer2++;
	}
	return 0;
}
void Compare_result(void)
{
	/* Check the datas */
	if (BufferCmp8((uint8_t *)RBuffer, (uint8_t *)TBuffer, DATA_NUMBER) == 0)
	{
			/* Expected bytes have been received */
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
	}
	else
	{
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
			GPIO_Toggle_Output(GPIOC, GPIO_PIN_0); //PC0
	}
}

int main(void)
{
	CLK_Init();
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  GPIO_InitStruct.Pin   = GPIO_PIN_0;
  GPIO_InitStruct.Mode  = GPIO_MODE_OUTPUT_PP;
  GPIO_Init(GPIOC, &GPIO_InitStruct);	
	
  UART1_Init(9600);
	
	UART_Send_Buf(UART1, &TBuffer[0], 16);
	Compare_result();

	
  while (1)
  {
    WDT_FeedDog();
  }
}
